import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;

/**
 * Write a description of class Holly_Grenade here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Airstrike extends Weapon
{
    private double velX;
    private double exactX;
    private double exactY;
    private double velY;
    
    private int targetX;
    private int targetY;
    
    public static final int EXPLOSIONS_RADIUS = 100;
    
    private boolean water = false;
    private boolean missile = false;
    private boolean initialised = false;
    
    private Worm worm;
    
    public Airstrike(double velX, double velY) {
        missile = true;
        this.velX = velX;
        this.velY = velY;
        changeImage(new GreenfootImage("Airstrike.png"));
        scaleImage(getImage(), 40);
    }
    
    public Airstrike(Worm worm, int x, int y) {
        this.worm = worm;
        missile = false;
        targetX = x;
        targetY = y;
        getImage().clear();
    }
    
    /**
     * Call the run method to run the game if the game is executed.
     */
    public void act() {
        if (getWorld().getObjects(Break_Menu.class).isEmpty()) {
            run();
        }
    }
    
    public void run() {
        if (!initialised) {
            if (missile) {
                exactX = getX();
                exactY = getY();
            }
            else {
                if (targetY <= 150) {
                    for (int i = 0, startX = targetX - 360; i < 5; i++, startX += 50) {
                        getWorld().addObject(new Airstrike(7.0, -5.0), startX, -50);
                    }
                }
                else if (targetY <= 250) {
                    for (int i = 0, startX = targetX - 420; i < 5; i++, startX += 50) {
                        getWorld().addObject(new Airstrike(7.0, -5.0), startX, -50);
                    }  
                }
                else if (targetY <= 350) {
                    for (int i = 0, startX = targetX - 480; i < 5; i++, startX += 50) {
                        getWorld().addObject(new Airstrike(7.0, -5.0), startX, -50);
                    } 
                }
                else if (targetY <= 450) {
                    for (int i = 0, startX = targetX - 540; i < 5; i++, startX += 50) {
                        getWorld().addObject(new Airstrike(7.0, -5.0), startX, -50);
                    }   
                }
                else if (targetY <= 550) {
                    for (int i = 0, startX = targetX - 600; i < 5; i++, startX += 50) {
                        getWorld().addObject(new Airstrike(7.0, -5.0), startX, -50);
                    }   
                }
                else {
                    for (int i = 0, startX = targetX - 660; i < 5; i++, startX += 50) {
                        getWorld().addObject(new Airstrike(7.0, -5.0), startX, -50);
                    }   
                }
            }
            initialised = true;
        }
        else if (missile) {
            velY -= Worms_Land.GRAVITY/3;
            setExactLocation(exactX + velX, exactY - velY);
            setRotation((int) (Math.toDegrees(Math.atan2(velX, velY)))-90);
            if (((Worms_Land) getWorld()).getMaterialAt((int) (getX() + velX), (int) (getY() - velY)).getMaterial() == 1 || foundEnemyWorm() || foundOilDrum()) {
                explode();
                return;
            }
        }
        if (((Worms_Land) getWorld()).getMaterialAt((int) (getX() + velX), (int) (getY() - velY)).getMaterial() == 3 || foundEnemyWorm() || foundOilDrum()) {
            GreenfootSound water = new GreenfootSound("splash.wav");
            water.setVolume(Settings.effectVolume);
            water.play();
            getWorld().removeObject(this);
        }
    }
    
    public void setExactLocation(double x, double y) {
        exactX = x;
        exactY = y;
        super.setLocation((int) (x + 0.5), (int) (y + 0.5));
    }
    
    private boolean foundEnemyWorm() {
        List<Worm> worms = getWorld().getObjectsAt((int) (getX()+velX), (int) (getY()+velY), Worm.class);
        for (int i = 0; i < worms.size(); i++) {
            if (!worms.get(i).getExecuting()) {
                return true;
            }
        }
        return false;
    }
    
    private boolean foundOilDrum() {
        return getWorld().getObjectsAt((int) (getX() + velX), (int) (getY() + velY), Oil_Drum.class).size() != 0;
    }
    
    private void explode() {
        List<Worm> worms = getObjectsInRange(EXPLOSIONS_RADIUS, Worm.class);
        List<Grave_Stone> graves = getObjectsInRange(EXPLOSIONS_RADIUS, Grave_Stone.class);
        List<Mine> mines = getObjectsInRange(EXPLOSIONS_RADIUS, Mine.class);
        List<Oil_Drum> oilDrums = getObjectsInRange(EXPLOSIONS_RADIUS, Oil_Drum.class);
        int damage;
        for (int i = 0; i < worms.size(); i++) {
            damage = (int) (-0.20*getObjectsDistance(this, worms.get(i))+20.0);
            if (damage > 15) {
                damage = 15;
            }
            kill(worms.get(i), damage);
        }
        for (int i = 0; i < worms.size(); i++) {
            blowUp(Math.toRadians(directionToTurnTo(worms.get(i).getX(), worms.get(i).getY())), (((-0.3/EXPLOSIONS_RADIUS)*getObjectsDistance(worms.get(i), this))+0.3), worms.get(i));
        }
        for (int i = 0; i < graves.size(); i++) {
            blowUp(Math.toRadians(directionToTurnTo(graves.get(i).getX(), graves.get(i).getY())), (((-0.15/EXPLOSIONS_RADIUS)*getObjectsDistance(graves.get(i), this))+0.15), graves.get(i));
        }
        for (int i = 0; i < mines.size(); i++) {
            blowUp(Math.toRadians(directionToTurnTo(mines.get(i).getX(), mines.get(i).getY())), (((-0.1/EXPLOSIONS_RADIUS)*getObjectsDistance(mines.get(i), this))+0.2), mines.get(i));
        }
        for (int i = 0; i < oilDrums.size(); i++) {
            oilDrums.get(i).explode();
        }
        destroyWorld(getX(), getY(), (int) (EXPLOSIONS_RADIUS*0.4));
        getWorld().addObject(new Explosion(2), getX(), getY());
        getWorld().removeObject(this);
    }
}
