import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
/**
 * Write a description of class Armaggeddon here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Armageddon extends Weapon
{
    private int counter = 0;
    private int cometsAdded = 0;
    private int angle;
    
    public static final int EXPLOSIONS_RADIUS = 150;
    
    private boolean comet = false;
    
    private Worm worm;
    
    public Armageddon(Worm worm) {
        this.worm = worm;
        getImage().clear();
    }
    
    public Armageddon(int angle) {
        this.angle = angle;
        comet = true;
        turn(angle);
        //changeImage(new GreenfootImage("Airstrike.png"));
    }
    
    public void act() {
        if (getWorld().getObjects(Break_Menu.class).isEmpty()) {
            run();
        }
    }  
    
    public void run() {
        if (comet) {
            move(angle, 15);
            double[] nextPosition = move(getX(), getY(), angle, 15);
            if (((Worms_Land) getWorld()).getMaterialAt((int) nextPosition[0], (int) nextPosition[1]).getMaterial() == 1 || foundEnemyWorm() || foundOilDrum()) {
                 explode();
                 return;
            }
            else if (((Worms_Land) getWorld()).getMaterialAt((int) nextPosition[0], (int) nextPosition[1]).getMaterial() == 3) {
                GreenfootSound water = new GreenfootSound("splash.wav");
                water.play();
                getWorld().removeObject(this);
                return;
            }
        }
        else {
            if (counter > 0) {
                counter--;
            }
            else {
                addNewComet();
                counter = 20 + Greenfoot.getRandomNumber(30);
            }
            if (cometsAdded >= 15) {
                getWorld().removeObject(this);
            }
        }
    }
    
    private void addNewComet() {
        int angle = 45 + Greenfoot.getRandomNumber(90);
        int x = Greenfoot.getRandomNumber(600) + (int) ((6.66 * angle) - 300);
        getWorld().addObject(new Armageddon(angle), x, -50);
        cometsAdded++;
    }
    
    private boolean foundEnemyWorm() {
        List<Worm> worms = getWorld().getObjectsAt(getX(), getY(), Worm.class);
        for (int i = 0; i < worms.size(); i++) {
            if (!worms.get(i).getExecuting()) {
                return true;
            }
        }
        return false;
    }
    
    private boolean foundOilDrum() {
        return getWorld().getObjectsAt(getX(), getY(), Oil_Drum.class).size() != 0;
    }
    
    private void explode() {
        List<Worm> worms = getObjectsInRange(EXPLOSIONS_RADIUS, Worm.class);
        List<Grave_Stone> graves = getObjectsInRange(EXPLOSIONS_RADIUS, Grave_Stone.class);
        List<Mine> mines = getObjectsInRange(EXPLOSIONS_RADIUS, Mine.class);
        List<Oil_Drum> oilDrums = getObjectsInRange(EXPLOSIONS_RADIUS, Oil_Drum.class);
        int damage;
        for (int i = 0; i < worms.size(); i++) {
            damage = (int) (-0.375*getObjectsDistance(this, worms.get(i))+56.25);
            if (damage > 45) {
                damage = 45;
            }
            kill(worms.get(i), damage);
        }
        for (int i = 0; i < worms.size(); i++) {
            blowUp(Math.toRadians(directionToTurnTo(worms.get(i).getX(), worms.get(i).getY())), (((-0.5/EXPLOSIONS_RADIUS)*getObjectsDistance(worms.get(i), this))+0.5), worms.get(i));
        }
        for (int i = 0; i < graves.size(); i++) {
            blowUp(Math.toRadians(directionToTurnTo(graves.get(i).getX(), graves.get(i).getY())), (((-0.3/EXPLOSIONS_RADIUS)*getObjectsDistance(graves.get(i), this))+0.4), graves.get(i));
        }
        for (int i = 0; i < mines.size(); i++) {
            blowUp(Math.toRadians(directionToTurnTo(mines.get(i).getX(), mines.get(i).getY())), (((-0.2/EXPLOSIONS_RADIUS)*getObjectsDistance(mines.get(i), this))+0.2), mines.get(i));
        }
        for (int i = 0; i < oilDrums.size(); i++) {
            oilDrums.get(i).explode();
        }
        destroyWorld(getX(), getY(), (int) (EXPLOSIONS_RADIUS*0.4));
        getWorld().addObject(new Explosion(2), getX(), getY());
        getWorld().removeObject(this);
    }
    
    public boolean getComet() {
        return comet;
    }
}
