import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;

/**
 * Write a description of class Baseball_Bat here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Baseball_Bat extends Weapon
{
    private Worm worm;
    
    private final int hittingRadius = 50;
    
    private int hittingCounter = 0;
    
    private boolean imageLeft = false;
    private boolean hit = false;
    
    public Baseball_Bat(Worm worm) {
        this.worm = worm;
        scaleImage(getImage(), 50);
    }
    
    /**
     * Call the run method to run the game if the game is executed.
     */
    public void act() {
        if (getWorld().getObjects(Break_Menu.class).isEmpty()) {
            run();
        }
    }
    
    public void run() {
        if (worm.getWeaponUsing() != 8 || !worm.getExecuting()) {
            getWorld().removeObject(this);
            return;
        }
        if (worm.getImageLeft()) {
            if (!imageLeft) {
                getImage().mirrorHorizontally();
                imageLeft = true;
            }
            setLocation(worm.getX()-15, worm.getY()+15);
        }
        else {
            if (imageLeft) {
                getImage().mirrorHorizontally();
                imageLeft = false;
            }
            setLocation(worm.getX()+15, worm.getY()+15);
        }
        if (hittingCounter == 10) {
            hitWorm();
        }
        if (hit) {
            hit();
        }
    }
    
    private void hit() {
        if (imageLeft) {
            if (hittingCounter < 10) {
                turn(-5);
                if (hittingCounter % 3 == 0) {
                    setLocation(getX(), getY()+1);
                }
            }
            else if (hittingCounter < 20) {
                turn(5);
                if (hittingCounter % 3 == 0) {
                    setLocation(getX(), getY()-1);
                }
            }
            else {
                hittingCounter = 0;
                hit = false;
                getWorld().removeObject(this);
                return;
            }
        }
        else {
            if (hittingCounter < 10) {
                turn(5);
                if (hittingCounter % 3 == 0) {
                    setLocation(getX(), getY()+1);
                }
            }
            else if (hittingCounter < 20) {
                turn(-5);
                if (hittingCounter % 3 == 0) {
                    setLocation(getX(), getY()-1);
                }
            }
            else {
                hittingCounter = 0;
                hit = false;
                getWorld().removeObject(this);
                return;
            }
        }
        hittingCounter++;
    }
    
    private void hitWorm() {
        List<Worm> worms = getObjectsInRange(hittingRadius, Worm.class);
        if (worms.size() > 1) {
            GreenfootSound impact = new GreenfootSound("firepunchimpact.wav");
            impact.setVolume(Settings.effectVolume);
            impact.play();
            if (Greenfoot.getRandomNumber(10) > 6) {
                ((Worms_Land) getWorld()).setClaim(7, Greenfoot.getRandomNumber(2)+1, worm);
            }
        }
        for (int i = 0; i < worms.size(); i++) {
            if (!worms.get(i).equals(worm)) {
                worms.get(i).setLife(-30);
                worms.get(i).setHitByBaseballBat(true);
            }
        }
        for (int i = 0; i < worms.size(); i++) {
            if (!worms.get(i).equals(worm)) {
                blowUp(Math.toRadians(imageLeft ? 200 : 340), 0.5, worms.get(i));
            }
        }
    }
    
    public boolean getHit() {
        return hit;
    }
    public void setHit(boolean hit) {
        this.hit = hit;
    }
}
