import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Point;
import java.util.List;

/**
 * Write a description of class Bazooka here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Bazooka extends Weapon
{
    private double velX;
    private double exactX;
    private double exactY;
    private double velY;
    
    private int[] nearestCoordinates = new int[2];
    
    private int waterRotation = 0;
    private int counter = 0;
    
    public static final int EXPLOSIONS_RADIUS = 150;
    
    private boolean water = false;
    private boolean initialised = false;
    
    private Worm worm;
    private Worm targetWorm;
    
    public Bazooka(Worm worm, double vx, double vy) {
        this.worm = worm;
        velX = vx;
        velY = vy;
    }
    
    public Bazooka() {
        worm = null;
        velX = 0;
        velY = 0;
    }
    
    /**
     * Call the run method to run the game if the game is executed.
     */
    public void act() {
        if (getWorld().getObjects(Break_Menu.class).isEmpty()) {
            run();
        }
    }
    
    public void run() {
        if (!initialised) {
            exactX = getX();
            exactY = getY();
            nearestCoordinates[0] = getX();
            nearestCoordinates[1] = getY();
            initialised = true;
        }
        fly();
        setRotation((int) (Math.toDegrees(Math.atan2(velX, velY)))-90);
        if (targetWorm == null) {
            targetWorm = ((Worms_Land) getWorld()).getEnemyWorm();
        }
        if (targetWorm != null && GreenfootToolkit.getToolkit().getObjectsDistance(this, targetWorm) < 
            GreenfootToolkit.getToolkit().getPointsDistance(new Point(nearestCoordinates[0], nearestCoordinates[1]), new Point(targetWorm.getX(), targetWorm.getY()))) {
            nearestCoordinates[0] = getX();
            nearestCoordinates[1] = getY();
        }
        if (counter > 15) {
            if (found(Worm.class) || !getWorld().getObjectsAt((int) (getX() + velX), (int) (getY() - velY), Worm.class).isEmpty()) {
                explode();
                return;
            }
        }
        else {
            counter++;
        }
        if (((Worms_Land) getWorld()).getMaterialAt((int) (getX() + velX), (int) (getY() - velY)).getMaterial() == 1 || foundEnemyWorm() || foundOilDrum()) {
            if (water) {
                getWorld().removeObject(this);
                return;
            }
            else {
                explode();
                return;
            }
        }
        else if (((Worms_Land) getWorld()).getMaterialAt(getX(), getY()+25).getMaterial() == 3) {
            GreenfootSound water = new GreenfootSound("splash.wav");
            water.setVolume(Settings.effectVolume);
            if (velY < -5) {
                if (velY < -3) {
                    water.setVolume((int) Math.abs(3*100/5));
                }
                else {
                    water.setVolume((int) Math.abs(velY*100/5));
                }
            }
            water.play();
            getWorld().removeObject(this);
            return;
        }
        else if (getY() > 710) {
            getWorld().removeObject(this);
            return;
        }
    }
    
    private boolean foundEnemyWorm() {
        List<Worm> worms = getWorld().getObjectsAt((int) (getX() + velX), (int) (getY() + velY), Worm.class);
        for (int i = 0; i < worms.size(); i++) {
            if (!worms.get(i).getExecuting()) {
                return true;
            }
        }
        return false;
    }
    
    private boolean foundOilDrum() {
        return getWorld().getObjectsAt((int) (getX() + velX), (int) (getY() + velY), Oil_Drum.class).size() != 0;
    }
    
    public void fly() {
        velY -= Worms_Land.GRAVITY;
        velX += Worms_Land.WIND;
        setLocation((int) (exactX + velX), (int) (exactY - velY));
    }
    
    public void setLocation(int x, int y) {
        exactX = x;
        exactY = y;
        super.setLocation(x, y);
    }
    
    private void explode() {
        List<Worm> worms = getObjectsInRange(EXPLOSIONS_RADIUS, Worm.class);
        List<Grave_Stone> graves = getObjectsInRange(EXPLOSIONS_RADIUS, Grave_Stone.class);
        List<Mine> mines = getObjectsInRange(EXPLOSIONS_RADIUS, Mine.class);
        List<Oil_Drum> oilDrums = getObjectsInRange(EXPLOSIONS_RADIUS, Oil_Drum.class);
        int damage;
        for (int i = 0; i < worms.size(); i++) {
            damage = (int) (-0.375*getObjectsDistance(this, worms.get(i))+56.25);
            if (damage > 45) {
                damage = 45;
            }
            kill(worms.get(i), damage);
        }
        for (int i = 0; i < worms.size(); i++) {
            blowUp(Math.toRadians(directionToTurnTo(worms.get(i).getX(), worms.get(i).getY())), (((-0.5/EXPLOSIONS_RADIUS)*getObjectsDistance(worms.get(i), this))+0.5), worms.get(i));
        }
        for (int i = 0; i < graves.size(); i++) {
            blowUp(Math.toRadians(directionToTurnTo(graves.get(i).getX(), graves.get(i).getY())), (((-0.3/EXPLOSIONS_RADIUS)*getObjectsDistance(graves.get(i), this))+0.4), graves.get(i));
        }
        for (int i = 0; i < mines.size(); i++) {
            blowUp(Math.toRadians(directionToTurnTo(mines.get(i).getX(), mines.get(i).getY())), (((-0.2/EXPLOSIONS_RADIUS)*getObjectsDistance(mines.get(i), this))+0.2), mines.get(i));
        }
        for (int i = 0; i < oilDrums.size(); i++) {
            oilDrums.get(i).explode();
        }
        destroyWorld(getX(), getY(), (int) (EXPLOSIONS_RADIUS*0.4));
        ((Worms_Land) getWorld()).calculateAdaptiveAlgorithm(this);
        getWorld().addObject(new Explosion(2), getX(), getY());
        getWorld().removeObject(this);
    }
    
    public void setMagneticInfluence(double vx, double vy) {
        velX += vx;
        velY += vy;
    }
    
    public int[] getNearestCoordinates() {
        return nearestCoordinates;
    }
}
