import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;

/**
 * Write a description of class Bullet here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Bullet extends Weapon
{
    private double velX;
    private double velY;
    private double exactX;
    private double exactY;
    
    private int bulletType = 0;
    
    public static int explosionsRadius = 50;
    
    private int damage = 25;
    
    private Worm worm;
    private Shotgun shotgun;
    
    public Bullet(Worm worm, Weapon weapon, double vx, double vy) {
        getImage().clear();
        getImage().scale(5, 5);
        this.worm = worm;
        if (weapon instanceof Shotgun) {
            bulletType = 1;
            explosionsRadius = 50;
            damage = 25;
        }
        else if (weapon instanceof Uzi) {
            bulletType = 2;
            explosionsRadius = 10;
            damage = 2;
        }
        else {
            System.out.println("Bullet: wrong weapon type");
        }
        velX = vx;
        velY = vy;
    }
    
    /**
     * Call the run method to run the game if the game is executed.
     */
    public void act() {
        if (getWorld().getObjects(Break_Menu.class).isEmpty()) {
            run();
        }
    }
    
    public void run() {
        for (int i = 0; i < 1000; i++) {
            if (foundEarth() || foundEnemyWorm() || foundOilDrum()) {
                explode();
                return;
            }
            else {
                setExactLocation(exactX + velX, exactY - velY);
                if (getX() < 0 || getX() > 1200 || getY() < 0 || getY() > 700) {
                    getWorld().removeObject(this);
                    return;
                }
            }
        }
        getWorld().removeObject(this);
        return;
    }
    
    private boolean foundEarth() {
        double vx = (velX/10);
        double vy = (velY/10);
        for (int i = 0; i < 10; i++) {
            if (((Worms_Land) getWorld()).getMaterialAt((int) (getX()+(i*vx)), (int) (getY()+(i*vy))).getMaterial() == 1) {
                return true;
            }
        }
        return false;
    }
    
    private boolean foundEnemyWorm() {
        List<Worm> worms = getWorld().getObjectsAt(getX(), getY(), Worm.class);
        for (int i = 0; i < worms.size(); i++) {
            if (!worms.get(i).getExecuting()) {
                return true;
            }
        }
        return false;
    }
    
    private boolean foundOilDrum() {
        return getWorld().getObjectsAt((int) (getX() + velX), (int) (getY() + velY), Oil_Drum.class).size() != 0;
    }
    
    public void setExactLocation(double x, double y) {
        exactX = x;
        exactY = y;
        super.setLocation((int) x, (int) y);
    }
    public void setLocation(int x, int y) {
        exactX = x;
        exactY = y;
        super.setLocation(x, y);
    }
    
    private void explode() {
        //List<Worm> worms = getObjectsInRange(explosionsRadius, Worm.class);
        List<Worm> worms = getWorld().getObjectsAt(getX(), getY(), Worm.class);
        List<Grave_Stone> graves = getObjectsInRange(explosionsRadius, Grave_Stone.class);
        List<Mine> mines = getObjectsInRange(explosionsRadius, Mine.class);
        List<Oil_Drum> oilDrums = getObjectsInRange(explosionsRadius, Oil_Drum.class);
        for (int i = 0; i < worms.size(); i++) {
            kill(worms.get(i), damage);
        }
        for (int i = 0; i < worms.size(); i++) {
            blowUp(Math.toRadians(directionToTurnTo(worms.get(i).getX(), worms.get(i).getY())), (((-0.4/explosionsRadius)*getObjectsDistance(worms.get(i), this))+(bulletType == 1 ? 0.4 : 1.5)), worms.get(i));
        }
        for (int i = 0; i < graves.size(); i++) {
            blowUp(Math.toRadians(directionToTurnTo(graves.get(i).getX(), graves.get(i).getY())), (((-0.3/explosionsRadius)*getObjectsDistance(graves.get(i), this))+0.2), graves.get(i));
        }
        for (int i = 0; i < mines.size(); i++) {
            blowUp(Math.toRadians(directionToTurnTo(mines.get(i).getX(), mines.get(i).getY())), (((-0.2/explosionsRadius)*getObjectsDistance(mines.get(i), this))+0.2), mines.get(i));
        }
        for (int i = 0; i < oilDrums.size(); i++) {
            oilDrums.get(i).explode();
        }
        destroyWorld(getX(), getY(), (int) (explosionsRadius*0.5));
        getWorld().removeObject(this);
    }
}
