import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;

/**
 * Write a description of class Bunkerbuster here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Bunkerbuster extends Weapon
{
    public static final int EXPLOSIONS_RADIUS = 100;
    
    private int drillingCounter = 0;
    
    private double exactX = 0;
    private double exactY = 0;
    private double velY = 0;
    
    private boolean water = false;
    private boolean initialised = false;
    
    private Worm worm;
    
    public Bunkerbuster(Worm worm) {
        this.worm = worm;
    }
    
    /**
     * Call the run method to run the game if the game is executed.
     */
    public void act() {
        if (getWorld().getObjects(Break_Menu.class).isEmpty()) {
            run();
        }
    }
    
    public void run() {
        if (!initialised) {
            exactX = getX();
            exactY = getY();
            initialised = true;
        }
        if (((Worms_Land) getWorld()).getMaterialAt((int) exactX, (int) (exactY + velY)).getMaterial() == 1) {           
            destroyWorld(getX(), getY()-29, 30);
            setExactLocation(exactX, exactY + 1);
            velY = 0;
            drillingCounter++;
        } 
        else if (((Worms_Land) getWorld()).getMaterialAt((int) exactX, (int) (exactY + velY)).getMaterial() == 3) {
            GreenfootSound water = new GreenfootSound("splash.wav");
            water.setVolume(Settings.effectVolume);
            water.play();
            getWorld().removeObject(this);
            return;
        }
        else {
            fly();
        }
        if (foundEnemyWorm() || drillingCounter >= 150) {
            explode();
        }
    }    
    
    public void fly() {
        velY -= Worms_Land.GRAVITY/2;
        //velX += Worms_Land.WIND;
        setExactLocation(exactX, exactY - velY);
    }
    
    public void setExactLocation(double x, double y) {
        exactX = x;
        exactY = y;
        super.setLocation((int) x, (int) y);
    }
    
    private boolean foundEnemyWorm() {
        List<Worm> worms = getWorld().getObjectsAt(getX(), getY(), Worm.class);
        for (int i = 0; i < worms.size(); i++) {
            if (!worms.get(i).getExecuting()) {
                return true;
            }
        }
        return false;
    }
    
    private void explode() {
        List<Worm> worms = getObjectsInRange(EXPLOSIONS_RADIUS, Worm.class);
        List<Grave_Stone> graves = getObjectsInRange(EXPLOSIONS_RADIUS, Grave_Stone.class);
        List<Mine> mines = getObjectsInRange(EXPLOSIONS_RADIUS, Mine.class);
        List<Oil_Drum> oilDrums = getObjectsInRange(EXPLOSIONS_RADIUS, Oil_Drum.class);
        int damage;
        for (int i = 0; i < worms.size(); i++) {
            damage = (int) (-0.65*getObjectsDistance(this, worms.get(i))+97.5);
            if (damage > 65) {
                damage = 65;
            }
            kill(worms.get(i), damage);
        }
        for (int i = 0; i < worms.size(); i++) {
            blowUp(Math.toRadians(directionToTurnTo(worms.get(i).getX(), worms.get(i).getY())), (((-0.5/EXPLOSIONS_RADIUS)*getObjectsDistance(worms.get(i), this))+0.5), worms.get(i));
        }
        for (int i = 0; i < graves.size(); i++) {
            blowUp(Math.toRadians(directionToTurnTo(graves.get(i).getX(), graves.get(i).getY())), (((-0.3/EXPLOSIONS_RADIUS)*getObjectsDistance(graves.get(i), this))+0.4), graves.get(i));
        }
        for (int i = 0; i < mines.size(); i++) {
            blowUp(Math.toRadians(directionToTurnTo(mines.get(i).getX(), mines.get(i).getY())), (((-0.2/EXPLOSIONS_RADIUS)*getObjectsDistance(mines.get(i), this))+0.2), mines.get(i));
        }
        for (int i = 0; i < oilDrums.size(); i++) {
            oilDrums.get(i).explode();
        }
        destroyWorld(getX(), getY(), (int) (EXPLOSIONS_RADIUS*0.6));
        getWorld().addObject(new Explosion(3), getX(), getY());
        getWorld().removeObject(this);
    }
}
