import java.util.List;
import java.awt.Point;
import greenfoot.*;

/**
 * Write a description of class Calculator here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Calculator
{
    private int windInfluence;
    private int weaponNumber = 0;
    private int actingCounter = 0;
    private int lyingCounter = 0;
    private int xPos = 0;
    private int yPos = 0;
    
    private double velX;
    private double velY;
    private double startingVelX;
    private double startingVelY;
    private double exactX;
    private double exactY;
    private double startingX;
    private double startingY;
    
    private World world;
    private Weapon weapon;
    private Worm targetWorm;
    
    public Calculator(World world, Weapon weapon, double velX, double velY, double exactX, double exactY, Worm targetWorm) {
        this.world = world;
        this.weapon = weapon;
        this.velX = velX;
        this.velY = velY;
        this.startingVelX = velX;
        this.startingVelY = velY;
        this.exactX = exactX;
        this.exactY = exactY;
        this.startingX = exactX;
        this.startingY = exactY;
        this.targetWorm = targetWorm;
        if (weapon instanceof Bazooka) {
            weaponNumber = 1;
            windInfluence = 1;
        }
        else if (weapon instanceof Grenade) {
            weaponNumber = 2;
            windInfluence = 3;
            actingCounter = 100*((Grenade) weapon).getTimeToExplode();
        }
        else if (weapon instanceof Clustergrenade) {
            weaponNumber = 3;
            windInfluence = 3;
            actingCounter = 100*((Clustergrenade) weapon).getTimeToExplode();
        }
        else if (weapon instanceof Holly_Grenade) {
            weaponNumber = 9;
            windInfluence = 3;
        }
        else if (weapon instanceof Bananabomb) {
            weaponNumber = 10;
            windInfluence = 3;
            actingCounter = 100*((Bananabomb) weapon).getTimeToExplode();
        }
    }
    
    public double[] getTrajectoryValues() {
        double[] trajectoryValues = getStartingValues();
        int[] impactCoordinates;
        for (int i = 0; i < 25; i++) {
            resetPosition();
            impactCoordinates = getImpactCoordinates(trajectoryValues);
            if (targetWormHit(impactCoordinates)) {
                return trajectoryValues;
            }
            else {
                if (impactCoordinates[0] < targetWorm.getX()-50) {
                    trajectoryValues[0] += Math.abs(targetWorm.getX() - impactCoordinates[0]) * (10.0/1200.0);
                }
                else if (impactCoordinates[0] > targetWorm.getX()+50) {
                    trajectoryValues[0] -= Math.abs(targetWorm.getX() - impactCoordinates[0]) * (10.0/1200.0);
                }
                else {
                    if (impactCoordinates[1] < targetWorm.getY()-50) {
                        trajectoryValues[0] -= Math.abs(targetWorm.getY() - impactCoordinates[1]) * (3.0/700.0);
                    }
                    else if (impactCoordinates[1] > targetWorm.getY()+50) {
                        trajectoryValues[1] += Math.abs(targetWorm.getY() - impactCoordinates[1]) * (3.0/700.0);
                    }
                }
            }
            if (Math.abs(trajectoryValues[0]) > Worms_Land.MAX_FORCE) {
                trajectoryValues[0] = Worms_Land.MAX_FORCE;
            }
            else if (Math.abs(trajectoryValues[0]) < Worms_Land.MIN_FORCE) {
                trajectoryValues[0] = Worms_Land.MIN_FORCE;
            }
            if (Math.abs(trajectoryValues[1]) > Worms_Land.MAX_FORCE) {
                trajectoryValues[1] = Worms_Land.MAX_FORCE;
            }
            else if (Math.abs(trajectoryValues[1]) < Worms_Land.MIN_FORCE) {
                trajectoryValues[1] = Worms_Land.MIN_FORCE;
            }
            //System.out.println(trajectoryValues[0] + " " + trajectoryValues[1]);
        }
        return new double[2];
    }
    
    public boolean targetWormHit() {
        int[] impactCoordinates = getImpactCoordinates();
        if (Math.abs(targetWorm.getX() - impactCoordinates[0]) < 100 && Math.abs(targetWorm.getY() - impactCoordinates[1]) < 100) {
            return true;
        }
        return false;
    }
    
    private boolean targetWormHit(int[] impactCoordinates) {
        if (Math.abs(targetWorm.getX() - impactCoordinates[0]) < 100 && Math.abs(targetWorm.getY() - impactCoordinates[1]) < 100) {
            return true;
        }
        return false;
    }
    
    public int[] getImpactCoordinates() {
        calculateTrajectory();
        int[] coordinates = new int[2];
        coordinates[0] = (int) exactX;
        coordinates[1] = (int) exactY;
        return coordinates;
    }
    
    public int[] getImpactCoordinates(double[] trajectoryValues) {
        calculateTrajectory(trajectoryValues);
        int[] coordinates = new int[2];
        coordinates[0] = (int) exactX;
        coordinates[1] = (int) exactY;
        return coordinates;
    }
    
    public double[] getStartingValues() {
        double[] startingValues = new double[2];
        int deltaX = (int) (targetWorm.getX() - exactX);
        int deltaY = (int) (targetWorm.getY() - exactY);
        startingValues[1] = 3;
        if (deltaY < 0) {
            startingValues[1] += (5.0/700.0) * Math.abs(deltaY);
        }
        startingValues[0] = (18.0/1200.0) * deltaX;
        return startingValues;
    }
    
    private void calculateTrajectory() {
        for (int i = 0; i < 1000; i++) {
            switch (weaponNumber) {
                case 1:
                    fly(true);
                    if (((Worms_Land) world).getMaterialAt((int) (exactX + velX), (int) (exactY + velY)).getMaterial() != 2 || foundEnemyWorm() || foundOilDrum()) {
                        return;
                    }
                    break;
                case 2:
                    fly(false);
                    move();
                    actingCounter--;
                    if (actingCounter == 0) {
                        return;
                    }
                    break;
                case 3:
                    fly(false);
                    move();
                    actingCounter--;
                    if (actingCounter == 0) {
                        return;
                    }
                    break;
                case 9:
                    fly(false);
                    move();
                    if (xPos == getX() && yPos == getY()) {
                        lyingCounter++;
                    }
                    xPos = getX();
                    yPos = getY();
                    if (lyingCounter > 100) {
                        return;
                    }
                    break;
                case 10:
                    fly(false);
                    move();
                    actingCounter--;
                    if (actingCounter == 0) {
                        return;
                    }
                    break;
                default:
                    System.out.println("Error: Calculator: WeaponNubmber unknown");
                    break;
            }
        }
    }
    
    private void calculateTrajectory(double[] trajectoryValues) {
        for (int i = 0; i < 1000; i++) {
            switch (weaponNumber) {
                case 1:
                    fly(true);
                    if (((Worms_Land) world).getMaterialAt((int) (exactX + velX), (int) (exactY + velY)).getMaterial() != 2 || foundEnemyWorm() || foundOilDrum()) {
                        return;
                    }
                    break;
                case 2:
                    fly(false);
                    move();
                    actingCounter--;
                    if (actingCounter == 0) {
                        return;
                    }
                    break;
                case 3:
                    fly(false);
                    move();
                    actingCounter--;
                    if (actingCounter == 0) {
                        return;
                    }
                    break;
                case 9:
                    fly(false);
                    move();
                    if (xPos == getX() && yPos == getY()) {
                        lyingCounter++;
                    }
                    xPos = getX();
                    yPos = getY();
                    if (lyingCounter > 100) {
                        return;
                    }
                    break;
                case 10:
                    fly(false);
                    move();
                    actingCounter--;
                    if (actingCounter == 0) {
                        return;
                    }
                    break;
                default:
                    System.out.println("Error: Calculator: WeaponNubmber unknown");
                    break;
            }
        }
    }
    
    private boolean foundEnemyWorm() {
        List<Worm> worms = world.getObjectsAt((int) (exactX + velX), (int) (exactY + velY), Worm.class);
        for (int i = 0; i < worms.size(); i++) {
            if (!worms.get(i).getExecuting()) {
                return true;
            }
        }
        return false;
    }
    
    private boolean foundOilDrum() {
        return world.getObjectsAt((int) (exactX + velX), (int) (exactY + velY), Oil_Drum.class).size() != 0;
    }
    
    private void fly(boolean setLocation) {
        velY -= Worms_Land.GRAVITY;
        velX += (windInfluence == 0 ? 0 : Worms_Land.WIND / windInfluence);
        if (setLocation) {
            setExactLocation(exactX + velX, exactY - velY);
        }
    }
    
    public void move() {
        try {
            if (((Worms_Land) world).getMaterialAt(getX(), getY()).getMaterial() == 1) {    
                velX = 0;
                velY = 0;
                return;
            }
            double Speed = Math.hypot(velX, velY);
            double a = Math.toRadians(Math.toDegrees(Math.atan2(velX, velY))-90);
            double x = Math.cos(a) * Math.hypot(velX, velY);
            double y = Math.sin(a) * Math.hypot(velX, velY);
            int ToMove = (int) Speed + 1;
            for (int i = 0; i < ToMove; i++) {
                MoveTo(exactX + x/ToMove, exactY + y/ToMove);
                Speed = Math.hypot(velX, velY);
                a = Math.toRadians(Math.toDegrees(Math.atan2(velX, velY))-90);
                x = Math.cos(a) * Math.hypot(velX, velY);
                y = Math.sin(a) * Math.hypot(velX, velY);
            }
        }
        catch (Exception e) {
            //e.printStackTrace();
        }
    }
    
    private void MoveTo(double x, double y) {
        if(((Worms_Land) world).getMaterialAt((int) x, (int) y).getMaterial() != 1) {
            setExactLocation(x, y);
            return;
        }
        x = getX();
        y = getY();
        double Degrees = Math.toDegrees(Math.atan2(velX, velY));
        Point P1 = null;
        Point P2 = null;
        for(double i = 13; i <= 360; i++) {
            double Rotation = Math.toRadians(Degrees + i - 90);
            double x1 = exactX + Math.cos(Rotation);
            double y1 = exactY + Math.sin(Rotation);
            Rotation = Math.toRadians(Degrees - i - 90);
            double x2 = exactX + Math.cos(Rotation);
            double y2 = exactY + Math.sin(Rotation);
            boolean noSolidIC = ((Worms_Land) world).getMaterialAt((int) x1, (int) y1).getMaterial() != 1;
            boolean noSolidAC = ((Worms_Land) world).getMaterialAt((int) x2, (int) y2).getMaterial() != 1;
            if(noSolidIC && P1 == null) {
                P1 = new Point(0,0);
                P1.setLocation(x1, y1);
            }
            if(noSolidAC && P2 == null) {
                P2 = new Point(0,0);
                P2.setLocation(x2, y2);
            }
            if(P1 != null && P2 != null) {
                double a = getDegreesToFrom(P1, P2);
                double g = Math.abs((a % 180) - (Degrees % 180));
                double SP = Math.hypot(velX, velY);
                if(a == 180) {
                    a = 0;
                }
                if((a % 180) > (Degrees % 180)) {
                    a += g;
                }
                else {
                    a -= g;
                }
                double Elastic = 1;
                if(g > 90) {
                    Elastic = (1-Math.abs((180-g)/90) * Elastic);
                }
                else {
                    Elastic = (1-Math.abs(g/90) * Elastic);
                }
                setSpeedInDirection(a, SP * Elastic);
                SP = Math.hypot(velX, velY);
                a = Math.toRadians(Math.toDegrees(Math.atan2(velX, velY))-90);
                x = getX() + Math.cos(a) * SP;
                y = getY() + Math.sin(a) * SP;
                if(((Worms_Land) world).getMaterialAt((int) x, (int) y).getMaterial() != 1) {
                    setExactLocation(x, y);
                }
                return;
            }
        }
        velX = 0;
        velY = 0;
        return;
    }
    
    private void setSpeedInDirection(double direction,double howFast) {
        double a = Math.toRadians(direction);
        velX = Math.cos(a) * howFast;
        velY = Math.sin(a) * howFast;
    }
    
    private double getDegreesToFrom(Point P1, Point P2) {
        return getDegreesToFrom(P1.getX(), P1.getY(), P2.getX(), P2.getY());
    }
    
    private double getDegreesToFrom(double x1, double y1,double x,double y) {
        return Math.toDegrees(Math.atan2(y1-y, x1-x));
    }
    
    private void setExactLocation(double x, double y) {
        exactX = x;
        exactY = y;
    }
    
    public static int randomInteger(int start, int end) throws IllegalArgumentException {
        if (start >= end) {
            throw new IllegalArgumentException("Value of start: " + start + " has to be less than the value of end: " + end);
        }
        return (int) (Math.random() * (end - start + 1)) + start;
    }
    
    private int getX() {
        return (int) exactX;
    }
    private int getY() {
        return (int) exactY;
    }
    
    public void resetPosition() {
        exactX = startingX;
        exactY = startingY;
    }
    public void resetVectors() {
        velX = startingVelX;
        velY = startingVelY;
    }
    public void reset() {
        resetPosition();
        resetVectors();
    }
}
