import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.awt.Font;
import java.util.ArrayList;

/**
 * Write a description of class Claims here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Claims extends Actor
{
    private int counter = 0;
    
    private boolean textDrawed = false;
    
    private ArrayList memory = new ArrayList();
    
    private String[] startingClaims = {"Payback time", "Time for [n]", "It's your turn [n]", "The Grim Reaper is coming", "Let's go [n]", "Ready, [n]?", "[n] is planing the next step", 
        "[n] is comming for you"};
    private String[] killerClaims = {"[n] riots merciless", "[n] is the gravedigger", "Violence is a solution", "Has anyone seen the medic?", "[n] shows who is the boss"};
    private String[] teamDiedClaims = {"For team [t] the mission is over", "Team [t] is history", "Things look rather bleak for team [t]"};
    private String[] wormDiedClaims = {"[n] bit the dust", "[n] peged out", "[n] has kicked the bucket", "For [n] the mission is over", "You'll never take me alive", 
        "We'll meet in hell next time", "Will anyone miss him?"};
    private String[] wormDiedWaterClaims = {"[n] couldn't swim", "[n] lies on the seabed", "[n] has found his wet grave", "[n] has a date with Neptune"};
    private String[] suizideClaims = {"Suicide is no solution, [n]", "[n] commited Suicide"};
    private String[] weaponClaims = {"Far Far Away!!!", "Perfect Homerun", "Eat This!!!", "Watch This", "Look in here, smile, and wait for the flashlight", "The end is near", "The sky is falling down"};
    private String[] mateKillClaims = {"Hey, [n], aim at the others!!!", "Friendly Fire!!!", "That was the wrong worm, [n]"};
    private String[] teamWon = {"Team [t] won", "Congratulations team [t]", "Team [t] is still alive", "Team [t] is the last on alive", "Team [t] killed all the others"};
    private String[] noOneAlive = {"Has anyone seen the soldiers?", "Is there anyone alive?", "That means overtime in the morgues", "The battle will go on in hell"};
    
    private class Memory {
        private String claim;
        private int team;
        
        public Memory() {
            claim = "";
            team = 0;
        }
        public Memory(String claim, int team) {
            this.claim = claim;
            this.team = team;
        }
        
        public void setClaim(String claim) {
            this.claim = claim;
        }
        public String getClaim() {
            return claim;
        }
        
        public void setTeam(int team) {
            this.team = team;
        }
        public int getTeam() {
            return team;
        }
    }
    
    public Claims() {
        getImage().clear();
        getImage().scale(1200, 100);
    }
    
    /**
     * Call the run method to run the game if the game is executed.
     */
    public void act() {
        if (getWorld().getObjects(Break_Menu.class).isEmpty()) {
            run();
        }
    }
    
    public void run() {
        if (textDrawed) {
            if (counter <= 0) {
                if (!memory.isEmpty()) {
                    Memory memoryUnit = (Memory) memory.remove(0);
                    changeImage(new GreenfootImage(memoryUnit.getClaim(), 50, getTeamColor(memoryUnit.getTeam()), new Color(0, 0, 0, 0)));
                    setLocation(600, 40);
                    counter = 200;
                }
                else {
                    getImage().clear();
                    textDrawed = false;
                }
            }
            else {
                counter--;
            }
        }
    }
    
    public void drawClaim(int claimCase, Worm callingWorm) {
        Color teamColor = getTeamColor(callingWorm.getParty());
        String[] claims = getClaims(claimCase);
        String claim = claims[Greenfoot.getRandomNumber(claims.length)];
        claim = exchangeNames(claim, callingWorm);
        if (textDrawed) {
            memory.add(new Memory(claim, callingWorm.getParty()));
        }
        else {
            changeImage(new GreenfootImage(claim, 50, teamColor, new Color(0, 0, 0, 0)));
            setLocation(600, 40);
            textDrawed = true;
            counter = 200;
        }
    }
    public void drawClaim(int claimCase, int claimNumber, Worm callingWorm) {
        Color teamColor = getTeamColor(callingWorm.getParty());
        String claim = getClaims(claimCase)[claimNumber-1];
        claim = exchangeNames(claim, callingWorm);
        if (textDrawed) {
            memory.add(new Memory(claim, callingWorm.getParty()));
        }
        else {
            changeImage(new GreenfootImage(claim, 50, teamColor, new Color(0, 0, 0, 0)));
            setLocation(600, 40);
            textDrawed = true;
            counter = 200;
        }
    }
    public void drawClaim(String text, Worm callingWorm) {
        Color teamColor = getTeamColor(callingWorm.getParty());
        text = exchangeNames(text, callingWorm);
        if (textDrawed) {
            memory.add(new Memory(text, callingWorm.getParty()));
        }
        else {
            changeImage(new GreenfootImage(text, 50, teamColor, new Color(0, 0, 0, 0)));
            setLocation(600, 40);
            textDrawed = true;
            counter = 200;
        }
    }
    
    private String exchangeNames(String string, Worm worm) {
        string = string.replace("[n]", worm.getName());
        string = string.replace("[t]", worm.getTeamname());
        return string;
    }
    
    private Color getTeamColor(int team) {
        switch (team) {
            case 1:
                return Color.red;
            case 2:
                return Color.blue;
            case 3:
                return Color.yellow;
            case 4:
                return new Color(0, 200, 0, 255);
            default:
                return new Color(0, 0, 0, 0);
        }
    }
    
    private String[] getClaims(int claimCase) {
        switch (claimCase) {
            case 1:
                return startingClaims;
            case 2:
                return killerClaims;
            case 3:
                return teamDiedClaims;
            case 4:
                return wormDiedClaims;
            case 5:
                return wormDiedWaterClaims;
            case 6:
                return suizideClaims;
            case 7:
                return weaponClaims;
            case 8:
                return mateKillClaims;
            case 9:
                return teamWon;
            case 10:
                return noOneAlive;
            default:
                System.out.println("Claim: Case unknown");
                return new String[0];
        }
    }
    
    public void changeImage(GreenfootImage img) {
        getImage().clear();
        getImage().scale(img.getWidth(), img.getHeight());
        getImage().drawImage(img, 0, 0);
    }
    
    public boolean chaimEmpty() {
        return counter <= 0 && memory.isEmpty();
    }
}
