import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.awt.Font;

/**
 * Write a description of class Clock here.
 * 
 * @author (your name)
 * @version (a version number or a date)
 */
public class Clock extends Actor
{
    private static int STARTING_TIME;
    
    private int seconds = 180;
    private int clockType = 0;
    
    private long lastCurrentSecond;
    private long timeSaved = 0;
    
    private boolean timeUp = false;
    private boolean count = false;
    
    public Clock() {
        getImage().clear();
        getImage().scale(130, 70);
        clockType = 1;
        STARTING_TIME = 180;
    }
    
    public Clock(int clockType) {
        this.clockType = clockType;
        if (clockType == 1) {
            getImage().clear();
            getImage().scale(130, 70);
            STARTING_TIME = 180;
        }
        else if (clockType == 2) {
            seconds = 45;
            STARTING_TIME = 45;
        }
    }
    
    public void act() {
        if (clockType == 1) {
            if (count && !timeUp) {
                if (System.currentTimeMillis() - lastCurrentSecond >= 1000) {
                    lastCurrentSecond += 1000;
                    seconds--;
                    drawTime();
                }
                if (seconds == 0) {
                    ((Worms_Land) getWorld()).setSuddenDeath(true);
                    timeUp = true;
                    GreenfootSound suddenDeath = new GreenfootSound("suddendeath.wav");
                    suddenDeath.setVolume(Settings.effectVolume);
                    suddenDeath.play();
                }
            }
        }
        else if (clockType == 2) {
            if (count) {
                if (System.currentTimeMillis() - lastCurrentSecond >= 1000) {
                    lastCurrentSecond += 1000;
                    seconds--;
                }
                if (seconds == 0) {
                    timeUp = true;
                }
            }
        }
    }
    
    private void drawTime() {
        int min = (int) (seconds / 60);
        int sec = seconds % 60;
        String remainingTime;
        if (sec < 10) {
            remainingTime = min+":0"+sec;
        }
        else {
            remainingTime = min+":"+sec;
        }
        getImage().setColor(Color.gray);
        getImage().fill();
        GreenfootImage text = new GreenfootImage("Time left:", 30, Color.black, new Color(0, 0, 0, 0));
        GreenfootImage time = new GreenfootImage(remainingTime, 40, Color.black, new Color(0, 0, 0, 0));
        getImage().drawImage(text, (getImage().getWidth()/2)-(text.getWidth()/2), 5);
        getImage().drawImage(time, (getImage().getWidth()/2)-(time.getWidth()/2), 30);
    }
    
    public boolean timeUp() {
        return timeUp;
    }
    
    public void startClock() {
        lastCurrentSecond = System.currentTimeMillis() - timeSaved;
        count = true;
    }
    public void stopClock() {
        timeSaved = System.currentTimeMillis() - lastCurrentSecond;
        count = false;
    }
    public void resetClock() {
        seconds = STARTING_TIME;
        timeUp = false;
    }
}
