import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
import java.awt.Point;

/**
 * Write a description of class Clustergranade here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Clustergrenade extends Weapon
{
    private double velX;
    private double exactX;
    private double exactY;
    private double velY;
    
    private int[] nearestCoordinates = new int[2];
    
    private int rotation = 0;
    private int counter = 0;
    private int timeToExplode;
    
    public static final int EXPLOSIONS_RADIUS = 75;
    
    private boolean moveX = true;
    private boolean moveY = true;
    private boolean countdownAdded = false;
    private boolean water = false;
    private boolean positionSubmitted = false;
    private boolean split;
    private boolean initialised = false;
    
    private GreenfootImage original;
    
    private Worm worm;
    private Worm targetWorm;
    private Countdown countdown;
    
    public Clustergrenade() {
        
    }
    
    public Clustergrenade(Worm worm, double vx, double vy, int time, boolean split) {
        this.worm = worm;
        targetWorm = worm.getTarget();
        velX = vx;
        velY = vy;
        timeToExplode = time;
        this.split = split;
        if (split) {
            getImage().scale(7, 7);
        }
        else {
            getImage().scale(30, 30);
        }
        original = getImage();
    }
    
    /**
     * Call the run method to run the game if the game is executed.
     */
    public void act() {
        if (getWorld().getObjects(Break_Menu.class).isEmpty()) {
            run();
        }
    }
    
    public void run() {
        if (!initialised) {
            nearestCoordinates[0] = getX();
            nearestCoordinates[1] = getY();
            initialised = true;
        }
        if (split) {
            move();
            fly();
            if (targetWorm == null) {
                targetWorm = ((Worms_Land) getWorld()).getEnemyWorm();
            }
            if (targetWorm != null && GreenfootToolkit.getToolkit().getObjectsDistance(this, targetWorm) < 
                GreenfootToolkit.getToolkit().getPointsDistance(new Point(nearestCoordinates[0], nearestCoordinates[1]), new Point(targetWorm.getX(), targetWorm.getY()))) {
                nearestCoordinates[0] = getX();
                nearestCoordinates[1] = getY();
            }
            if (moveX && moveY) {
                spin();
            }
            else if (!moveX && !moveY && !positionSubmitted) {
                alertWorm();
                positionSubmitted = true;
            }
            setRotation((int) (Math.toDegrees(Math.atan2(velX, velY)))-90);
            if (((Worms_Land) getWorld()).getMaterialAt((int) (exactX + velX), (int) (exactY - velY)).getMaterial() == 1) {
                explode();
                return;
            }
            else if (((Worms_Land) getWorld()).getMaterialAt(getX(), getY()+5).getMaterial() == 3) {
                getWorld().removeObject(countdown);
                getWorld().removeObject(this);
                return;
            }
        }
        else {
            if (!countdownAdded) {
                countdown = new Countdown(this);
                getWorld().addObject(countdown, getX(), getY()-10);
                countdownAdded = true;
            }
            move();
            fly();
            if (moveX && moveY) {
                spin();
            }
            setRotation((int) (Math.toDegrees(Math.atan2(velX, velY)))-90);
            if (counter > 5) {
                if (((Worms_Land) getWorld()).getMaterialAt(getX(), getY()+5).getMaterial() == 1 || foundEnemyWorm() || foundOilDrum()) {
                    velY = -velY;
                    if (velY <= 0.1) {
                        velY = 0;
                        moveY = false;
                    }
                    else {
                        velY -= velY*0.2;
                    }
                    if (velX <= 0.1 && velX >= -0.1) {
                        velX = 0;
                        moveX = false;
                    }
                    else {
                        velX -= velX*0.2;
                    }
                }
                else if (((Worms_Land) getWorld()).getMaterialAt(getX(), getY()+5).getMaterial() == 3) {
                    if (!water) {
                        GreenfootSound water = new GreenfootSound("splash.wav");
                        water.setVolume(Settings.effectVolume);
                        if (velY < -5) {
                            if (velY < -3) {
                                water.setVolume((int) Math.abs(3*100/5));
                            }
                            else {
                                water.setVolume((int) Math.abs(velY*100/5));
                            }
                        }
                        water.play();
                    }
                    getWorld().removeObject(countdown);
                    getWorld().removeObject(this);
                    return;
                }
            }
            else {
                counter++;
            }
        }
    }
    
    public void move() {
        try {
            if (((Worms_Land) getWorld()).getMaterialAt(getX(), getY()).getMaterial() == 1) {    
                velX = 0;
                velY = 0;
                return;
            }
            double Speed = Math.hypot(velX, velY);
            double a = Math.toRadians(Math.toDegrees(Math.atan2(velX, velY))-90);
            double x = Math.cos(a) * Math.hypot(velX, velY);
            double y = Math.sin(a) * Math.hypot(velX, velY);
            int ToMove= (int) Speed + 1;
            for (int i = 0; i < ToMove; i++) {
                MoveTo(exactX + x/ToMove, exactY + y/ToMove);
                Speed = Math.hypot(velX, velY);
                a = Math.toRadians(Math.toDegrees(Math.atan2(velX, velY))-90);
                x = Math.cos(a) * Math.hypot(velX, velY);
                y = Math.sin(a) * Math.hypot(velX, velY);
            }
        }
        catch(Exception e) {
            //e.printStackTrace();
        }
    }
    
    private void MoveTo(double x, double y) {
        if(split || ((Worms_Land) getWorld()).getMaterialAt((int) x, (int) y).getMaterial() != 1) {
            setExactLocation(x, y);
            return;
        }
        x = getX();
        y = getY();
        double Degrees = Math.toDegrees(Math.atan2(velX, velY));
        Point P1 = null;
        Point P2 = null;
        for(double i = 13; i <= 360; i++) {
            double Rotation = Math.toRadians(Degrees + i - 90);
            double x1 = exactX + Math.cos(Rotation);
            double y1 = exactY + Math.sin(Rotation);
            Rotation = Math.toRadians(Degrees - i - 90);
            double x2 = exactX + Math.cos(Rotation);
            double y2 = exactY + Math.sin(Rotation);
            boolean noSolidIC = ((Worms_Land) getWorld()).getMaterialAt((int) x1, (int) y1).getMaterial() != 1;
            boolean noSolidAC = ((Worms_Land) getWorld()).getMaterialAt((int) x2, (int) y2).getMaterial() != 1;
            if(noSolidIC && P1 == null) {
                P1 = new Point(0,0);
                P1.setLocation(x1, y1);
            }
            if(noSolidAC && P2 == null) {
                P2 = new Point(0,0);
                P2.setLocation(x2, y2);
            }
            if(P1 != null && P2 != null) {
                double a = getDegreesToFrom(P1, P2),
                g = Pos((a % 180) - (Degrees % 180)),
                SP = Math.hypot(velX, velY);
                if(a == 180) {
                    a = 0;
                }
                if((a % 180) > (Degrees % 180)) {
                    a += g;
                }
                else {
                    a -= g;
                }
                double Elastic = 1;
                if(g > 90) {
                    Elastic = (1-Pos((180-g)/90) * Elastic);
                }
                else {
                    Elastic = (1-Pos(g/90) * Elastic);
                }
                setSpeedInDirection(a, SP * Elastic);
                SP = Math.hypot(velX, velY);
                a = Math.toRadians(Math.toDegrees(Math.atan2(velX, velY))-90);
                x = getX() + Math.cos(a) * SP;
                y = getY() + Math.sin(a) * SP;
                if(split || ((Worms_Land) getWorld()).getMaterialAt((int) x, (int) y).getMaterial() != 1) {
                    setExactLocation(x, y);
                }
                return;
            }
        }
        velX = 0;
        velY = 0;
        return;
    }
    
    public void setSpeedInDirection(double direction,double howFast) {
        double a = Math.toRadians(direction);
        velX = Math.cos(a) * howFast;
        velY = Math.sin(a) * howFast;
    }
    
    private boolean foundEnemyWorm() {
        List<Worm> worms = getWorld().getObjectsAt((int) (getX() + velX), (int) (getY() + velY), Worm.class);
        for (int i = 0; i < worms.size(); i++) {
            if (!worms.get(i).getExecuting()) {
                return true;
            }
        }
        return false;
    }
    
    private boolean foundOilDrum() {
        return getWorld().getObjectsAt((int) (getX() + velX), (int) (getY() + velY), Oil_Drum.class).size() != 0;
    }
    
    private void fly() {
        velY -= Worms_Land.GRAVITY;
        velX += Worms_Land.WIND/3;
        //setLocation((int) (exactX + velX), (int) (exactY - velY));
    }
    
    private void spin() {
        rotation += 8;
        GreenfootImage cur = new GreenfootImage(original);
        cur.rotate(rotation);
        setImage(cur);
    }
    
    public void setLocation(int x, int y) {
        if (split || ((Worms_Land) getWorld()).getMaterialAt(x, y).getMaterial() != 1) {
            exactX = x;
            exactY = y;
            super.setLocation(x, y);
        }
    }
    
    public void setExactLocation(double x, double y) {
        if (split || ((Worms_Land) getWorld()).getMaterialAt((int) x, (int) y).getMaterial() != 1) {
            exactX = x;
            exactY = y;
            super.setLocation((int) x, (int) y);
        }
    }
    
    public void explode() {
        if (split) {
            List<Worm> worms = getObjectsInRange(EXPLOSIONS_RADIUS, Worm.class);
            List<Grave_Stone> graves = getObjectsInRange(EXPLOSIONS_RADIUS, Grave_Stone.class);
            List<Mine> mines = getObjectsInRange(EXPLOSIONS_RADIUS, Mine.class);
            List<Oil_Drum> oilDrums = getObjectsInRange(EXPLOSIONS_RADIUS, Oil_Drum.class);
            int damage;
            for (int i = 0; i < worms.size(); i++) {
                damage = (int) (-0.308*getObjectsDistance(this, worms.get(i))+23.1);
                if (damage > 20) {
                    damage = 20;
                }
                kill(worms.get(i), damage);
            }
            for (int i = 0; i < worms.size(); i++) {
                blowUp(Math.toRadians(directionToTurnTo(worms.get(i).getX(), worms.get(i).getY())), (((-0.5/EXPLOSIONS_RADIUS)*getObjectsDistance(worms.get(i), this))+0.5), worms.get(i));
            }
            for (int i = 0; i < graves.size(); i++) {
                blowUp(Math.toRadians(directionToTurnTo(graves.get(i).getX(), graves.get(i).getY())), (((-0.3/EXPLOSIONS_RADIUS)*getObjectsDistance(graves.get(i), this))+0.4), graves.get(i));
            }
            for (int i = 0; i < mines.size(); i++) {
                blowUp(Math.toRadians(directionToTurnTo(mines.get(i).getX(), mines.get(i).getY())), (((-0.2/EXPLOSIONS_RADIUS)*getObjectsDistance(mines.get(i), this))+0.2), mines.get(i));
            }
            for (int i = 0; i < oilDrums.size(); i++) {
                oilDrums.get(i).explode();
            }
            destroyWorld(getX(), getY(), (int) (EXPLOSIONS_RADIUS*0.4));
            ((Worms_Land) getWorld()).calculateAdaptiveAlgorithm(this);
            getWorld().addObject(new Explosion(2), getX(), getY());
            getWorld().removeObject(this);
        }
        else {
            for (int i = 0; i < 5; i++) {
                getWorld().addObject(new Clustergrenade(worm, (int) (Greenfoot.getRandomNumber((int) (Worms_Land.MAX_FORCE/2))-(Worms_Land.MAX_FORCE/4)+velX), (int) (Greenfoot.getRandomNumber((int) (Worms_Land.MAX_FORCE/2))-(Worms_Land.MAX_FORCE/3)), 0, true), getX(), getY());
            }
            getWorld().addObject(new Explosion(1), getX(), getY());
            destroyWorld(getX(), getY(), 25);
            getWorld().removeObject(this);
        }
    }
    
    public void alertWorm() {
        if (worm.getArtificialIntelligence()) {
            List<Worm> wormsInExplosionsRange = getObjectsInRange(EXPLOSIONS_RADIUS*3, Worm.class);
            for (Worm worm : wormsInExplosionsRange) {
                if (worm.equals(this.worm)) {
                    if (getX() > worm.getX()) {
                        worm.moveLeft();
                        worm.setRunningCounter(100);
                    }
                    else {
                        worm.moveRight();
                        worm.setRunningCounter(100);
                    }
                    return;
                }
            }
        }
    }
    
    public void setMagneticInfluence(double vx, double vy) {
        velX += vx;
        velY += vy;
    }
    
    public int getTimeToExplode() {
        return timeToExplode;
    }
    
    public int[] getNearestCoordinates() {
        return nearestCoordinates;
    }
}
