import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.util.List;
import java.util.ArrayList;

/**
 * Write a description of class Dropdown_List here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Dropdown_List extends Menu
{
    private boolean element;
    private boolean initialised = false;
    
    private Profile profile;
    
    private Dropdown_List callingList;
    
    private Menu callingMenu;
    
    private ArrayList<Dropdown_List> elements;
    
    public Dropdown_List(List<Profile> profiles, Menu callingMenu) {
        elements = new ArrayList<Dropdown_List>();
        this.callingMenu = callingMenu;
        for (Profile profile : profiles) {
            elements.add(new Dropdown_List(profile, callingMenu, this));
        }
        element = false;
        getImage().clear();
        getImage().scale(378, 40*(profiles.size() == 0 ? 1 : profiles.size()) + 2);
        getImage().setColor(new Color(14, 0, 181, 255));
        getImage().fill();
        getImage().setColor(Color.black);
        getImage().drawRect(0, 0, 376, getImage().getHeight()-2);
    }
    
    public Dropdown_List(Profile profile, Menu callingMenu, Dropdown_List callingList) {
        this.profile = profile;
        this.callingMenu = callingMenu;
        this.callingList = callingList;
        element = true;
        getImage().clear();
        getImage().scale(375, 40);
        getImage().setColor(Color.black);
        GreenfootImage img = new GreenfootImage(profile.getProfileName(), 35, Color.black, new Color(0, 0, 0, 0));
        getImage().drawImage(img, 5, getImage().getHeight()/2 - img.getHeight()/2);
    }
    
    public void act() {
        if (element) {
            if (FullScreenWindow.mouseClicked(this)) {
                if (!this.profile.getProfileName().equals("<no profile available>")) {
                    ((Settings_Menu) callingMenu).setProfile(this.profile);
                }
                getWorld().removeObject(this);
                callingList.remove();
            }
        }
        else if (!initialised) {
            if (elements.isEmpty()) {
                Profile profile = new Profile(new String[] {"<no profile available>", "", "", "", "", ""});
                Dropdown_List list = new Dropdown_List(profile, callingMenu, this);
                GreenfootImage text = new GreenfootImage(profile.getProfileName(), 35, Color.black, new Color(0, 0, 0, 0));
                list.getImage().drawImage(text, 5, getImage().getHeight()/2 - text.getHeight()/2);
                getWorld().addObject(list, getX() + 1, getY() - (getImage().getHeight() / 2) + (list.getImage().getHeight() / 2));
            }
            else {
                for (Dropdown_List element : elements) {
                    getWorld().addObject(element, getX() + 1, getY() - (getImage().getHeight() / 2) + (element.getImage().getHeight() / 2) + (40 * elements.indexOf(element)));
                }
            }
            initialised = true;
        }
    }
    
    public void remove() {
        for (Dropdown_List element : elements) {
            getWorld().removeObject(element);
        }
        getWorld().removeObject(this);
    }
}
