import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;

/**
 * Write a description of class Dynamite here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Dynamite extends Weapon
{
    private double velX;
    private double velY;
    
    private int fallingCounter = 0;
    
    public static final int EXPLOSIONS_RADIUS = 250;
    
    private boolean countdownAdded = false;
    private boolean flying = true;
    private boolean soundPlayed = false;
    
    private Worm worm;
    
    public Dynamite(Worm worm, double vx, double vy) {
        this.worm = worm;
        velX = vx;
        velY = vy;
        getImage().scale(45, 45);
    }
    
    /**
     * Call the run method to run the game if the game is executed.
     */
    public void act() {
        if (getWorld().getObjects(Break_Menu.class).isEmpty()) {
            run();
        }
    }
    
    public void run() {
        if (!countdownAdded) {
            getWorld().addObject(new Countdown(this), getX(), getY()-10);
            countdownAdded = true;
        }
        if (flying) {
            fly();
        }
        if ((((Worms_Land) getWorld()).getMaterialAt(getX(), getY()+5).getMaterial() != 1)) {
            fallingCounter++;
            setLocation(getX(), (int) (getY()+(((Worms_Land) getWorld()).GRAVITY*fallingCounter)));
            if (!soundPlayed && (((Worms_Land) getWorld()).getMaterialAt(getX(), getY()+5).getMaterial() == 3)) {
                GreenfootSound water = new GreenfootSound("splash.wav");
                water.setVolume(Settings.effectVolume);
                if (fallingCounter < 50) {
                    if (fallingCounter < 30) {
                        water.setVolume((int) (30.0*100.0/50.0));
                    }
                    else {
                        water.setVolume((int) ((double)fallingCounter*100.0/50.0));
                    }
                }
                water.play();
                soundPlayed = true;
            }
        }
    }
    
    private void fly() {
        if (velY > 0) {
            velY -= Worms_Land.GRAVITY;
        }
        else {
            velY = 0;
        }
        if (velX < 0.1) {
            velX += 0.02;
        }
        else if (velX > -0.1) {
            velX -= 0.02;
        }
        if (((Worms_Land) getWorld()).getMaterialAt((int) (getX() + velX), (int) (getY() - velY + 10)).getMaterial() == 1) {
            if (velX < 0.1) {
                velX += 0.07;
            }
            else if (velX > -0.1) {
                velX -= 0.07;
            }
        }
        if (velX < 0.5 && velX > -0.5) {
            velX = 0;
            velY = 0;
            flying = false;
        }
        if (((Worms_Land) getWorld()).getMaterialAt((int) (getX() + velX), (int) (getY() - velY)).getMaterial() == 1) {
            if (((Worms_Land) getWorld()).getMaterialAt((int) (getX()), (int) (getY()+10)).getMaterial() == 1) {
                setLocation(getX(), getY()-25);
            }
            velX = 0;
            velY = 0;
            flying = false;
        }
        else {
            setLocation((int) (getX() + velX), (int) (getY() - velY));
        }
    }
    
    public void explode() {
        List<Worm> worms = getObjectsInRange(EXPLOSIONS_RADIUS, Worm.class);
        List<Grave_Stone> graves = getObjectsInRange(EXPLOSIONS_RADIUS, Grave_Stone.class);
        List<Mine> mines = getObjectsInRange(EXPLOSIONS_RADIUS, Mine.class);
        List<Oil_Drum> oilDrums = getObjectsInRange(EXPLOSIONS_RADIUS, Oil_Drum.class);
        int damage;
        for (int i = 0; i < worms.size(); i++) {
            damage = (int) (-0.295*getObjectsDistance(this, worms.get(i))+73.75);
            if (damage > 65) {
                damage = 65;
            }
            kill(worms.get(i), damage);
        }
        for (int i = 0; i < worms.size(); i++) {
            blowUp(Math.toRadians(directionToTurnTo(worms.get(i).getX(), worms.get(i).getY())), (((-0.5/EXPLOSIONS_RADIUS)*getObjectsDistance(worms.get(i), this))+0.5), worms.get(i));
        }
        for (int i = 0; i < graves.size(); i++) {
            blowUp(Math.toRadians(directionToTurnTo(graves.get(i).getX(), graves.get(i).getY())), (((-0.3/EXPLOSIONS_RADIUS)*getObjectsDistance(graves.get(i), this))+0.4), graves.get(i));
        }
        for (int i = 0; i < mines.size(); i++) {
            blowUp(Math.toRadians(directionToTurnTo(mines.get(i).getX(), mines.get(i).getY())), (((-0.2/EXPLOSIONS_RADIUS)*getObjectsDistance(mines.get(i), this))+0.2), mines.get(i));
        }
        for (int i = 0; i < oilDrums.size(); i++) {
            oilDrums.get(i).explode();
        }
        destroyWorld(getX(), getY(), (int) (EXPLOSIONS_RADIUS*0.4));
        getWorld().addObject(new Explosion(3), getX(), getY());
        getWorld().removeObject(this);
    }
}
