import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
import java.util.ArrayList;

/**
 * Write a description of class Firepunch here.
 * 
 * @author (your name)
 * @version (a version number or a date)
 */
public class Firepunch extends Weapon
{
    private double exactX;
    private double exactY;
    private double velY;
    
    private static final int EXPLOSIONS_RADIUS = 25;
    
    private boolean move = true;
    private boolean initialised = false;
    
    private Worm worm;
    
    private List<Worm> hitWorms = new ArrayList<Worm>();
    
    public Firepunch(Worm worm) {
        this.worm = worm;
        velY = 6;
        scaleImage(getImage(), 15);
    }
    
    public void act() {
        if (!initialised) {
            exactX = getX();
            exactY = getY();
            initialised = true;
        }
        fly();
        destroyWorld(getX(), getY() - 10, (int) (EXPLOSIONS_RADIUS));
        if (foundEnemyWorm()) {
            hitEnemyWorm();
        }
        if (((Worms_Land) getWorld()).getMaterialAt(getX(), getY()+25).getMaterial() != 2) {
            getWorld().removeObject(this);
        }
    }
    
    public void fly() {
        velY -= Worms_Land.GRAVITY;
        setExactLocation(exactX, (exactY - velY));
    }
    
    public void setExactLocation(double x, double y) {
        exactY = y;
        super.setLocation((int) x, (int) y);
    }
    
    private void hitEnemyWorm() {
        List<Worm> worms = getWorld().getObjectsAt(getX(), getY(), Worm.class);
        for (int i = 0; i < worms.size(); i++) {
            if (!worms.get(i).equals(worm) && !wormHit(worms.get(i))) {
                worms.get(i).setLife(-40);
                blowUp(Math.toRadians(worm.getImageLeft() ? 200 : 340), 0.2, worms.get(i));
            }
        }
    }
    
    private boolean wormHit(Worm worm) {
        for (Worm hitWorm : hitWorms) {
            if (hitWorm.equals(worm)) {
                return true;
            }
        }
        return false;
    }
    
    private boolean foundEnemyWorm() {
        List<Worm> worms = getWorld().getObjectsAt(getX(), getY(), Worm.class);
        for (int i = 0; i < worms.size(); i++) {
            if (!worms.get(i).getExecuting()) {
                return true;
            }
        }
        return false;
    }
}
