import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Grave_Stone here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Grave_Stone extends Players
{
    private double velX;
    private double velY;
    
    private int fallingCounter = 0;
    private int sinkingCounter = 0;
    private int counter = 0;
    
    private boolean falling = false;
    private boolean flying = false;
    private boolean sinking = false;
    
    public Grave_Stone(int stone, double velX, double velY) {
        this.velX = velX;
        this.velY = velY;
        if (velX != 0 || velY != 0) {
            flying = true;
        }
        switch (stone) {
            case 1:
                changeImage(new GreenfootImage("WoodenCross.png"));
                scaleImage(getImage(), 50);
                break;
            case 2:
                changeImage(new GreenfootImage("HelmetOnPole.png"));
                scaleImage(getImage(), 50);
                break;
            case 3:
                changeImage(new GreenfootImage("WoodenRIP.png"));
                scaleImage(getImage(), 50);
                break;
            case 4:
                changeImage(new GreenfootImage("StoneRIP.png"));
                scaleImage(getImage(), 50);
                break;
        }
    }
    
    /**
     * Call the run method to run the game if the game is executed.
     */
    public void act() {
        if (getWorld().getObjects(Break_Menu.class).isEmpty()) {
            run();
        }
    }
    
    /**
     * Makes the worm move, shoot or do whatever he wants to do.
     */
    public void run() {
        if (flying) {
            fly();
        }
        if (((Worms_Land) getWorld()).getMaterialAt(getX(), getY()+25).getMaterial() == 2) {
            //Air -> fall;
            fallingCounter++;
            setLocation(getX(), (int) (getY()+(((Worms_Land) getWorld()).GRAVITY*fallingCounter)));
            falling = true;
        }
        else if (((Worms_Land) getWorld()).getMaterialAt(getX(), getY()+25).getMaterial() == 1){
            //Earth;
            if (falling) {
                int fallingSpeed = (int) (((Worms_Land) getWorld()).GRAVITY*fallingCounter);
                if (fallingSpeed > 10) {
                    //count damage;
                }
                falling = false;
                fallingCounter = 0;
            }
            else {
                while (((Worms_Land) getWorld()).getMaterialAt(getX(), getY()+24).getMaterial() == 1 && ((Worms_Land) getWorld()).getMaterialAt(getX(), getY()+15).getMaterial() == 2) {
                    setLocation(getX(), getY()-1);
                }
            }
        }
        else if (!sinking) {
            if (counter >= 25) {
                GreenfootSound water = new GreenfootSound("splash.wav");
                water.setVolume(Settings.effectVolume);
                if (fallingCounter < 50) {
                    water.setVolume((int) ((double)fallingCounter*100.0/50.0));
                }
                water.play();
            }
            sinking = true;
        }
        if (sinking) {
            sink();
        }
        if (counter < 25) {
            counter++;
        }
    }
    
    private void fly() {
        if (velY > 0) {
            velY -= Worms_Land.GRAVITY;
        }
        else {
            velY = 0;
        }
        if (velX < 0.1) {
            velX += 0.02;
        }
        else if (velX > -0.1) {
            velX -= 0.02;
        }
        if (((Worms_Land) getWorld()).getMaterialAt((int) (getX()+velX), (int) (getY()+velY+25)).getMaterial() == 1) {
            if (velX < 0.1) {
                velX += 0.07;
            }
            else if (velX > -0.1) {
                velX -= 0.07;
            }
        }
        if (velX < 0.5 && velX > -0.5) {
            velX = 0;
            velY = 0;
            flying = false;
        }
        if (((Worms_Land) getWorld()).getMaterialAt((int) (getX()+velX), (int) (getY()+velY)).getMaterial() == 1) {
            if (((Worms_Land) getWorld()).getMaterialAt((int) (getX()), (int) (getY()+25)).getMaterial() == 1) {
                setLocation(getX(), getY()-25);
            }
            velX = 0;
            velY = 0;
            flying = false;
            //count damage;
        }
        else {
            setLocation((int) (getX() + velX), (int) (getY() - velY));
        }
    }
    
    private void sink() {
        if (sinkingCounter < 100) {
            sinkingCounter++;
            setLocation(getX(), getY()+1);
        }
        else {
            getWorld().removeObject(this);
        }
    }
    
    public void setFlying(boolean flying, double xSpeed, double ySpeed) {
        this.flying = flying;
        velX = xSpeed;
        velY = ySpeed;
    }
}
