import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Jetpack here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Jetpack extends Weapon
{
    private double velX;
    private double velY;
    private double exactX;
    private double exactY;
    private double fuel = 100;
    
    private Worm worm;
    
    public Jetpack(Worm worm) {
        this.worm = worm;
    }
    
    /**
     * Call the run method to run the game if the game is executed.
     */
    public void act() {
        if (getWorld().getObjects(Break_Menu.class).isEmpty()) {
            run();
        }
    }
    
    public void run() {
        if (FullScreenWindow.isKeyDown(Settings.wormUp)) {
            velY += 0.3;
            fuel -= 0.25;
        }
        if (FullScreenWindow.isKeyDown(Settings.wormLeft)) {
            velX -= 0.2;
            fuel -= 0.1;
        }
        if (FullScreenWindow.isKeyDown(Settings.wormRight)) {
            velX += 0.2;
            fuel -= 0.1;
        }
        fly();
    }
    
    private void fly() {
        velY -= Worms_Land.GRAVITY;
        velX += Worms_Land.WIND;
        if (Math.abs(velX) > 5) {
            if (velX > 5) {
                velX = 5;
            }
            else {
                velX = -5;
            }
        }
        if (Math.abs(velY) > 4) {
            if (velY > 4) {
                velY = 4;
            }
            else {
                velY = -4;
            }
        }
        setExactLocation(exactX + velX, exactY - velY);
    }
    
    public void setLocation(int x, int y) {
        if (movingPossible(x, y)) {
            exactX = x;
            exactY = y;
            super.setLocation(x, y);
        }
    }
    
    public void setExactLocation(double x, double y) {
        if (movingPossible(x, y)) {
            exactX = x;
            exactY = y;
            super.setLocation((int) x, (int) y);
        }
    }
    
    private boolean movingPossible(double x, double y) {
        for (int i = (int) (x - 10); i < x + 10; i += 5) {
            for (int j = (int) (y - 5); j < y + 25; i += 5) {
                if (((Worms_Land) getWorld()).getMaterialAt(i, j).getMaterial() != 2) {
                    return false;
                }
            }
        }
        return true;
    }
}
