import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;

/**
 * Write a description of class Kamikaze here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Kamikaze extends Weapon
{
    private static final int EXPLOSIONS_RADIUS = 150;
    
    private int counter = 0;
    
    public Kamikaze(int angle) {
        GreenfootSound kamikaze = new GreenfootSound("kamikaze.wav");
        kamikaze.setVolume(Settings.effectVolume);
        kamikaze.play();
        getImage().rotate(90);
        getImage().scale(48, 60);
        if (angle < 0) {
            angle += 360;
        }
        else if (angle > 360) {
            angle -= 360;
        }
        if (angle >= 0 && angle < 90 || angle > 270 && angle <= 360) {
            getImage().mirrorVertically();
        }
        turn(angle);
    }
    
    /**
     * Call the run method to run the game if the game is executed.
     */
    public void act() {
        if (getWorld().getObjects(Break_Menu.class).isEmpty()) {
            run();
        }
    }
    
    public void run() {
        if (foundEnemyWorm() || counter >= 150) {
            explode();
            return;
        }
        else {
            double[] nextPosition = move(getX(), getY(), getRotation(), 15);
            if (((Worms_Land) getWorld()).getMaterialAt((int) nextPosition[0], (int) nextPosition[1]).getMaterial() == 3) {
                GreenfootSound water = new GreenfootSound("splash.wav");
                water.setVolume(Settings.effectVolume);
                water.play();
                getWorld().removeObject(this);
                return;
            }
            move(15);
            destroyWorld(getX(), getY(), (int) (EXPLOSIONS_RADIUS*0.15));
            counter++;
        }
    }
    
    private boolean foundEnemyWorm() {
        List<Worm> worms = getWorld().getObjectsAt(getX(), getY(), Worm.class);
        for (int i = 0; i < worms.size(); i++) {
            if (!worms.get(i).getExecuting()) {
                return true;
            }
        }
        return false;
    }
    
    private void move(double distance) {
        double angle = Math.toRadians(getRotation());
        int x = (int) (getX() + Math.cos(angle) * distance);
        int y = (int) (getY() + Math.sin(angle) * distance);
        setLocation(x, y);
    }
    
    private void explode() {
        List<Worm> worms = getObjectsInRange(EXPLOSIONS_RADIUS, Worm.class);
        List<Grave_Stone> graves = getObjectsInRange(EXPLOSIONS_RADIUS, Grave_Stone.class);
        List<Mine> mines = getObjectsInRange(EXPLOSIONS_RADIUS, Mine.class);
        List<Oil_Drum> oilDrums = getObjectsInRange(EXPLOSIONS_RADIUS, Oil_Drum.class);
        int damage;
        for (int i = 0; i < worms.size(); i++) {
            damage = (int) (-0.65*getObjectsDistance(this, worms.get(i))+97.5);
            if (damage > 65) {
                damage = 65;
            }
            kill(worms.get(i), damage);
        }
        for (int i = 0; i < worms.size(); i++) {
            blowUp(Math.toRadians(directionToTurnTo(worms.get(i).getX(), worms.get(i).getY())), (((-0.5/EXPLOSIONS_RADIUS)*getObjectsDistance(worms.get(i), this))+0.5), worms.get(i));
        }
        for (int i = 0; i < graves.size(); i++) {
            blowUp(Math.toRadians(directionToTurnTo(graves.get(i).getX(), graves.get(i).getY())), (((-0.3/EXPLOSIONS_RADIUS)*getObjectsDistance(graves.get(i), this))+0.4), graves.get(i));
        }
        for (int i = 0; i < mines.size(); i++) {
            blowUp(Math.toRadians(directionToTurnTo(mines.get(i).getX(), mines.get(i).getY())), (((-0.2/EXPLOSIONS_RADIUS)*getObjectsDistance(mines.get(i), this))+0.2), mines.get(i));
        }
        for (int i = 0; i < oilDrums.size(); i++) {
            oilDrums.get(i).explode();
        }
        destroyWorld(getX(), getY(), (int) (EXPLOSIONS_RADIUS*0.6));
        getWorld().addObject(new Explosion(3), getX(), getY());
        getWorld().removeObject(this);
    }
}
