import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;

/**
 * Write a description of class Magnet here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Magnet extends Weapon
{
    private double velX;
    private double velY;
    private double imageSize;
    
    private int magnetType = 0;
    private int round = 0;
    private int fallingCounter = 0;
    private int animationCounter = 0;
    
    public static final int INFLUENCE_RANGE = 250;
    
    private boolean flying = true;
    private boolean soundPlayed = false;
    
    private GreenfootImage basicImage;
    private GreenfootImage impuls = new GreenfootImage("Elektroimpuls.png");
    
    public Magnet(int magnetType) {
        this.magnetType = magnetType;
        switch (magnetType) {
            case 1:
                basicImage = new GreenfootImage("Magnet_red.png");
                scaleImage(basicImage, 50);
                changeImage(basicImage);
                break;
            case 2:
                basicImage = new GreenfootImage("Magnet_blue.png");
                scaleImage(basicImage, 50);
                changeImage(basicImage);
                break;
            default:
                System.out.println("Magnet: Unknown magnetType");
                break;
        }
        imageSize = basicImage.getHeight();
    }
    
    /**
     * Call the run method to run the game if the game is executed.
     */
    public void act() {
        if (getWorld().getObjects(Break_Menu.class).isEmpty()) {
            run();
        }
    }
    
    public void run() {
        if (flying) {
            fly();
        }
        if ((((Worms_Land) getWorld()).getMaterialAt(getX(), getY()+15).getMaterial() != 1)) {// || found(Worm.class))) {
            fallingCounter++;
            setLocation(getX(), (int) (getY()+(((Worms_Land) getWorld()).GRAVITY*fallingCounter)));
            if (!soundPlayed && (((Worms_Land) getWorld()).getMaterialAt(getX(), getY()+15).getMaterial() == 3)) {
                GreenfootSound water = new GreenfootSound("splash.wav");
                water.setVolume(Settings.effectVolume);
                if (fallingCounter < 50) {
                    if (fallingCounter < 30) {
                        water.setVolume((int) (30.0*100.0/50.0));
                    }
                    else {
                        water.setVolume((int) ((double)fallingCounter*100.0/50.0));
                    }
                }
                water.play();
                soundPlayed = true;
            }
        }
        if (round < 5) {//maybe other value
            /*if (animationCounter < 25) {
                if (animationCounter % 5 == 0) {
                    impuls = new GreenfootImage("Elektroimpuls.png");
                    scaleImage(impuls, (int) imageSize);
                }
                scaleImage(impuls, 110);
                imageSize *= 110;
                imageSize /= 100;
                impuls.setTransparency(250 - 10*animationCounter);
                changeImage(impuls);
                getImage().drawImage(basicImage, getImage().getWidth()/2 - basicImage.getWidth()/2, getImage().getHeight()/2 - basicImage.getHeight()/2);
                animationCounter++;
            }
            else {
                animationCounter = 0;
                impuls = new GreenfootImage("Elektroimpuls.png");
                //imageSize = impuls.getHeight();
                changeImage(basicImage);
            }*/
            List<Weapon> weaponsInRange = getObjectsInRange(INFLUENCE_RANGE, Weapon.class);
            for (Weapon weapon : weaponsInRange) {
                if (magnetType == 1) {
                    setMagneticInfluence(Math.toRadians(directionToTurnTo(weapon.getX(), weapon.getY())), weapon);
                }
                else if (magnetType == 2) {
                    setMagneticInfluence(Math.toRadians(directionToTurnTo(weapon.getX(), weapon.getY()) + 180), weapon);
                }
            }
        }
    }
    
    private void fly() {
        if (velY > 0) {
            velY -= Worms_Land.GRAVITY;
        }
        else {
            velY = 0;
        }
        if (velX < 0.1) {
            velX += 0.02;
        }
        else if (velX > -0.1) {
            velX -= 0.02;
        }
        if (((Worms_Land) getWorld()).getMaterialAt((int) (getX() + velX), (int) (getY() - velY + 10)).getMaterial() == 1) {
            if (velX < 0.1) {
                velX += 0.07;
            }
            else if (velX > -0.1) {
                velX -= 0.07;
            }
        }
        if (velX < 0.5 && velX > -0.5) {
            velX = 0;
            velY = 0;
            flying = false;
        }
        if (((Worms_Land) getWorld()).getMaterialAt((int) (getX() + velX), (int) (getY() - velY)).getMaterial() == 1) {
            if (((Worms_Land) getWorld()).getMaterialAt((int) (getX()), (int) (getY()+10)).getMaterial() == 1) {
                setLocation(getX(), getY()-25);
            }
            velX = 0;
            velY = 0;
            flying = false;
        }
        else {
            setLocation((int) (getX() + velX), (int) (getY() - velY));
        }
    }
    
    public void setMagneticInfluence(double angleRadians, Weapon weapon) {
        double vx = getVelX(angleRadians, 0);
        double vy = getVelY(angleRadians, 0);
        vx /= getObjectsDistance(this, weapon)*0.1;
        vy /= getObjectsDistance(this, weapon)*0.1;
        if (weapon != null) {
            if (weapon instanceof Bazooka) {
               ((Bazooka) weapon).setMagneticInfluence(vx, vy);
            }
            else if (weapon instanceof Grenade) {
               ((Grenade) weapon).setMagneticInfluence(vx, vy);
            }
            else if (weapon instanceof Clustergrenade) {
               ((Clustergrenade) weapon).setMagneticInfluence(vx, vy);
            }
            else if (weapon instanceof Seeking_Missile) {//no influence after target;
               ((Seeking_Missile) weapon).setMagneticInfluence(vx, vy);
            }
            else if (weapon instanceof Holly_Grenade) {
               ((Holly_Grenade) weapon).setMagneticInfluence(vx, vy);
            }
        }
    }
    
    public void setRound(int number) {
        round += number;
    }
}
