import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;

/**
 * Write a description of class Mine here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Mine extends Other_Weapons
{
    private double velX;
    private double exactX;
    private double exactY;
    private double velY;
    
    private final int explosionsRadius = 100;
    
    private int rotation = 0;
    private int fallingCounter = 0;
    private int explodingCounter = 0;
    private int waterCounter = 0;
    private int waterRotation = 0;
    
    private boolean falling = false;
    private boolean flying = false;
    private boolean counting = false;
    private boolean water = false;
    
    private GreenfootImage original;
    
    public Mine() {
        scaleImage(getImage(), 20);
    }
    
    /**
     * Call the run method to run the game if the game is executed.
     */
    public void act() {
        if (getWorld().getObjects(Break_Menu.class).isEmpty()) {
            run();
        }
    }
    
    public void run() {
        if (!water) {
            if (getObjectsInRange(explosionsRadius, Worm.class).size() != 0) {
                counting = true;
            }
            if (counting) {
                explodingCounter++;
                if (explodingCounter > (Settings.mineExplodingTime == 4 ? (Greenfoot.getRandomNumber(3)+1)*100 : Settings.mineExplodingTime*100)) {
                    explode();
                    return;
                }
            }
            if (flying) {
                fly();
            }
        }
        else {
            if (((Worms_Land) getWorld()).getMaterialAt((int) (exactX + velX), (int) (exactY + velY)).getMaterial() != 1) {
                setLocation((int) (exactX + velX), (int) (exactY + velY));
            }
            setRotation(waterRotation);
            if (velX > 0.1) {
                velX -= 0.1;
            }
            else if (velX < 0.1) {
                velX += 0.1;
            }
            else {
                velX = 0;
            }
            velY += Worms_Land.GRAVITY/2;
            if (waterCounter > 25) {
                getWorld().removeObject(this);
                return;
            }
            else {
                waterCounter++;
            }
        }
        if (((Worms_Land) getWorld()).getMaterialAt(getX(), getY()+3).getMaterial() == 2) {
            fallingCounter++;
            setLocation(getX(), (int) (getY()+(((Worms_Land) getWorld()).GRAVITY*fallingCounter)));
            falling = true;
        }
        else if (((Worms_Land) getWorld()).getMaterialAt(getX(), getY()+3).getMaterial() == 3) {
            flying = false;
            falling = false;
            water = true;
            velY = 3;
            waterRotation = getRotation();
            GreenfootSound water = new GreenfootSound("splash.wav");
            water.setVolume(Settings.effectVolume);
            if (fallingCounter < 50) {
                if (fallingCounter < 30) {
                    water.setVolume((int) (30.0*100.0/50.0));
                }
                else {
                    water.setVolume((int) ((double)fallingCounter*100.0/50.0));
                }
            }
            water.play();
            return;
        }
        else {
            if (falling) {
                falling = false;
                fallingCounter = 0;
            }
            else {
                while (((Worms_Land) getWorld()).getMaterialAt(getX(), getY()+6).getMaterial() == 1 && ((Worms_Land) getWorld()).getMaterialAt(getX(), getY()+3).getMaterial() == 2) {
                    setLocation(getX(), getY()-1);
                }
            }
        }
    }
    
    private void fly() {
        if (velY > 0) {
            velY -= Worms_Land.GRAVITY;
        }
        else {
            velY = 0;
        }
        if (velX < 0.1) {
            velX += 0.02;
        }
        else if (velX > -0.1) {
            velX -= 0.02;
        }
        if (((Worms_Land) getWorld()).getMaterialAt((int) (getX()+velX), (int) (getY()-velY+25)).getMaterial() == 1) {
            if (velX < 0.1) {
                velX += 0.07;
            }
            else if (velX > -0.1) {
                velX -= 0.07;
            }
        }
        if (velX < 0.5 && velX > -0.5) {
            velX = 0;
            velY = 0;
            flying = false;
        }
        if (((Worms_Land) getWorld()).getMaterialAt((int) (getX()+velX), (int) (getY()-velY)).getMaterial() == 1) {
            if (((Worms_Land) getWorld()).getMaterialAt((int) (getX()), (int) (getY()+25)).getMaterial() == 1) {
                setLocation(getX(), getY()-25);
            }
            velX = 0;
            velY = 0;
            flying = false;
            //count damage;
        }
        else {
            setLocation((int) (getX() + velX), (int) (getY() - velY));
        }
        turn(-8);
    }
    
    public void moveTo(double x, double y) {
        setExactLocation(x, y);
    }
    
    public void setLocation(int x, int y) {
        exactX = x;
        exactY = y;
        super.setLocation(x, y);
    }
    
    public void setExactLocation(double x, double y) {
        exactX = x;
        exactY = y;
        super.setLocation((int) (x + 0.5), (int) (y + 0.5));
    }
    
    public boolean getFlying() {
        return flying;
    }
    public void setFlying(boolean flying, double xSpeed, double ySpeed) {
        this.flying = flying;
        velX = xSpeed;
        velY = ySpeed;
    }
    
    public boolean getFalling() {
        return falling;
    }
    
    public boolean getCounting() {
        return counting;
    }
    
    //must be changed;
    private void explode() {
        List<Worm> worms = getObjectsInRange(explosionsRadius, Worm.class);
        List<Grave_Stone> graves = getObjectsInRange(explosionsRadius, Grave_Stone.class);
        List<Oil_Drum> oilDrums = getObjectsInRange(explosionsRadius, Oil_Drum.class);
        int damage;
        for (int i = 0; i < worms.size(); i++) {
            damage = (int) (-0.5*getObjectsDistance(this, worms.get(i))+50);
            if (damage > 35) {
                damage = 35;
            }
            kill(worms.get(i), damage);
        }
        for (int i = 0; i < worms.size(); i++) {
            blowUp(Math.toRadians(directionToTurnTo(worms.get(i).getX(), worms.get(i).getY())), (((-0.5/explosionsRadius)*getObjectsDistance(worms.get(i), this))+0.5), worms.get(i));
        }
        for (int i = 0; i < graves.size(); i++) {
            blowUp(Math.toRadians(directionToTurnTo(graves.get(i).getX(), graves.get(i).getY())), (((-0.3/explosionsRadius)*getObjectsDistance(graves.get(i), this))+0.4), graves.get(i));
        }
        for (int i = 0; i < oilDrums.size(); i++) {
            oilDrums.get(i).explode();
        }
        destroyWorld(getX(), getY(), (int) (explosionsRadius*0.4));
        getWorld().addObject(new Explosion(2), getX(), getY());
        getWorld().removeObject(this);
    }
}
