import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;

/**
 * Write a description of class Oil_Drum here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Oil_Drum extends Other_Weapons
{
    public static final int EXPLOSIONS_RADIUS = 175;
    
    private int fallingCounter = 0;
    
    private boolean falling = false;
    
    public Oil_Drum() {
        scaleImage(getImage(), 60);
    }
    
    /**
     * Call the run method to run the game if the game is executed.
     */
    public void act() {
        if (getWorld().getObjects(Break_Menu.class).isEmpty()) {
            run();
        }
    }
    
    public void run() {
        if (((Worms_Land) getWorld()).getMaterialAt(getX(), getY()+15).getMaterial() == 2) {
            fallingCounter++;
            setLocation(getX(), (int) (getY()+(((Worms_Land) getWorld()).GRAVITY*fallingCounter)));
            falling = true;
        }
        else if (((Worms_Land) getWorld()).getMaterialAt(getX(), getY()+15).getMaterial() == 1) {
            if (falling) {
                falling = false;
                fallingCounter = 0;
            }
        }
        else if (((Worms_Land) getWorld()).getMaterialAt(getX(), getY()+15).getMaterial() == 3) {
            GreenfootSound water = new GreenfootSound("splash.wav");
            water.setVolume(Settings.effectVolume);
            if (fallingCounter < 50) {
                if (fallingCounter < 30) {
                    water.setVolume((int) (30.0*100.0/50.0));
                }
                else {
                    water.setVolume((int) ((double)fallingCounter*100.0/50.0));
                }
            }
            water.play();
            getWorld().removeObject(this);
            return;
        }
    }
    
    public void explode() {
        List<Worm> worms = getObjectsInRange(EXPLOSIONS_RADIUS, Worm.class);
        List<Grave_Stone> graves = getObjectsInRange(EXPLOSIONS_RADIUS, Grave_Stone.class);
        List<Mine> mines = getObjectsInRange(EXPLOSIONS_RADIUS, Mine.class);
        int damage;
        for (int i = 0; i < worms.size(); i++) {
            damage = (int) (-0.241*getObjectsDistance(this, worms.get(i))+42.175);
            if (damage > 35) {
                damage = 35;
            }
            kill(worms.get(i), damage);
        }
        for (int i = 0; i < worms.size(); i++) {
            blowUp(Math.toRadians(directionToTurnTo(worms.get(i).getX(), worms.get(i).getY())), (((-0.5/EXPLOSIONS_RADIUS)*getObjectsDistance(worms.get(i), this))+0.5), worms.get(i));
        }
        for (int i = 0; i < graves.size(); i++) {
            blowUp(Math.toRadians(directionToTurnTo(graves.get(i).getX(), graves.get(i).getY())), (((-0.3/EXPLOSIONS_RADIUS)*getObjectsDistance(graves.get(i), this))+0.4), graves.get(i));
        }
        for (int i = 0; i < mines.size(); i++) {
            blowUp(Math.toRadians(directionToTurnTo(mines.get(i).getX(), mines.get(i).getY())), (((-0.2/EXPLOSIONS_RADIUS)*getObjectsDistance(mines.get(i), this))+0.2), mines.get(i));
        }
        destroyWorld(getX(), getY(), (int) (EXPLOSIONS_RADIUS*0.5));
        getWorld().addObject(new Explosion(2.5), getX(), getY());
        getWorld().removeObject(this);
    }
}
