import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
import java.awt.Point;

/**
 * Write a description of class Players here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Players extends Actor
{
    private static Worm worm;
    
    public static double getVelX(double angleRadians, double forceFactor) {
        return Math.cos(angleRadians) * (Worms_Land.MIN_FORCE + forceFactor * (Worms_Land.MAX_FORCE - Worms_Land.MIN_FORCE));
    }
    
    public static double getVelY(double angleRadians, double forceFactor) {
        return -Math.sin(angleRadians) * (Worms_Land.MIN_FORCE + forceFactor * (Worms_Land.MAX_FORCE - Worms_Land.MIN_FORCE));
    }
    
    public void fire(double angleRadians, double forceFactor) {
        final int minDegrees = -180 + Worms_Land.LOWEST_ANGLE;
        final int maxDegrees = -Worms_Land.LOWEST_ANGLE;
        if (angleRadians < Math.toRadians(minDegrees) || angleRadians > Math.toRadians(maxDegrees)) {
            throw new IllegalArgumentException("Angle (" + Math.toDegrees(angleRadians) + ") outside acceptable range: " + minDegrees + " to " + maxDegrees);
        }
        if (forceFactor < 0 || forceFactor > 1) {
            throw new IllegalArgumentException("Force factor out of range");
        }
        double vx = getVelX(angleRadians, forceFactor);
        double vy = getVelY(angleRadians, forceFactor);
        if (worm != null && !((Worms_Land) getWorld()).getWeaponThrown()) {
            switch (worm.getWeaponUsing()) {
                case 1:
                    getWorld().addObject(new Bazooka(worm, vx, vy), getX(), getY());
                    ((Worms_Land) getWorld()).setWeaponThrown(true);
                    worm.setShoot(true);
                    ((Worms_Land) getWorld()).getWeaponPackage().setWeaponNumber(worm.getParty(), 1, -1);
                    break;
                case 2:
                    getWorld().addObject(new Grenade(worm, vx, vy, (worm.getCountdownTime() > 0 && worm.getCountdownTime() <= 5 ? worm.getCountdownTime() : 5)), getX(), getY());
                    ((Worms_Land) getWorld()).setWeaponThrown(true);
                    worm.setShoot(true);
                    ((Worms_Land) getWorld()).getWeaponPackage().setWeaponNumber(worm.getParty(), 2, -1);
                    if (Greenfoot.getRandomNumber(10) > 8) {
                        ((Worms_Land) getWorld()).setClaim(7, Greenfoot.getRandomNumber(2)+3, ((Worms_Land) getWorld()).getExecutingWorm());
                    }
                    break;
                case 3:
                    getWorld().addObject(new Clustergrenade(worm, vx, vy, (worm.getCountdownTime() > 0 && worm.getCountdownTime() <= 5 ? worm.getCountdownTime() : 5), false), getX(), getY());
                    ((Worms_Land) getWorld()).setWeaponThrown(true);
                    worm.setShoot(true);
                    ((Worms_Land) getWorld()).getWeaponPackage().setWeaponNumber(worm.getParty(), 3, -1);
                    if (Greenfoot.getRandomNumber(10) > 8) {
                        ((Worms_Land) getWorld()).setClaim(7, Greenfoot.getRandomNumber(2)+3, ((Worms_Land) getWorld()).getExecutingWorm());
                    }
                    break;
                case 4:
                    //Bullet added by Shotgun;
                    //Claim added in Worm;
                    ((Worms_Land) getWorld()).setWeaponThrown(true);
                    worm.setShoot(true);
                    ((Worms_Land) getWorld()).getWeaponPackage().setWeaponNumber(worm.getParty(), 4, -1);
                    break;
                case 5:
                    Seeking_Missile missile = new Seeking_Missile(worm, vx, vy);
                    missile.setTargetX(worm.getMissileX());
                    missile.setTargetY(worm.getMissileY());
                    worm.setMissileTarget(false);
                    getWorld().addObject(missile, getX(), getY());
                    ((Worms_Land) getWorld()).setWeaponThrown(true);
                    worm.setShoot(true);
                    ((Worms_Land) getWorld()).getWeaponPackage().setWeaponNumber(worm.getParty(), 5, -1);
                    break;
                case 6:
                    if (worm.getImageLeft()) {
                        getWorld().addObject(new Dynamite(worm, -1.0, 0.5), getX()-15, getY()-10);
                    }
                    else {
                        getWorld().addObject(new Dynamite(worm, 1.0, 0.5), getX()+15, getY()-10);
                    }
                    ((Worms_Land) getWorld()).setWeaponThrown(true);
                    worm.setShoot(true);
                    ((Worms_Land) getWorld()).getWeaponPackage().setWeaponNumber(worm.getParty(), 6, -1);
                    if (Greenfoot.getRandomNumber(10) > 6) {
                        ((Worms_Land) getWorld()).setClaim(7, Greenfoot.getRandomNumber(2)+3, ((Worms_Land) getWorld()).getExecutingWorm());
                    }
                    break;
                case 7:
                    if (worm.getImageLeft()) {
                        if (worm.getArtificialIntelligence()) {
                            getWorld().addObject(new Sheep(worm, worm.getTarget(), -1.0, 0.5), getX()-15, getY()-10);
                        }
                        else {
                            getWorld().addObject(new Sheep(worm, -1.0, 0.5), getX()-15, getY()-10);
                        }
                    }
                    else {
                        if (worm.getArtificialIntelligence()) {
                            getWorld().addObject(new Sheep(worm, worm.getTarget(), 1.0, 0.5), getX()+15, getY()-10);
                        }
                        else {
                            getWorld().addObject(new Sheep(worm, 1.0, 0.5), getX()+15, getY()-10);
                        }
                    }
                    ((Worms_Land) getWorld()).setWeaponThrown(true);
                    worm.setShoot(true);
                    ((Worms_Land) getWorld()).getWeaponPackage().setWeaponNumber(worm.getParty(), 7, -1);
                    break;
                case 8:
                    //Claim added in Baseball_Bat;
                    worm.getBaseballBat().setHit(true);
                    ((Worms_Land) getWorld()).setWeaponThrown(true);
                    worm.setShoot(true);
                    ((Worms_Land) getWorld()).getWeaponPackage().setWeaponNumber(worm.getParty(), 8, -1);
                    break;
                case 9:
                    getWorld().addObject(new Holly_Grenade(worm, vx, vy), getX(), getY());
                    ((Worms_Land) getWorld()).setWeaponThrown(true);
                    worm.setShoot(true);
                    ((Worms_Land) getWorld()).getWeaponPackage().setWeaponNumber(worm.getParty(), 9, -1);
                    if (Greenfoot.getRandomNumber(10) > 8) {
                        ((Worms_Land) getWorld()).setClaim(7, Greenfoot.getRandomNumber(2)+3, ((Worms_Land) getWorld()).getExecutingWorm());
                    }
                    break;
                case 10:
                    getWorld().addObject(new Bananabomb(worm, vx, vy, (worm.getCountdownTime() > 0 && worm.getCountdownTime() <= 5 ? worm.getCountdownTime() : 5), false), getX(), getY());
                    ((Worms_Land) getWorld()).setWeaponThrown(true);
                    worm.setShoot(true);
                    ((Worms_Land) getWorld()).getWeaponPackage().setWeaponNumber(worm.getParty(), 10, -1);
                    if (Greenfoot.getRandomNumber(10) > 8) {
                        ((Worms_Land) getWorld()).setClaim(7, Greenfoot.getRandomNumber(2)+3, ((Worms_Land) getWorld()).getExecutingWorm());
                    }
                    break;
            }
        }
        else {
            searchForExecutingWorm();
        }
    }
    public void fireValues(double vx, double vy) {
        final int minDegrees = -180 + Worms_Land.LOWEST_ANGLE;
        final int maxDegrees = -Worms_Land.LOWEST_ANGLE;
        if (worm != null && !((Worms_Land) getWorld()).getWeaponThrown()) {
            switch (worm.getWeaponUsing()) {
                case 1:
                    getWorld().addObject(new Bazooka(worm, vx, vy), getX(), getY());
                    ((Worms_Land) getWorld()).setWeaponThrown(true);
                    worm.setShoot(true);
                    ((Worms_Land) getWorld()).getWeaponPackage().setWeaponNumber(worm.getParty(), 1, -1);
                    break;
                case 2:
                    getWorld().addObject(new Grenade(worm, vx, vy, (worm.getCountdownTime() > 0 && worm.getCountdownTime() <= 5 ? worm.getCountdownTime() : 5)), getX(), getY());
                    ((Worms_Land) getWorld()).setWeaponThrown(true);
                    worm.setShoot(true);
                    ((Worms_Land) getWorld()).getWeaponPackage().setWeaponNumber(worm.getParty(), 2, -1);
                    break;
                case 3:
                    getWorld().addObject(new Clustergrenade(worm, vx, vy, (worm.getCountdownTime() > 0 && worm.getCountdownTime() <= 5 ? worm.getCountdownTime() : 5), false), getX(), getY());
                    ((Worms_Land) getWorld()).setWeaponThrown(true);
                    worm.setShoot(true);
                    ((Worms_Land) getWorld()).getWeaponPackage().setWeaponNumber(worm.getParty(), 3, -1);
                    break;
                case 4:
                    //Bullet added by Shotgun;
                    ((Worms_Land) getWorld()).setWeaponThrown(true);
                    worm.setShoot(true);
                    ((Worms_Land) getWorld()).getWeaponPackage().setWeaponNumber(worm.getParty(), 4, -1);
                    break;
                case 5:
                    Seeking_Missile missile = new Seeking_Missile(worm, vx, vy);
                    missile.setTargetX(worm.getMissileX());
                    missile.setTargetY(worm.getMissileY());
                    worm.setMissileTarget(false);
                    getWorld().addObject(missile, getX(), getY());
                    ((Worms_Land) getWorld()).setWeaponThrown(true);
                    worm.setShoot(true);
                    ((Worms_Land) getWorld()).getWeaponPackage().setWeaponNumber(worm.getParty(), 5, -1);
                    break;
                case 6:
                    if (worm.getImageLeft()) {
                        getWorld().addObject(new Dynamite(worm, -1.0, 0.5), getX()-15, getY()-10);
                    }
                    else {
                        getWorld().addObject(new Dynamite(worm, 1.0, 0.5), getX()+15, getY()-10);
                    }
                    ((Worms_Land) getWorld()).setWeaponThrown(true);
                    worm.setShoot(true);
                    ((Worms_Land) getWorld()).getWeaponPackage().setWeaponNumber(worm.getParty(), 6, -1);
                    break;
                case 7:
                    if (worm.getImageLeft()) {
                        if (worm.getArtificialIntelligence()) {
                            getWorld().addObject(new Sheep(worm, worm.getTarget(), -1.0, 0.5), getX()-15, getY()-10);
                        }
                        else {
                            getWorld().addObject(new Sheep(worm, -1.0, 0.5), getX()-15, getY()-10);
                        }
                    }
                    else {
                        if (worm.getArtificialIntelligence()) {
                            getWorld().addObject(new Sheep(worm, worm.getTarget(), 1.0, 0.5), getX()+15, getY()-10);
                        }
                        else {
                            getWorld().addObject(new Sheep(worm, 1.0, 0.5), getX()+15, getY()-10);
                        }
                    }
                    ((Worms_Land) getWorld()).setWeaponThrown(true);
                    worm.setShoot(true);
                    ((Worms_Land) getWorld()).getWeaponPackage().setWeaponNumber(worm.getParty(), 7, -1);
                    break;
                case 8:
                    worm.getBaseballBat().setHit(true);
                    ((Worms_Land) getWorld()).setWeaponThrown(true);
                    worm.setShoot(true);
                    ((Worms_Land) getWorld()).getWeaponPackage().setWeaponNumber(worm.getParty(), 8, -1);
                    break;
                case 9:
                    getWorld().addObject(new Holly_Grenade(worm, vx, vy), getX(), getY());
                    ((Worms_Land) getWorld()).setWeaponThrown(true);
                    worm.setShoot(true);
                    ((Worms_Land) getWorld()).getWeaponPackage().setWeaponNumber(worm.getParty(), 9, -1);
                    break;
                case 10:
                    getWorld().addObject(new Bananabomb(worm, vx, vy, (worm.getCountdownTime() > 0 && worm.getCountdownTime() <= 5 ? worm.getCountdownTime() : 5), false), getX(), getY());
                    ((Worms_Land) getWorld()).setWeaponThrown(true);
                    worm.setShoot(true);
                    ((Worms_Land) getWorld()).getWeaponPackage().setWeaponNumber(worm.getParty(), 10, -1);
                    break;
            }
        }
        else {
            searchForExecutingWorm();
        }
    }
    
    public static void setWorm(Worm w) {
        worm = w;
    }
    private void searchForExecutingWorm() {
        List<Worm> worms = getWorld().getObjects(Worm.class);
        for (int i = 0; i < worms.size(); i++) {
            if (worms.get(i).getExecuting()) {
                this.worm = worms.get(i);
                return;
            }
        }
    }
    
    public double getAbsoluteDistance(double x, double y) {
        return Math.hypot(x - getX(), y - getY());
    }
    
    public double getRelativeDistance(double deltaX, double deltaY) {
        return Math.hypot(deltaX, deltaY);
    }
    
    public double getObjectsDistance(Actor a, Actor b) {
        return Math.hypot(a.getX() - b.getX(), a.getY() - b.getY());
    }
    
    public double getPointsDistance(Point p1, Point p2) {
        return Math.hypot(p1.getX() - p2.getX(), p1.getY() - p2.getY());
    }
    
    public void scaleImage(GreenfootImage img, int size) {
        img.scale((img.getWidth()*size/100), (img.getHeight()*size/100));
    }
    
    public void changeImage(GreenfootImage img) {
        getImage().clear();
        getImage().scale(img.getWidth(), img.getHeight());
        getImage().drawImage(img, 0, 0);
    }
    
    public void move(double angle, int speed) {
        angle = Math.toRadians(angle);
        setLocation((int) (getX() + Math.cos(angle) * speed), (int) (getY() + Math.sin(angle) * speed));
    }
    public double[] move(double currentX, double currentY, double angle, double speed) {
        double[] coordinates = new double[2];
        angle = Math.toRadians(angle);
        coordinates[0] = currentX + Math.cos(angle) * speed;
        coordinates[1] = currentY + Math.sin(angle) * speed;
        return coordinates;
    }
    
    private boolean mouseOnObject(Actor actor) {
        FullScreenMouseInfo mouse = FullScreenWindow.getMouseInfo();
        return mouse != null && mouse.getX() > actor.getX() - actor.getImage().getWidth()/2 && mouse.getX() < actor.getX() + actor.getImage().getWidth()/2 && 
            mouse.getY() > actor.getY() - actor.getImage().getHeight()/2 && mouse.getY() < actor.getY() + actor.getImage().getHeight()/2;
    }
    
    public boolean found(java.lang.Class clss) {
        return getOneObjectAtOffset(0, 0, clss) != null;
    }
    
    public void turnTo(double x, double y) {
        setDirection(x - getX(), y - getY());
    }
    
    public double directionToTurnTo(double x, double y) {
        return direction(x - getX(), y - getY());
    }
    
    public double direction(double deltaX, double deltaY) {
        double direction;
        if(deltaX == 0 && deltaY == 0) {
            direction = 0;
        }
        else if(deltaX == 0 && deltaY < 0) {
            direction = -90;
        }
        else if(deltaX == 0 && deltaY > 0) {
            direction = 90;
        }
        else if(deltaX > 0 && deltaY == 0) {
            direction = 0;
        }
        else if(deltaX < 0 && deltaY == 0) {
            direction = 180;
        }
        else {
            int w = (int) Math.toDegrees(Math.atan((double) deltaY / (double) deltaX));
            if(deltaX > 0) {
                direction = w;
            }
            else {
                direction = 180 + w;
            }
        }
        return direction;
    }

    public void setDirection(double deltaX, double deltaY) {
        int direction;
        if(deltaX == 0 && deltaY == 0) {
            direction = 0;
        }
        else if(deltaX == 0 && deltaY < 0) {
            direction = -90;
        }
        else if(deltaX == 0 && deltaY > 0) {
            direction = 90;
        }
        else if(deltaX > 0 && deltaY == 0) {
            direction = 0;
        }
        else if(deltaX < 0 && deltaY == 0) {
            direction = 180;
        }
        else {
            int w = (int) Math.toDegrees(Math.atan((double) deltaY / (double) deltaX));
            if(deltaX > 0) {
                direction = w;
            }
            else {
                direction = 180 + w;
            }
        }
        setRotation(direction);
    }
    
    public double getDegreesToFrom(Point P1, Point P2) {
        return getDegreesToFrom(P1.getX(), P1.getY(), P2.getX(), P2.getY());
    }
    
    public double getDegreesToFrom(double x1, double y1, double x, double y) {
        return Math.toDegrees(Math.atan2(y1-y, x1-x));
    }
    
    public static double Pos(double a) {
        if(a < 0) {
            return -a;
        }
        return a;
    }
}
