import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;

/**
 * Write a description of class Uzi here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Seeking_Missile extends Weapon
{
    private double velX;
    private double exactX;
    private double exactY;
    private double velY;
    private double rotation = 0;
    
    public static final int EXPLOSIONS_RADIUS = 150;
    
    private int seekingCounter = 0;
    private int turningCounter = 0;
    private int targetX = 0;
    private int targetY = 0;
    
    private boolean foundPosition = false;
    private boolean soundPlayed = false;
    private boolean water = false;
    
    private Worm worm;
    
    public Seeking_Missile(Worm worm, double vx, double vy) {
        this.worm = worm;
        velX = vx;
        velY = vy;
        scaleImage(getImage(), 40);
    }
    
    /**
     * Call the run method to run the game if the game is executed.
     */
    public void act() {
        if (getWorld().getObjects(Break_Menu.class).isEmpty()) {
            run();
        }
    }
    
    public void run() {
        if (seekingCounter < 50) {
            if (((Worms_Land) getWorld()).getMaterialAt((int) (getX() + velX), (int) (getY() - velY)).getMaterial() == 1 || foundEnemyWorm() || foundOilDrum()) {
                explode();
                return;
            }
            fly();
            setRotation((int) (Math.toDegrees(Math.atan2(velX, velY)))-90);
            seekingCounter++;
        }
        else {
            if (!soundPlayed) {
                GreenfootSound weaponHoming = new GreenfootSound("weaponhoming.wav");
                weaponHoming.setVolume(Settings.effectVolume);
                weaponHoming.play();
                soundPlayed = true;
            }
            if (((Worms_Land) getWorld()).getMaterialAt((int) (getX() + velX), (int) (getY() - velY)).getMaterial() == 1 || foundEnemyWorm() || foundOilDrum()) {
                explode();
                return;
            }
            else{
                move(10);
            }
            if (seekingCounter > 400) {
                explode();
                return;
            }
            else {
                seekingCounter++;
            }
            if (rotation == 0) {
                rotation = directionToTurnTo(targetX, targetY);
            }
            if (!foundPosition) {
                if (rotation > 100) {
                    if (turningCounter < 25) {
                        turn(turningCounter/25);
                        turningCounter++;
                    }
                    else {
                        turnTo(targetX, targetY);
                    }
                }
                else if (rotation > 50) {
                    if (turningCounter < 15) {
                        turn(turningCounter/15);
                        turningCounter++;
                    }
                    else {
                        turnTo(targetX, targetY);
                    }
                }
                else {
                    if (turningCounter < 10) {
                        turn(turningCounter/10);
                        turningCounter++;
                    }
                    else {
                        turnTo(targetX, targetY);
                    }
                }
                if (getX() > targetX-25 && getX() < targetX+25 && getY() > targetY-25 && getY() < targetY+25) {
                    foundPosition = true;
                }
            }
        }
        if (((Worms_Land) getWorld()).getMaterialAt((int) (getX() + velX), (int) (getY() - velY)).getMaterial() == 3) {
            if (!water) {
                GreenfootSound water = new GreenfootSound("splash.wav");
                water.setVolume(Settings.effectVolume);
                if (velY < -5) {
                    if (velY < -3) {
                        water.setVolume((int) Math.abs(3*100/5));
                    }
                    else {
                        water.setVolume((int) Math.abs(velY*100/5));
                    }
                }
                water.play();
            }
            water = true;
            getWorld().removeObject(this);
            return;
        }
    }
    
    private boolean foundEnemyWorm() {
        List<Worm> worms = getWorld().getObjectsAt((int) (getX()+velX), (int) (getY()+velY), Worm.class);
        for (int i = 0; i < worms.size(); i++) {
            if (!worms.get(i).getExecuting()) {
                return true;
            }
        }
        return false;
    }
    
    private boolean foundOilDrum() {
        return getWorld().getObjectsAt((int) (getX() + velX), (int) (getY() + velY), Oil_Drum.class).size() != 0;
    }
    
    private void fly() {
        velY -= Worms_Land.GRAVITY;
        velX += Worms_Land.WIND;
        setLocation((int) (exactX + velX), (int) (exactY - velY));
    }
    
    public void setLocation(int x, int y) {
        exactX = x;
        exactY = y;
        super.setLocation(x, y);
    }
    
    public void setExactLocation(double x, double y) {
        exactX = x;
        exactY = y;
        super.setLocation((int) (x + 0.5), (int) (y + 0.5));
    }
    
    private void explode() {
        List<Worm> worms = getObjectsInRange(EXPLOSIONS_RADIUS, Worm.class);
        List<Grave_Stone> graves = getObjectsInRange(EXPLOSIONS_RADIUS, Grave_Stone.class);
        List<Mine> mines = getObjectsInRange(EXPLOSIONS_RADIUS, Mine.class);
        List<Oil_Drum> oilDrums = getObjectsInRange(EXPLOSIONS_RADIUS, Oil_Drum.class);
        int damage;
        for (int i = 0; i < worms.size(); i++) {
            damage = (int) (-0.375*getObjectsDistance(this, worms.get(i))+56.25);
            if (damage > 45) {
                damage = 45;
            }
            kill(worms.get(i), damage);
        }
        for (int i = 0; i < worms.size(); i++) {
            blowUp(Math.toRadians(directionToTurnTo(worms.get(i).getX(), worms.get(i).getY())), (((-0.5/EXPLOSIONS_RADIUS)*getObjectsDistance(worms.get(i), this))+0.5), worms.get(i));
        }
        for (int i = 0; i < graves.size(); i++) {
            blowUp(Math.toRadians(directionToTurnTo(graves.get(i).getX(), graves.get(i).getY())), (((-0.3/EXPLOSIONS_RADIUS)*getObjectsDistance(graves.get(i), this))+0.4), graves.get(i));
        }
        for (int i = 0; i < mines.size(); i++) {
            blowUp(Math.toRadians(directionToTurnTo(mines.get(i).getX(), mines.get(i).getY())), (((-0.2/EXPLOSIONS_RADIUS)*getObjectsDistance(mines.get(i), this))+0.2), mines.get(i));
        }
        for (int i = 0; i < oilDrums.size(); i++) {
            oilDrums.get(i).explode();
        }
        destroyWorld(getX(), getY(), (int) (EXPLOSIONS_RADIUS*0.4));
        getWorld().addObject(new Explosion(2), getX(), getY());
        getWorld().removeObject(this);
    }
    
    public int getTragetX() {
        return targetX;
    }
    public void setTargetX(int x) {
        targetX = x;
    }
    
    public int getTragetY() {
        return targetY;
    }
    public void setTargetY(int y) {
        targetY = y;
    }
    
    public void setMagneticInfluence(double vx, double vy) {
        velX += vx;
        velY += vy;
    }
}
