import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.awt.Font;
import java.util.ArrayList;

/**
 * Write a description of class Settings_Menu here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Settings_Menu extends Menu
{
    private int x;
    private int y;
    
    private boolean textChanged = true;
    private boolean initialised = false;
    
    private Profile currentUsingProfile = (Settings.profile == null ? new Profile(new String[] {"<no profile>", "", "", "", "", ""}) : Settings.profile);
    
    private Main_Menu main;
    
    private Dropdown_List list;
    
    private SlideBar musicVolume = new SlideBar(200, Settings.musicVolume, 100, Color.black, Color.black, new Color(0, 0, 0, 0));
    private SlideBar effectVolume = new SlideBar(200, Settings.effectVolume, 100, Color.black, Color.black, new Color(0, 0, 0, 0));
    
    public Settings_Menu(Main_Menu main) {
        this.main = main;
        changeImage(new GreenfootImage("Settings_Menu.jpg"));
    }
    
    public void act() {
        if (getWorld().getObjects(Map_Settings_Menu.class).isEmpty() && getWorld().getObjects(Profile_Menu.class).isEmpty() && getWorld().getObjects(Key_Menu.class).isEmpty() && 
            getWorld().getObjects(Profile_Menu.class).isEmpty()) {
            run();
        }
    }
    
    public void run() {
        FullScreenMouseInfo mouse = FullScreenWindow.getMouseInfo();
        if (mouse != null) {
            x = mouse.getX();
            y = mouse.getY();
        }
        if (!initialised) {
            getWorld().addObject(musicVolume, 950, 300);
            getWorld().addObject(effectVolume, 950, 465);
            initialised = true;
        }
        if (textChanged) {
            getImage().setColor(new Color(14, 0, 181, 255));
            getImage().fillRect(65, 182, 275, 41);
            getImage().setFont(new Font("", 0, 25));
            getImage().setColor(Color.black);
            getImage().drawString(currentUsingProfile.getProfileName(), 75, 212); 
        }
        if (FullScreenWindow.mouseClicked(null)) {
            if (x > 360 && x < 405 && y > 190 && y < 220) {
                //Profile Selection;
                if (getWorld().getObjects(Dropdown_List.class).isEmpty()) {
                    ArrayList<Profile> profiles = new ArrayList<Profile>();
                    /*Profile temp;
                    for (int i = 0; i < 10; i++) {
                        temp = new Profile(i+1);
                        if (!temp.getProfileName().equals("")) {
                            profiles.add(temp);
                        }
                        else {
                            break;
                        }
                    }
                    list = new Dropdown_List(profiles, this);*/
                    getWorld().addObject(list, 242, 230 + list.getImage().getHeight()/2);
                }
                else {
                    getWorld().removeObjects(getWorld().getObjects(Dropdown_List.class));
                }
            }
            if (x > 480 && x < 700) {
                if (y > 175 && y < 230) {
                    //New Profile;
                    try {
                        list.remove();
                    }
                    catch (NullPointerException npe) {
                        //npe.printStackTrace();
                    }
                    getWorld().addObject(new Profile_Menu(), 600, 350);
                }
                if (y > 255 && y < 310) {
                    //Delete Profile;
                    getWorld().addObject(new Dialog_Menu(currentUsingProfile, this), 600, 350);
                }
                if (y > 340 && y < 395) {
                    //Map Settings;
                    try {
                        list.remove();
                    }
                    catch (NullPointerException npe) {
                        //npe.printStackTrace();
                    }
                    getWorld().addObject(new Map_Settings_Menu(main), 600, 350);
                }
                if (y > 420 && y < 475) {
                    //Key Menu;
                    try {
                        list.remove();
                    }
                    catch (NullPointerException npe) {
                        //npe.printStackTrace();
                    }
                    getWorld().addObject(new Key_Menu(), 600, 350);
                }
            }
            if (y > 610 && y < 660) {
                if (x > 330 && x < 550) {
                    //Back;
                    getWorld().removeObjects(getWorld().getObjects(Dropdown_List.class));
                    getWorld().removeObject(musicVolume);
                    getWorld().removeObject(effectVolume);
                    getWorld().removeObject(this);
                } 
                if (x > 610 && x < 835) {
                    //Finished;
                    if (!currentUsingProfile.getTeamName().equals("")) {
                        Settings.profile = currentUsingProfile;
                    }
                    Settings.musicVolume = musicVolume.getValue();
                    Settings.effectVolume = effectVolume.getValue();
                    Settings.saveSettings();
                    getWorld().removeObjects(getWorld().getObjects(Dropdown_List.class));
                    getWorld().removeObject(musicVolume);
                    getWorld().removeObject(effectVolume);
                    getWorld().removeObject(this);
                } 
            }
        }
        //System.out.println(x + " " + y);
    }
    
    public void setProfile(Profile profile) {
        this.currentUsingProfile = profile;
        textChanged = true;
    }
}
