import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Shotgun here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Shotgun extends Weapon
{
    private Worm worm;
    
    private int counter = 0;
    private int counter2 = 0;
    
    private boolean imageLeft = false;
    private boolean initialised = false;
    
    public Shotgun(Worm worm) {
        this.worm = worm;
        scaleImage(getImage(), 40);
    }
    
    public void addedToWorld(World world) {
        initialised = false;
        counter2 = 0;
    }
    
    /**
     * Call the run method to run the game if the game is executed.
     */
    public void act() {
        if (getWorld().getObjects(Break_Menu.class).isEmpty()) {
            run();
        }
    }
    
    public void run() {
        FullScreenMouseInfo mouse = FullScreenWindow.getMouseInfo();
        if (worm != null) {
            if (worm.getWeaponUsing() != 4 || !worm.getExecuting()) {
                getWorld().removeObject(this);
                return;
            }
        }
        if (!initialised) {
            if (counter2 >= 10) {
                GreenfootSound reload = new GreenfootSound("shotgunreload.wav");
                reload.setVolume(Settings.effectVolume);
                reload.play();
                initialised = true;
                counter2 = 0;
            }
            counter2++;
        }
        if (counter > 0 && counter < 25) {
            counter++;
        }
        else if (counter >= 25) {
            GreenfootSound reload = new GreenfootSound("shotgunreload.wav");
            reload.setVolume(Settings.effectVolume);
            reload.play();
            counter = 0;
        }
        if (mouse != null && !worm.getArtificialIntelligence()) {
            if (worm.getImageLeft()) {
                if (!imageLeft) {
                    getImage().mirrorHorizontally();
                    imageLeft = true;
                }
                if (directionToTurnTo(mouse.getX(), mouse.getY()) > 105 && directionToTurnTo(mouse.getX(), mouse.getY()) < 255) {
                    turnTo(mouse.getX(), mouse.getY());
                    turn(180);
                }
                setLocation(worm.getX()-15, worm.getY()+5);
            }
            else {
                if (imageLeft) {
                    getImage().mirrorHorizontally();
                    imageLeft = false;
                }
                if (directionToTurnTo(mouse.getX(), mouse.getY()) > 285 || directionToTurnTo(mouse.getX(), mouse.getY()) < 75) {
                    turnTo(mouse.getX(), mouse.getY());
                }
                setLocation(worm.getX()+15, worm.getY()+5);
            }
        }
        else if (worm.getArtificialIntelligence()) {
            if (worm.getImageLeft()) {
                if (!imageLeft) {
                    getImage().mirrorHorizontally();
                    imageLeft = true;
                }
                setLocation(worm.getX()-15, worm.getY()+5);
            }
            else {
                if (imageLeft) {
                    getImage().mirrorHorizontally();
                    imageLeft = false;
                }
                setLocation(worm.getX()+15, worm.getY()+5);
            }
        }
    }
    
    public boolean shoot() {
        FullScreenMouseInfo mouse = FullScreenWindow.getMouseInfo();
        if (mouse != null) {
            if (worm.getImageLeft()) {
                if (directionToTurnTo(mouse.getX(), mouse.getY()) > 105 && directionToTurnTo(mouse.getX(), mouse.getY()) < 255) {
                    addBullet(mouse.getX(), mouse.getY());
                    return true;
                }
            }
            else {
                if (directionToTurnTo(mouse.getX(), mouse.getY()) > 285 || directionToTurnTo(mouse.getX(), mouse.getY()) < 75) {
                    addBullet(mouse.getX(), mouse.getY());
                    return true;
                }
            }
        }
        return false;
    }
    
    public void addBullet(int x, int y) {
        Greenfoot.playSound("shotgunfire.wav");
        counter = 1;
        double angle = Math.atan2((y - getY()), (x - getX()));
        double vx = getVelX(angle, 1);
        double vy = getVelY(angle, 1);
        getWorld().addObject(new Bullet(worm, this, vx, vy), getX(), getY());
    }
}
