import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.awt.Font;

/**
 * Write a description of class SlideBar here.
 * 
 * @author (Moritz L.(Busch2207)) 
 * @version (27.09.2012)
 */
public class SlideBar extends Menu
{
    private int i_MaxValue;
    private int i_Value;
    private int i_SlideLocation;
    private int i_width;
    
    private boolean b_changedSinceLastTime = false;
    
    private Color col_slideBar;
    private Color col_Number;
    private Color col_rect;
    private Color col_back;
    
    public static final GreenfootImage gi_sf_Slide = new GreenfootImage("Slide.gif");

    public SlideBar(int width, int StartValue, int MaxValue, Color BarColor) {
        this(width, StartValue, MaxValue, BarColor, new Color(0, 0, 0, 0), new Color(0, 0, 0, 0), new Color(0, 0, 0, 0));
    }

    public SlideBar(int width, int StartValue, int MaxValue, Color BarColor, Color RectColor) {
        this(width, StartValue, MaxValue, BarColor, new Color(0, 0, 0, 0), RectColor, new Color(0, 0, 0, 0));
    }

    public SlideBar(int width, int StartValue, int MaxValue, Color BarColor, Color NumberColor, Color RectColor) {
        this(width, StartValue, MaxValue, BarColor, NumberColor, RectColor, new Color(0, 0, 0, 0));
    }

    public SlideBar(int width, int StartValue, int MaxValue, Color BarColor, Color NumberColor, Color RectColor, Color BackColor) {
        setImage(new GreenfootImage(width + gi_sf_Slide.getWidth(), gi_sf_Slide.getHeight() + (NumberColor.getAlpha()>0 ? 21 : 6)));
        getImage().setFont(new Font("", Font.ROMAN_BASELINE, 20));
        this.col_slideBar = BarColor;
        this.col_rect = RectColor;
        this.col_Number = NumberColor;
        this.col_back = BackColor;
        this.i_MaxValue = MaxValue;
        this.i_width = width;
        setValue(StartValue);
    }

    public void act() {
        if (FullScreenWindow.mouseDragged(this) || FullScreenWindow.mouseClicked(this)) {
            b_changedSinceLastTime = true;
            setSlideLocation(FullScreenWindow.getMouseInfo().getX() - getX() + i_width / 2 - (i_width % 2 == 0 ? 1 : 0));
        }
    }

    private void setSlideLocation(int i_mouseLocation) {
        if (i_mouseLocation<0) {
            i_mouseLocation=0;
        }
        if (i_mouseLocation>i_width) {
            i_mouseLocation=i_width;
        }
        this.i_SlideLocation = i_mouseLocation;
        i_Value = (int) ((double) i_mouseLocation / (double) i_width * (double) i_MaxValue);
        updateImage();
    }

    private void updateImage() {
        getImage().clear();
        getImage().setColor(col_back);
        getImage().fill();
        getImage().setColor(col_rect);
        getImage().drawRect(0, 0, getImage().getWidth()-1, getImage().getHeight()-1);
        getImage().setColor(col_slideBar);
        getImage().fillRect(gi_sf_Slide.getWidth()/2-1, 0, 3, 11);
        getImage().fillRect(i_width+gi_sf_Slide.getWidth()/2-1, 0, 3, 11);
        getImage().fillRect(getImage().getWidth()/2-1, 0, 3, 11);
        getImage().fillRect(gi_sf_Slide.getWidth()/2, 4, i_width, 3);
        getImage().drawImage(gi_sf_Slide, i_SlideLocation, 5);
        if (col_Number.getAlpha() != 0) {
            getImage().setColor(col_Number);
            getImage().drawString(i_Value+"", 0, 20+gi_sf_Slide.getHeight());
        }
    }

    public int getHeight() {
        return getImage().getHeight();
    }

    public void setValue(int i_newValue) {
        if (i_newValue<0) {
            i_newValue=0;
        }
        if (i_newValue>i_MaxValue) {
            i_newValue=i_MaxValue;
        }
        this.i_Value = i_newValue;
        i_SlideLocation = (int) ((double) i_Value / (double) i_MaxValue * (double) i_width);
        updateImage();
    }

    public int getValue() {
        b_changedSinceLastTime = false;
        return i_Value;
    }

    public boolean changed() {
        return b_changedSinceLastTime;
    }
}
