import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;

/**
 * Write a description of class SuperSheep here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class SuperSheep extends Weapon
{
    private double velX;
    private double velY;
    
    public static final int EXPLOSIONS_RADIUS = 250;
    
    private int fallingCounter = 0;
    private int jumpingCounter = 0;
    private int jumpBackCounter = 0;
    private int actingCounter = 0;
    private int soundCounter = 50;
    private int lastX = 0;
    private int lastY = 0;
    private int x = 0;
    private int y = 0;
    
    private boolean jump = false;
    private boolean jumpBack = false;
    private boolean falling = false;
    private boolean imageLeft = true;
    private boolean flying = false;
    private boolean initialised = false;
    
    private Worm worm;
    private Worm enemy;
    
    private Countdown countdown;
    
    public SuperSheep(Worm worm, double vx, double vy) {
        this.worm = worm;
        velX = vx;
        velY = vy;
        if (vx > 0) {
            getImage().mirrorHorizontally();
            imageLeft = false;
        }
        scaleImage(getImage(), 40);
    }
    
    public SuperSheep(Worm worm, Worm enemy, double vx, double vy) {
        this.worm = worm;
        this.enemy = enemy;
        velX = vx;
        velY = vy;
        if (vx > 0) {
            getImage().mirrorHorizontally();
            imageLeft = false;
        }
        scaleImage(getImage(), 40);
    }
    
    /**
     * Call the run method to run the game if the game is executed.
     */
    public void act() {
        if (getWorld().getObjects(Break_Menu.class).isEmpty()) {
            run();
        }
    }
    
    public void run() {
        if (!initialised) {
            if (worm != null) {
                if (((Worms_Land) getWorld()).getMaterialAt(getX(), getY()).getMaterial() == 1) {
                    setLocation(worm.getX(), worm.getY());
                }
            }
            initialised = true;
        }
        if (flying) {
            FullScreenMouseInfo mouse = FullScreenWindow.getMouseInfo();
            if (mouse!=null){
                x = mouse.getX();
                y = mouse.getY();
            }
            turnTo(x, y);
            move(5);
            double[] nextMovingPosition = move(getX(), getY(), getRotation(), 5);
            if (((Worms_Land) getWorld()).getMaterialAt((int) nextMovingPosition[0], (int) nextMovingPosition[1]).getMaterial() == 1) {
                explode();
            }
        }
        else{
            if (FullScreenWindow.mouseClicked(null)) {
                getImage().mirrorHorizontally();
                flying = true;
            }
            if (((Worms_Land) getWorld()).getMaterialAt(getX(), getY()+15).getMaterial() == 2) {
                //Air -> fall;
                fallingCounter++;
                setLocation(getX(), (int) (getY()+(((Worms_Land) getWorld()).GRAVITY*fallingCounter)));
                falling = true;
            }
            else if (((Worms_Land) getWorld()).getMaterialAt(getX(), getY()+15).getMaterial() == 3) {
                //Water -> die;
                GreenfootSound water = new GreenfootSound("splash.wav");
                water.setVolume(Settings.effectVolume);
                if (fallingCounter < 50) {
                    if (fallingCounter < 30) {
                        water.setVolume((int) (30.0*100.0/50.0));
                    }
                    else {
                        water.setVolume((int) ((double)fallingCounter*100.0/50.0));
                    }
                }
                water.play();
                getWorld().removeObject(countdown);
                getWorld().removeObject(this);
                return;
            }
            else {
                //Earth;
                if (falling) {
                    int fallingSpeed = (int) (((Worms_Land) getWorld()).GRAVITY*fallingCounter);
                    if (fallingSpeed > 10) {
                        //count damage;
                    }
                    falling = false;
                    fallingCounter = 0;
                }
                else {
                    for (int i = 0; i < 10 && (((Worms_Land) getWorld()).getMaterialAt(getX(), getY()+14).getMaterial() == 1 && ((Worms_Land) getWorld()).getMaterialAt(getX(), getY()+4).getMaterial() == 2); i++) {
                        setLocation(getX(), getY()-1);
                    }
                }
            }
            if (soundCounter == 0) {
                if (Greenfoot.getRandomNumber(100) > 97) {
                    Greenfoot.playSound("sheepbaa.wav");
                    soundCounter = 100;
                }
            }   
            else {
                soundCounter--;
            }
            if (lastX == getX() && lastY == getY()) {
                if (imageLeft) {
                    jumpBack = true;
                    velX = Math.random()*3+1;
                    velY = Math.random()*2+1;
                    setLocation(getX()+3, getY());
                }
                else {
                    jumpBack = true;
                    velX = Math.random()*3+1;
                    velY = Math.random()*2+1;
                    setLocation(getX()-3, getY());
                }
            }
            else {
                lastX = getX();
                lastY = getY();
            }
            if (jumpBack) {
                jumpBack();
            }
            else {
                jumpBackCounter = 0;
                if (jump) {
                    jump();
                }
                else {
                    if (Greenfoot.getRandomNumber(100) > 95) {
                        jump = true;
                        jumpingCounter = 0;
                        velY = Greenfoot.getRandomNumber(4)+3;
                    }
                }
            }
            if (imageLeft) {
                if (!moveLeft()) {
                    jumpBack = true;
                    velX = Math.random()*3+1;
                }
            }
            else {
                if (!moveRight()) {
                    jumpBack = true;
                    velX = Math.random()*3+1;
                }
            }
        }
        if (enemy != null) {
            if (getX() > enemy.getX()-25 && getX() < enemy.getX()+25) {
                explode();
                return;
            }
        }
    }
    
    private void move(double distance) {
        double angle = Math.toRadians(getRotation());
        int x = (int) (getX() + Math.cos(angle) * distance);
        int y = (int) (getY() + Math.sin(angle) * distance);
        setLocation(x, y);
    }
    
    private boolean moveLeft() {
        if (((Worms_Land) getWorld()).getMaterialAt(getX()-1, getY()).getMaterial() != 1) {
            setLocation(getX()-1, getY());
            return true;
        }
        return false;
    }
    
    private boolean moveRight() {
        if (((Worms_Land) getWorld()).getMaterialAt(getX()+1, getY()).getMaterial() != 1) {
            setLocation(getX()+1, getY());
            return true;
        }
        return false;
    }
    
    private void jump() {
        if (((Worms_Land) getWorld()).getMaterialAt((int) (getX()+velX), (int) (getY()-velY+5)).getMaterial() == 1 && jumpingCounter > 5) {
            velX = 0;
            velY = 0;
            jump = false;
        }
        else if (jumpingCounter > 25) {
            velX = 0;
            velY = 0;
            jump = false;
        }
        else {
            velY -= Worms_Land.GRAVITY;
            jumpingCounter++;
            if (((Worms_Land) getWorld()).getMaterialAt(getX(), (int) (getY()-velY+5)).getMaterial() != 1) {
                setLocation(getX(), (int) (getY() - velY));
            }
        }
    }
    
    private void jumpBack() {
        if (((Worms_Land) getWorld()).getMaterialAt((int) (getX()+velX), (int) (getY()-velY+5)).getMaterial() == 1 && jumpingCounter > 5) {
            velX = 0;
            velY = 0;
            jumpBack = false;
        }
        else if (jumpBackCounter > 25) {
            velX = 0;
            velY = 0;
            jumpBack = false;
        }
        else {
            velY -= Worms_Land.GRAVITY;
            velX -= 0.05;
            jumpBackCounter++;
            setLocation((int) (imageLeft ? getX() + velX : getX() - velX), (int) (getY() - velY));
        }
    }
    
    public void explode() {
        List<Worm> worms = getObjectsInRange(EXPLOSIONS_RADIUS, Worm.class);
        List<Grave_Stone> graves = getObjectsInRange(EXPLOSIONS_RADIUS, Grave_Stone.class);
        List<Mine> mines = getObjectsInRange(EXPLOSIONS_RADIUS, Mine.class);
        List<Oil_Drum> oilDrums = getObjectsInRange(EXPLOSIONS_RADIUS, Oil_Drum.class);
        int damage;
        for (int i = 0; i < worms.size(); i++) {
            damage = (int) (-0.324*getObjectsDistance(this, worms.get(i))+64.8);
            if (damage > 55) {
                damage = 55;
            }
            kill(worms.get(i), damage);
        }
        for (int i = 0; i < worms.size(); i++) {
            blowUp(Math.toRadians(directionToTurnTo(worms.get(i).getX(), worms.get(i).getY())), (((-0.5/EXPLOSIONS_RADIUS)*getObjectsDistance(worms.get(i), this))+0.5), worms.get(i));
        }
        for (int i = 0; i < graves.size(); i++) {
            blowUp(Math.toRadians(directionToTurnTo(graves.get(i).getX(), graves.get(i).getY())), (((-0.3/EXPLOSIONS_RADIUS)*getObjectsDistance(graves.get(i), this))+0.4), graves.get(i));
        }
        for (int i = 0; i < mines.size(); i++) {
            blowUp(Math.toRadians(directionToTurnTo(mines.get(i).getX(), mines.get(i).getY())), (((-0.2/EXPLOSIONS_RADIUS)*getObjectsDistance(mines.get(i), this))+0.2), mines.get(i));
        }
        for (int i = 0; i < oilDrums.size(); i++) {
            oilDrums.get(i).explode();
        }
        destroyWorld(getX(), getY(), (int) (EXPLOSIONS_RADIUS*0.4));
        getWorld().addObject(new Explosion(2.5), getX(), getY());
        getWorld().removeObject(countdown);
        getWorld().removeObject(this);
    }
}
