import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Font;
import java.awt.Color;

/**
 * Write a description of class TacticalDisplay here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class TacticalDisplay extends Actor
{
    private boolean textChanged = true;
    
    private Worm worm;
    
    private Font font_12 = new Font("font_12", 0, 12);
    private Font font_15 = new Font("font_15", 0, 15);
    private Font font_18 = new Font("font_18", Font.BOLD, 18);
    
    public TacticalDisplay(Worm worm) {
        this.worm = worm;
        getImage().clear();
        getImage().scale(120, 120);
    }
    
    public void act() {
        if (getWorld().getObjects(Weapon_Menu.class).isEmpty() && getWorld().getObjects(Break_Menu.class).isEmpty()) {
            run();
        }
    }
    
    public void run() {
        if (textChanged) {
            GreenfootImage name = new GreenfootImage(worm.getName(), 20, getTeamColor(worm.getParty()), new Color(0, 0, 0, 0));
            GreenfootImage teamname = new GreenfootImage(worm.getTeamname(), 15, getTeamColor(worm.getParty()), new Color(0, 0, 0, 0));
            GreenfootImage img = new GreenfootImage(120, 120);
            img.setColor(getTeamColor(worm.getParty()));
            img.setFont(font_15);
            if (worm.getExecuting()) {
                img.drawString("Action", 37, 15);
            }
            img.setFont(font_18);
            img.drawString(Integer.toString((worm.getLife() < 0 ? 0 : worm.getLife())), (worm.getLife() >= 100 ? 40 : (worm.getLife() >= 10 ? 43 : 46)), 65);
            img.setFont(font_15);
            switch (worm.getWeaponUsing()) {
                case 1:
                    img.drawString("Bazooka", 27, 85);
                    break;
                case 2:
                    img.drawString("Granade", 27, 85);
                    img.drawString("Time: " + Integer.toString(worm.getCountdownTime()), 30, 105);
                    break;
                case 3:
                    img.drawString("Clustergrenade", 7, 85);
                    img.drawString("Time: " + Integer.toString(worm.getCountdownTime()), 30, 105);
                    break;
                case 4:
                    img.drawString("Shotgun", 27, 85);
                    break;
                case 5:
                    img.drawString("Seeking_Missile", 7, 85);
                    break;
                case 6:
                    img.drawString("Dynamite", 26, 85);
                    break;
                case 7:
                    img.drawString("Sheep", 32, 85);
                    break;
                case 8:
                    img.drawString("Baseball Bat", 12, 85);
                    break;
                case 9:
                    img.drawString("Holly Grenade", 9, 85);
                    break;
                case 10:
                    img.drawString("Bananabomb", 12, 85);
                    img.drawString("Time: " + Integer.toString(worm.getCountdownTime()), 30, 105);
                    break;
            }
            getImage().clear();
            int width = 120;
            if (name.getWidth() > width) {
                width = name.getWidth();
            }
            if (teamname.getWidth() > width) {
                width = teamname.getWidth();
            }
            getImage().scale(width, 120);
            getImage().drawImage(img, (getImage().getWidth()/2)-(img.getWidth()/2), 0);
            getImage().drawImage(teamname, (getImage().getWidth()/2)-(teamname.getWidth()/2)-4, 18);
            getImage().drawImage(name, (getImage().getWidth()/2)-(name.getWidth()/2)-4, 29);
            textChanged = false;
        }
        setLocation(worm.getX(), worm.getY()-75);
        if (getX() < 55) {
            setLocation(55, getY());
        }
        else if (getX() > 1145) {
            setLocation(1145, getY());
        }
        if (getY() < 65) {
            setLocation(getX(), 65);
        }
        else if (getY() > 665) {
            setLocation(getX(), 665);
        }
    }
    
    private Color getTeamColor(int team) {
        switch (team) {
            case 1:
                return Color.red;
            case 2:
                return Color.blue;
            case 3:
                return Color.yellow;
            case 4:
                return new Color(0, 200, 0, 255);
            default:
                return new Color(0, 0, 0, 0);
        }
    }
    
    public boolean getTextChanged() {
        return textChanged;
    }
    public void setTextChanged(boolean changed) {
        textChanged = changed;
    }
}
