import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
import java.awt.Color;

/**
 * Write a description of class Team_Healthbar here.
 * 
 * @author (your name)
 * @version (a version number or a date)
 */
public class Team_Healthbar extends Actor
{
    private int[] totalHealth = new int[4];
    
    private int possibleHealth = Settings.wormLife * Settings.playerNumber;
    private int displayCounter = 0;
    
    private boolean stayInGame = false;
    
    public void act() {
        if (getWorld().getObjects(Weapon_Menu.class).isEmpty() && getWorld().getObjects(Break_Menu.class).isEmpty()) {
            run();
        }
    }
    
    public void run() {
        if (getY() < 770) {
            drawHealthbar();
            if (FullScreenWindow.mouseClicked(this)) {
                stayInGame = !stayInGame;
            }
        }
        if (stayInGame || displayCounter > 0) {
            if (getY() > 620) {
                setLocation(600, getY()-5);
            }
            if (displayCounter > 0) {
                displayCounter--;
            }
        }
        else {
            FullScreenMouseInfo mouse = FullScreenWindow.getMouseInfo();
            if (mouseOnObject(this) || (mouse != null && mouse.getX() > 450 && mouse.getX() < 750 && mouse.getY() > 600)) {
                displayCounter = 150;
                if (getY() > 620) {
                    setLocation(600, getY()-5);
                }
            }
            else if (getY() < 775) {
                setLocation(600, getY()+5);
            }
        }
    }
    
    public void drawHealthbar() {
        getHealthValues();
        int[] teamorder = getTeamorder();
        int counter = 0;
        GreenfootImage[] healthbars = new GreenfootImage[4];
        GreenfootImage image = new GreenfootImage(350, 135);
        image.setColor(new Color(50, 50, 50, 240));
        image.fill();
        for (int i : teamorder) {
            healthbars[i-1] = new GreenfootImage(310, 25);
            healthbars[i-1].setColor(getTeamColor(i));
            healthbars[i-1].fillRect(5, 0, totalHealth[i-1] * 300 / possibleHealth, 30);
            GreenfootImage teamname = new GreenfootImage(((Worms_Land) getWorld()).getWormByNumber(i, 1).getTeamname(), 25, Color.black, new Color(0, 0, 0, 0));
            healthbars[i-1].drawImage(teamname, healthbars[i-1].getWidth()/2 - teamname.getWidth()/2, healthbars[i-1].getHeight()/2 - teamname.getHeight()/2);
            image.drawImage(healthbars[i-1], 20, 10 + 30 * counter);
            counter++;
        }
        setImage(image);
    }
    
    public void getHealthValues() {
        List<Worm> wormsInWorld = getWorld().getObjects(Worm.class);
        totalHealth = new int[4];
        for (Worm worm : wormsInWorld) {
            switch (worm.getParty()) {
                case 1:
                    totalHealth[0] += (worm.getLife() < 0 ? 0 : worm.getLife());
                    break;
                case 2:
                    totalHealth[1] += (worm.getLife() < 0 ? 0 : worm.getLife());
                    break;
                case 3:
                    totalHealth[2] += (worm.getLife() < 0 ? 0 : worm.getLife());
                    break;
                case 4:
                    totalHealth[3] += (worm.getLife() < 0 ? 0 : worm.getLife());
                    break;
                default:
                    System.out.println("Team_Healthbar: Worm party unknown");
                    break;
            }
        }
    }
    
    private boolean mouseOnObject(Actor actor) {
        FullScreenMouseInfo mouse = FullScreenWindow.getMouseInfo();
        return mouse != null && mouse.getX() > actor.getX() - actor.getImage().getWidth()/2 && mouse.getX() < actor.getX() + actor.getImage().getWidth()/2 && 
            mouse.getY() > actor.getY() - actor.getImage().getHeight()/2 && mouse.getY() < actor.getY() + actor.getImage().getHeight()/2;
    }
    
    public int[] getTeamorder() {
        int[] teamorder = {1, 2, 3, 4};
        int changes = 0;
        for (int i = 0; i < teamorder.length-1; i++) {
            changes = 0;
            for(int j = 0; j < (teamorder.length-1)-i; j++) {
                if (totalHealth[teamorder[j]-1] < totalHealth[teamorder[j+1]-1]) {
                    int temp = teamorder[j];
                    teamorder[j] = teamorder[j+1];
                    teamorder[j+1] = temp;
                    changes++;
                }
            }
            if (changes == 0) {
                break;
            }
        }
        return teamorder;
    }
    
    private Color getTeamColor(int team) {
        switch (team) {
            case 1:
                return Color.red;
            case 2:
                return Color.blue;
            case 3:
                return Color.yellow;
            case 4:
                return new Color(0, 200, 0, 255);
            default:
                return new Color(0, 0, 0, 0);
        }
    }
    
    public void resetPossibleHealth() {
        possibleHealth = Settings.wormLife * Settings.playerNumber;
    }
    
    public void setDisplayCounter(int displayCounter) {
        this.displayCounter = displayCounter;
    }
    public int getDisplayCounter() {
        return displayCounter;
    }
}
