import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
import java.util.ArrayList;
import java.awt.Color;
import java.awt.Point;

/**
 * Write a description of class Worm here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Worm extends Players
{
    private double velX;
    private double velY;
    
    private int party;
    private int number;
    private int life = Settings.wormLife;
    private int weaponUsing = 1;
    private int languagePack = 0;
    private int weaponChanges = 0;
    private int fallingCounter = 0;
    private int jumpingCounter = 0;
    private int jumpingCounterAI = 0;
    private int jumpsAI = 0;
    private int dieCounter = 0;
    private int runningCounter = 0;
    private int waitingCounter = 0;
    private int countdownTime = 5;
    private int selectCounter = 0;
    private int weaponChangeCounter = 0;
    private int missileX = 0;
    private int missileY = 0;
    private int lastJump = 0;
    private int lastX = 0;
    private int lastY = 0;
    
    private final int EXPLOSIONS_RADIUS = 100;
    
    private boolean executing = false;
    private boolean weaponChange = false;
    private boolean imageLeft = true;
    private boolean falling = false;
    private boolean flying = false;
    private boolean tacticalDisplayAdded = false;
    private boolean shoot = false;
    private boolean jump = false;
    private boolean secondShotgun = false;
    private boolean addWeapon = false;
    private boolean missileTarget = false;
    private boolean controllJumpPosition = false;
    private boolean triedWalkingWeapon = false;
    private boolean hitByBaseballBat = false;
    private boolean artificialIntelligence;
    
    private boolean[] weaponTried = new boolean[10];
    
    private String name = "";
    private String teamname = "";
    
    private AimDisplay aimDisplay = new AimDisplay(this, 180, true);
    
    private TacticalDisplay tacticalDisplay = new TacticalDisplay(this);
    
    private Shotgun shotgun = new Shotgun(this);
    
    private Baseball_Bat baseballBat = new Baseball_Bat(this);
    
    private Clock clock = new Clock(2);
    
    private Worm target;
    
    /**
     * Constructor of the class Worm.
     * Creates a new Worm with the given party- and executingnumber and the given value of artifical intelligenze.
     * 
     * @param party
     *      The party of the created worm.
     *      Values from 1 up to the number of parties in this game.
     * 
     * @param number
     *      The executingnumber of the created worm.
     *      Values from 1 up to the number of worms in this party.
     * 
     * @param artificialIntelligence
     *      If true the worm is controlled by computer.
     *      If false the worm has to be controlled by the player.
     */
    public Worm(int party, int number, boolean artificialIntelligence) {
        this.party = party;
        this.number = number;
        this.artificialIntelligence = artificialIntelligence;
        if (party == 1) {
            changeImage(new GreenfootImage("Worm_Soldier.png"));
            getImage().scale(67, 50);
        }
        else if (party == 2) {
            changeImage(new GreenfootImage("Worm_Bazooka.png"));
            getImage().scale(67, 50);
        }
        else if (party == 3) {
            changeImage(new GreenfootImage("Worm_Shotgun.png"));
            getImage().scale(55, 50);
        }
        else if (party == 4) {
            changeImage(new GreenfootImage("Worm_Grenade.png"));
            getImage().scale(67, 49);
        }
    }
    
    /**
     * Call the run method to run the game if the game is executed.
     */
    public void act() {
        if (getWorld().getObjects(Break_Menu.class).isEmpty()) {
            run();
        }
    }
    
    /**
     * Makes the worm move, shoot or do whatever he wants to do.
     */
    public void run() {
        if (!artificialIntelligence) {//players conntroll;
            weaponChange = !getWorld().getObjects(Weapon_Menu.class).isEmpty();
            if (!tacticalDisplayAdded) {
                getWorld().addObject(tacticalDisplay, getX(), getY()-50);
                tacticalDisplayAdded = true;
            }
            if (flying) {
                fly();
            }
            else if (jump) {
                jump();
            }
            if (lastX == getX() && lastY == getY()) {//not moving;
                hitByBaseballBat = false;
            }
            else {
                lastX = getX();
                lastY = getY();
            }
            if (((Worms_Land) getWorld()).getMaterialAt(getX(), getY()+25).getMaterial() == 2) {
                //Air -> fall;
                fallingCounter++;
                setLocation(getX(), (int) (getY()+(((Worms_Land) getWorld()).GRAVITY*fallingCounter)));
                falling = true;
            }
            else if (((Worms_Land) getWorld()).getMaterialAt(getX(), getY()+25).getMaterial() == 3) {
                //Water -> die;
                flying = false;
                falling = false;
                ((Worms_Land) getWorld()).setWeaponThrown(true);
                setShoot(true);
                GreenfootSound water = new GreenfootSound("splash.wav");
                water.setVolume(Settings.effectVolume);
                if (fallingCounter < 50) {
                    if (fallingCounter < 30) {
                        water.setVolume((int) (30.0*100.0/50.0));
                    }
                    else {
                        water.setVolume((int) ((double)fallingCounter*100.0/50.0));
                    }
                }
                water.play();
                ((Worms_Land) getWorld()).setClaim(Greenfoot.getRandomNumber(2)+4, this);
                die(true);
                return;
            }
            else {
                //Earth;
                if (falling) {
                    if (fallingCounter > 65) {
                        int damage = (int) ((0.231*fallingCounter)-15.015);
                        if (damage > 15) {
                            damage = 15;
                        }
                        setLife(-damage);
                    }
                    falling = false;
                    fallingCounter = 0;
                }
                else {
                    for (int i = 0; i < 15 && ((Worms_Land) getWorld()).getMaterialAt(getX(), getY()+24).getMaterial() == 1 && ((Worms_Land) getWorld()).getMaterialAt(getX(), getY()+15).getMaterial() == 2; i++) {
                        setLocation(getX(), getY()-1);
                    }
                }
            }
            if (executing) {
                //shoot for weapons without AimDisplay;
                if (FullScreenWindow.mouseClicked(null) && !aimDisplayNeeded() && !weaponChange) {
                    switch (weaponUsing) {
                        case 4:
                            if (shotgun.shoot()) {//if true Bullet is added;
                                if (secondShotgun) {
                                    fire(0, 0);
                                    getWorld().removeObject(shotgun);
                                    secondShotgun = false;
                                    addWeapon = false;
                                }
                                else {
                                    secondShotgun = true;
                                }
                            }
                            break;
                        case 5:
                            if (!missileTarget) {
                                FullScreenMouseInfo mouse = FullScreenWindow.getMouseInfo();
                                missileX = mouse.getX();
                                missileY = mouse.getY();
                                getWorld().addObject(aimDisplay, getX(), getY());
                                missileTarget = true;
                            }
                            break;
                        default:
                            fire(0, 0);
                            break;
                    }
                }
                //Worm movement;
                if (FullScreenWindow.isKeyDown(Settings.wormJump)) {
                    if (!weaponChange && !flying && !falling && !jump) {
                        jump = true;
                        jumpingCounterAI = 0;
                        if (FullScreenWindow.isKeyDown(Settings.wormUp)) {
                            if (imageLeft) {
                                velX = 1.5;
                            }
                            else {
                                velX = -1;
                            }
                            velY = 5;
                        }
                        else {
                            if (imageLeft) {
                                if (FullScreenWindow.isKeyDown(Settings.wormLeft)) {
                                    velX = -3.5;
                                }
                                else {
                                    velX = -2.5;
                                }
                            }
                            else {
                                if (FullScreenWindow.isKeyDown(Settings.wormRight)) {
                                    velX = 3.5;
                                }
                                else {
                                    velX = 2.5;
                                }
                            }
                            velY = 3.5;
                        }
                    }
                    getWorld().removeObject(aimDisplay);
                    missileTarget = false;
                }
                if (FullScreenWindow.isKeyDown(Settings.wormLeft)) {
                    if (!weaponChange && getWorld().getObjects(Jetpack.class).isEmpty()) {
                        moveLeft();
                        getWorld().removeObject(aimDisplay);
                    }
                    missileTarget = false;
                }
                else if (FullScreenWindow.isKeyDown(Settings.wormRight)) {
                    if (!weaponChange && getWorld().getObjects(Jetpack.class).isEmpty()) {
                        moveRight();
                        getWorld().removeObject(aimDisplay);
                    }
                    missileTarget = false;
                }
                else if (FullScreenWindow.isKeyDown(Settings.wormChangeWeapon) && !secondShotgun) {
                    if (weaponChangeCounter <= 0) {
                        if (!weaponChange) {
                            getWorld().addObject(new Weapon_Menu(this), 600, 350);
                            weaponChangeCounter = 8;
                        }
                        else {
                            getWorld().removeObjects(getWorld().getObjects(Weapon_Menu.class));
                            weaponChangeCounter = 8;
                        }
                    }
                    else {
                        weaponChangeCounter--;
                    }
                }
                else if (FullScreenWindow.isKeyDown(Settings.wormSelect) && selectCounter > 10) {
                    if (countdownTime == 5) {
                        countdownTime = 1;
                    }
                    else {
                        countdownTime++;
                    }
                    selectCounter = 0;
                    tacticalDisplay.setTextChanged(true);
                }
                else if (!falling && !flying && !shoot && aimDisplayNeeded() && life > 0) {
                    if (getWorld().getObjects(AimDisplay.class).isEmpty()) {
                        getWorld().addObject(aimDisplay, getX(), getY());
                    }
                }
                selectCounter++;
            }
            else {
                getWorld().removeObject(aimDisplay);
            }
            if (shoot) {
                getWorld().removeObject(aimDisplay);
            }
            //use to scroll over the world;
            /*if (FullScreenWindow.isKeyDown(Settings.worldUp)) {
                setLocation(getX(), getY()+5);
            }
            else if (FullScreenWindow.isKeyDown(Settings.worldDown)) {
                setLocation(getX(), getY()-5);
            }
            if (FullScreenWindow.isKeyDown(Settings.worldLeft)) {
                setLocation(getX()+5, getY());
            }
            else if (FullScreenWindow.isKeyDown(Settings.worldRight)) {
                setLocation(getX()-5, getY());
            }*/
            if (life <= 0) {
                if (dieCounter > 100) {
                    try {
                        if (executing) {
                            ((Worms_Land) getWorld()).setClaim(6, this);
                        }
                        else {
                            ((Worms_Land) getWorld()).setClaim(4, this);
                            if (((Worms_Land) getWorld()).getExecutingWorm().getParty() == this.getParty()) {
                                ((Worms_Land) getWorld()).setClaim(8, ((Worms_Land) getWorld()).getExecutingWorm());
                            }
                        }
                        if (((Worms_Land) getWorld()).getTeam(getParty()).size() == 1) {
                            ((Worms_Land) getWorld()).setClaim(3, this);
                        }
                    }
                    catch (NullPointerException npe) {
                        //npe.printStackTrace();
                    }
                    die(false);
                    return;
                }
                else {
                    dieCounter++;
                }
            }
        }
        else {//controlled by computer;
            weaponChange = !getWorld().getObjects(Weapon_Menu.class).isEmpty();
            if (!tacticalDisplayAdded) {
                getWorld().addObject(tacticalDisplay, getX(), getY()-50);
                tacticalDisplayAdded = true;
            }
            if (flying) {
                fly();
            }
            else if (jump) {
                jump();
            }
            if (lastX == getX() && lastY == getY()) {//not moving;
                hitByBaseballBat = false;
            }
            else {
                lastX = getX();
                lastY = getY();
            }
            if (((Worms_Land) getWorld()).getMaterialAt(getX(), getY()+25).getMaterial() == 2) {
                //Air -> fall;
                fallingCounter++;
                setLocation(getX(), (int) (getY()+(((Worms_Land) getWorld()).GRAVITY*fallingCounter)));
                falling = true;
            }
            else if (((Worms_Land) getWorld()).getMaterialAt(getX(), getY()+25).getMaterial() == 3) {
                //Water -> die;
                flying = false;
                falling = false;
                ((Worms_Land) getWorld()).setWeaponThrown(true);
                setShoot(true);
                GreenfootSound water = new GreenfootSound("splash.wav");
                water.setVolume(Settings.effectVolume);
                if (fallingCounter < 50) {
                    if (fallingCounter < 30) {
                        water.setVolume((int) (30.0*100.0/50.0));
                    }
                    else {
                        water.setVolume((int) ((double)fallingCounter*100.0/50.0));
                    }
                }
                water.play();
                ((Worms_Land) getWorld()).setClaim(Greenfoot.getRandomNumber(2)+4, this);
                die(true);
                return;
            }
            else {
                //Earth;
                if (falling) {
                    if (fallingCounter > 80) {
                        int damage = (int) ((0.231*fallingCounter)-15.015);
                        if (damage > 15) {
                            damage = 15;
                        }
                        setLife(-damage);
                    }
                    falling = false;
                    fallingCounter = 0;
                }
                else {
                    for (int i = 0; i < 15 && ((Worms_Land) getWorld()).getMaterialAt(getX(), getY()+24).getMaterial() == 1 && ((Worms_Land) getWorld()).getMaterialAt(getX(), getY()+15).getMaterial() == 2; i++) {
                        setLocation(getX(), getY()-1);
                    }
                }
            }
            if (executing) {
                if (getX() < 0) {
                    moveRight();
                    runningCounter = 50;
                }
                else if (getX() > 1200) {
                    moveLeft();
                    runningCounter = 50;
                }
                if (clock.timeUp()) {
                    ((Worms_Land) getWorld()).setWeaponThrown(true);
                    setShoot(true);
                    return;
                }
                if (runningCounter <= 0 && waitingCounter <= 0 && enemyWormExisting()) { 
                    for (int i = 0; i < 25 && target == null && !shoot && !secondShotgun; i++) {
                        if (target == null) {
                            if (weaponChanges >= 50 && everyWeaponTried()) {
                                ((Worms_Land) getWorld()).setWeaponThrown(true);
                                setShoot(true);
                                return;
                            }
                            List<Worm> enemyWorms = getEnemyWorms();
                            chooseWeapon(enemyWorms);
                            weaponChanges++;
                            if (target == null) {
                                target = getTargetWorm(enemyWorms);
                            }
                            if (target == null) {
                                target = getRandomEnemy(enemyWorms);
                            }
                            if (target.getParty() == this.getParty()) {
                                //System.out.println("Error: Mate target");
                                target = null;
                                continue;
                            }
                        }
                        if (target != null) {
                            switch (weaponUsing) {
                                case 1:
                                    if (!freeShotAngle(target, 100) && i < 24) {
                                        target = null;
                                        //use calculator;
                                    }
                                    break;
                                case 2:
                                    if (!freeShotAngle(target, 100) && i < 24) {
                                        target = null;
                                        //use calculator;
                                    }
                                    break;
                                case 3:
                                    if (!freeShotAngle(target, 100) && i < 24) {
                                        target = null;
                                    }
                                    break;
                                case 4:
                                    if (!freeShotAngle(target, 100) && i < 24) {
                                        target = null;
                                    }
                                    break;
                                case 5:
                                    //always possible;
                                    break;
                                case 6:
                                    if (triedWalkingWeapon) {
                                        target = null;
                                    }
                                    break;
                                case 7:
                                    //always possible;
                                    break;
                                case 8:
                                    if (triedWalkingWeapon) {
                                        target = null;
                                    }
                                    break;
                                case 9:
                                    if (!(distanceToNearestMate(target) > 250) || !freeShotAngle(target)) {
                                        target = null;
                                        //use calculator;
                                    }
                                    break;
                                case 10:
                                    if (!(distanceToNearestMate(target) > 200) || !freeShotAngle(target)) {
                                        target = null;
                                        //use calculator;
                                    }
                                    break;
                            }
                        }
                        if (target != null) {
                            wait(25, 50);
                            return;
                        }
                    }
                    if (((Worms_Land) getWorld()).wormExistingInWorld(target) && target != null) {
                        double[] shootingCalculations;
                        switch (weaponUsing) {
                            case 1:
                                if (distanceToNearestWorm(this) < 30 || distanceToNearestOilDrum() < 30) {
                                    runningCounter = 50;
                                }
                                shootingCalculations = calculateShoot(target);
                                if (freeShootingAngle(new Bazooka(), shootingCalculations[0], shootingCalculations[1], (int) (Bazooka.EXPLOSIONS_RADIUS*0.5))) {
                                    ((Worms_Land) getWorld()).receiveAdaptiveAlgorithmValues(this, target);
                                    fireValues(shootingCalculations[0], shootingCalculations[1]);
                                }
                                else {
                                    target = null;
                                    wait(50, 75);
                                }
                                break;
                            case 2:
                                if (distanceToNearestWorm(this) < 30 || distanceToNearestOilDrum() < 30) {
                                    runningCounter = 50;
                                }
                                shootingCalculations = calculateShoot(target);
                                if (freeShootingAngle(new Grenade(), shootingCalculations[0], shootingCalculations[1], (int) (Grenade.EXPLOSIONS_RADIUS*0.5))) {
                                    ((Worms_Land) getWorld()).receiveAdaptiveAlgorithmValues(this, target);
                                    fireValues(shootingCalculations[0], shootingCalculations[1]);
                                }
                                else {
                                    target = null;
                                    wait(50, 75);
                                }
                                break;
                            case 3:
                                if (distanceToNearestWorm(this) < 30 || distanceToNearestOilDrum() < 30) {
                                    runningCounter = 50;
                                }
                                shootingCalculations = calculateShoot(target);
                                if (freeShootingAngle(new Clustergrenade(), shootingCalculations[0], shootingCalculations[1], (int) (Clustergrenade.EXPLOSIONS_RADIUS))) {
                                    ((Worms_Land) getWorld()).receiveAdaptiveAlgorithmValues(this, target);
                                    fireValues(shootingCalculations[0], shootingCalculations[1]);
                                }
                                else {
                                    target = null;
                                    wait(50, 75);
                                }
                                break;
                            case 4:
                                if (distanceToNearestWorm(this) < 30 || distanceToNearestOilDrum() < 30) {
                                    runningCounter = 50;
                                }
                                if (!freeShotAngle(target, 100)) {
                                    if (imageLeft) {
                                        moveRight();
                                        runningCounter = 50;
                                    }
                                    else {
                                        moveLeft();
                                        runningCounter = 50;
                                    }
                                }
                                if (getX() > target.getX()) {
                                    if (!shoot) {
                                        moveLeft();
                                    }
                                    if (getWorld().getObjects(Shotgun.class).isEmpty()) {
                                        if (imageLeft) {
                                            getWorld().addObject(shotgun, getX()-15, getY()+5);
                                        }
                                        else {
                                            getWorld().addObject(shotgun, getX()+15, getY()+5);
                                        }
                                    }
                                    if (freeShotAngle(target, 30)) {
                                        shotgun.turnTo(target.getX(), target.getY());
                                        shotgun.addBullet(target.getX(), target.getY());
                                        if (Greenfoot.getRandomNumber(10) > 7) {
                                            ((Worms_Land) getWorld()).setClaim(7, 5, this);
                                        }
                                        wait(100, 125);
                                    }
                                    else {
                                        runningCounter = 50;
                                    }
                                }
                                else {
                                    if (!shoot) {
                                        moveRight();
                                    }
                                    if (getWorld().getObjects(Shotgun.class).isEmpty()) {
                                        if (imageLeft) {
                                            getWorld().addObject(shotgun, getX()-15, getY()+5);
                                        }
                                        else {
                                            getWorld().addObject(shotgun, getX()+15, getY()+5);
                                        }
                                    }
                                    shotgun.turnTo(target.getX(), target.getY());
                                    shotgun.addBullet(target.getX(), target.getY());
                                    wait(100, 125);
                                }
                                if (secondShotgun && !shoot || !((Worms_Land) getWorld()).wormExistingInWorld(target)) {
                                    fire(0, 0);
                                    getWorld().removeObject(shotgun);
                                    secondShotgun = false;
                                    addWeapon = false;
                                }
                                else {
                                    secondShotgun = true;
                                }
                                break;
                            case 5:
                                if (distanceToNearestWorm(this) < 50 || distanceToNearestOilDrum() < 50) {
                                    runningCounter = 50;
                                }
                                if (!mapWithoutCover()) {
                                    target = null;
                                    return;
                                }
                                if (getX() > target.getX()) {
                                    if (freeShotAngle(255, 250)) {
                                        if (!missileTarget) {//find missiles target;
                                            missileX = target.getX();
                                            missileY = target.getY();
                                            missileTarget = true;
                                            wait(150, 150);
                                        }
                                        if (missileTarget) {//shoot;
                                            fire(Math.toRadians(255-360), toForceFactor(Worms_Land.MAX_FORCE));
                                        }
                                    }
                                    else if (freeShotAngle(285, 250)) {
                                        if (!missileTarget) {//find missiles target;
                                            missileX = target.getX();
                                            missileY = target.getY();
                                            missileTarget = true;
                                            wait(150, 150);
                                        }
                                        if (missileTarget) {//shoot;
                                            fire(Math.toRadians(285-360), toForceFactor(Worms_Land.MAX_FORCE));
                                        }
                                    }
                                    else {
                                        runningCounter = 50;
                                    }
                                }
                                else {
                                    if (freeShotAngle(285, 250)) {
                                        if (!missileTarget) {//find missiles target;
                                            missileX = target.getX();
                                            missileY = target.getY();
                                            missileTarget = true;
                                            wait(150, 150);
                                        }
                                        if (missileTarget) {//shoot;
                                            fire(Math.toRadians(285-360), toForceFactor(Worms_Land.MAX_FORCE));
                                            if (getAbsoluteDistance(missileX, missileY) < Seeking_Missile.EXPLOSIONS_RADIUS) {
                                                if (missileX > getX()) {
                                                    moveLeft();
                                                    runningCounter = 75;
                                                }
                                                else {
                                                    moveRight();
                                                    runningCounter = 75;
                                                }
                                            }
                                        }
                                    }
                                    else if (freeShotAngle(255, 250)) {
                                        if (!missileTarget) {//find missiles target;
                                            missileX = target.getX();
                                            missileY = target.getY();
                                            missileTarget = true;
                                            wait(150, 150);
                                        }
                                        if (missileTarget) {//shoot;
                                            fire(Math.toRadians(255-360), toForceFactor(Worms_Land.MAX_FORCE));
                                            if (getAbsoluteDistance(missileX, missileY) < Seeking_Missile.EXPLOSIONS_RADIUS) {
                                                if (missileX > getX()) {
                                                    moveLeft();
                                                    runningCounter = 75;
                                                }
                                                else {
                                                    moveRight();
                                                    runningCounter = 75;
                                                }
                                            }
                                        }
                                    }
                                    else {
                                        runningCounter = 50;
                                    }
                                }
                                break;
                            case 6:
                                if (Math.abs(getX() - target.getX()) <= 25 && Math.abs(getY() - target.getY()) <= 75) {
                                    fire(0, 0);//throw dynamite;
                                    if (imageLeft) {
                                        moveRight();
                                    }
                                    else {
                                        moveLeft();
                                    }
                                    runningCounter = 250;
                                }
                                else if (Math.abs(getX() - target.getX()) > 25 && target.getX() <= 1200 && target.getX() >= 0) {//move to other worm;
                                    if (getX() > target.getX()-25 && jumpingCounterAI == 0) {
                                        if (waterAtMovingPosition((imageLeft ? getX()-25 : getX()+25), getY()+15)) {
                                            if (!jump && !waterAtMovingPosition((imageLeft ? getX()-125 : getX()+125), getY()+15)) {
                                                jump = true;
                                                if (imageLeft) {
                                                    velX = -3.5;
                                                }
                                                else {
                                                    velX = 3.5;
                                                }
                                                velY = 3.5;
                                            }
                                            else if (!jump) {
                                                target = null;
                                                triedWalkingWeapon = true;
                                            }
                                        }
                                        else {
                                            if (!moveLeft()) {
                                                jumpingCounterAI = 1;//jump;
                                                controllJumpPosition = true;
                                                triedWalkingWeapon = true;
                                                moveRight();
                                            }
                                        }
                                    }
                                    else if (getX() < target.getX()+25 && jumpingCounterAI == 0) {
                                        if (waterAtMovingPosition((imageLeft ? getX()-25 : getX()+25), getY()+15)) {
                                            if (!jump && !waterAtMovingPosition((imageLeft ? getX()-125 : getX()+125), getY()+15)) {
                                                jump = true;
                                                if (imageLeft) {
                                                    velX = -3.5;
                                                }
                                                else {
                                                    velX = 3.5;
                                                }
                                                velY = 3.5;
                                            }
                                            else if (!jump) {
                                                target = null;
                                                triedWalkingWeapon = true;
                                            }
                                        }
                                        else {
                                            if (!moveRight()) {
                                                jumpingCounterAI = 1;//jump;
                                                controllJumpPosition = true;
                                                triedWalkingWeapon = true;
                                                moveLeft();
                                            }
                                        }
                                    }
                                }
                                else if ((Math.abs(getX() - target.getX()) <= 25 && Math.abs(getY() - target.getY()) > 35) || (target.getX() > 1200 && target.getX() < 0)) {
                                    target = null;
                                    triedWalkingWeapon = true;
                                }
                                if (shoot && jumpingCounterAI == 0) {//run away;
                                    if (imageLeft) {
                                        if (waterAtMovingPosition(getX()-25, getY()+15)) {
                                            if (!jump && !waterAtMovingPosition(getX()-125, getY()+15)) {
                                                jump = true;
                                                if (imageLeft) {
                                                    velX = -3.5;
                                                }
                                                else {
                                                    velX = 3.5;
                                                }
                                                velY = 3.5;
                                            }
                                            else if (!jump) {
                                                target = null;
                                                triedWalkingWeapon = true;
                                            }
                                        }
                                        else {
                                            if (!moveLeft()) {
                                                jumpingCounterAI = 1;//jump;
                                                controllJumpPosition = true;
                                                moveRight();
                                            }
                                        }
                                    }
                                    else {
                                        if (waterAtMovingPosition(getX()+25, getY()+15)) {
                                            if (!jump && !waterAtMovingPosition(getX()+125, getY()+15)) {
                                                jump = true;
                                                if (imageLeft) {
                                                    velX = -3.5;
                                                }
                                                else {
                                                    velX = 3.5;
                                                }
                                                velY = 3.5;
                                            }
                                            else if (!jump) {
                                                target = null;
                                                triedWalkingWeapon = true;
                                            }
                                        }
                                        else if (!waterAtMovingPosition(getX()+25, getY()+15) && !moveRight()) {
                                            jumpingCounterAI = 1;//jump;
                                            controllJumpPosition = true;
                                            moveLeft();
                                        }
                                    }
                                }
                                break;
                            case 7:
                                if (getX() > target.getX()) {
                                    if (Math.abs(getX() - target.getX()) < 100) {
                                        runningCounter = 50;
                                    }
                                    else {
                                        if (!shoot) {
                                            moveLeft();
                                        }
                                        fire(0, 0);
                                    }
                                }
                                else {
                                    if (Math.abs(getX() - target.getX()) < 100) {
                                        runningCounter = 50;
                                    }
                                    else {
                                        if (!shoot) {
                                            moveRight();
                                        }
                                        fire(0, 0);
                                    }
                                }
                                break;
                            case 8:
                                if (Math.abs(getX() - target.getX()) <= 15 && target.getX() <= 1200 && target.getX() >= 0) {
                                    if (!shoot) {
                                        if (getX() > target.getX() && jumpingCounterAI == 0) {
                                            if (waterAtMovingPosition((imageLeft ? getX()-25 : getX()+25), getY()+15)) {
                                                if (!jump && !waterAtMovingPosition((imageLeft ? getX()-125 : getX()+125), getY()+15)) {
                                                    jump = true;
                                                    if (imageLeft) {
                                                        velX = -3.5;
                                                    }
                                                    else {
                                                        velX = 3.5;
                                                    }
                                                    velY = 3.5;
                                                }
                                                else if (!jump) {
                                                    target = null;
                                                    triedWalkingWeapon = true;
                                                }
                                            }
                                            else {
                                                if (!moveLeft()) {
                                                    jumpingCounterAI = 1;//jump;
                                                    controllJumpPosition = true;
                                                    triedWalkingWeapon = true;
                                                    moveRight();
                                                }
                                            }
                                        }
                                        else {
                                            if (waterAtMovingPosition((imageLeft ? getX()-25 : getX()+25), getY()+15)) {
                                                if (!jump && !waterAtMovingPosition((imageLeft ? getX()-125 : getX()+125), getY()+15)) {
                                                    jump = true;
                                                    if (imageLeft) {
                                                        velX = -3.5;
                                                    }
                                                    else {
                                                        velX = 3.5;
                                                    }
                                                    velY = 3.5;
                                                }
                                                else if (!jump) {
                                                    target = null;
                                                    triedWalkingWeapon = true;
                                                }
                                            }
                                            else {
                                                if (!moveRight()) {
                                                    jumpingCounterAI = 1;//jump;
                                                    controllJumpPosition = true;
                                                    triedWalkingWeapon = true;
                                                    moveLeft();
                                                }
                                            }
                                        }
                                    }
                                    if (Math.abs(getY() - target.getY()) < 20) {
                                        fire(0, 0);//hit worm;
                                    }
                                    else {
                                        target = null;
                                        triedWalkingWeapon = true;
                                    }
                                }
                                else if (target.getX() <= 1200 && target.getX() >= 0) {//move to other worm;
                                    if (!shoot) {
                                        if (getX() > target.getX()-15 && jumpingCounterAI == 0) {
                                            if (waterAtMovingPosition((imageLeft ? getX()-25 : getX()+25), getY()+15)) {
                                                if (!jump && !waterAtMovingPosition((imageLeft ? getX()-125 : getX()+125), getY()+15)) {
                                                    jump = true;
                                                    if (imageLeft) {
                                                        velX = -3.5;
                                                    }
                                                    else {
                                                        velX = 3.5;
                                                    }
                                                    velY = 3.5;
                                                }
                                                else if (!jump) {
                                                    target = null;
                                                    triedWalkingWeapon = true;
                                                }
                                            }
                                            else {
                                                if (!moveLeft()) {
                                                    jumpingCounterAI = 1;//jump;
                                                    controllJumpPosition = true;
                                                    triedWalkingWeapon = true;
                                                    moveRight();
                                                }
                                            }
                                        }
                                        else if (getX() < target.getX()+15 && jumpingCounterAI == 0) {
                                            if (waterAtMovingPosition((imageLeft ? getX()-25 : getX()+25), getY()+15)) {
                                                if (!jump && !waterAtMovingPosition((imageLeft ? getX()-125 : getX()+125), getY()+15)) {
                                                    jump = true;
                                                    if (imageLeft) {
                                                        velX = -3.5;
                                                    }
                                                    else {
                                                        velX = 3.5;
                                                    }
                                                    velY = 3.5;
                                                }
                                                else if (!jump) {
                                                    target = null;
                                                    triedWalkingWeapon = true;
                                                }
                                            }
                                            else {
                                                if (!waterAtMovingPosition((imageLeft ? getX()-25 : getX()+25), getY()+15) && !moveRight()) {
                                                    jumpingCounterAI = 1;//jump;
                                                    controllJumpPosition = true;
                                                    triedWalkingWeapon = true;
                                                    moveLeft();
                                                }
                                            }
                                        }
                                    }
                                }
                                else if (target.getX() > 1200 || target.getX() < 0) {
                                    target = null;
                                    triedWalkingWeapon = true;
                                }
                                break;
                            case 9:
                                if (distanceToNearestWorm(this) < 30 || distanceToNearestOilDrum() < 30) {
                                    runningCounter = 50;
                                }
                                shootingCalculations = calculateShoot(target);
                                if (freeShootingAngle(new Holly_Grenade(), shootingCalculations[0], shootingCalculations[1], (int) (Holly_Grenade.EXPLOSIONS_RADIUS*0.7))) {
                                    ((Worms_Land) getWorld()).receiveAdaptiveAlgorithmValues(this, target);
                                    fireValues(shootingCalculations[0], shootingCalculations[1]);
                                }
                                else {
                                    target = null;
                                    wait(50, 75);
                                }
                                break;
                            case 10:
                                if (distanceToNearestWorm(this) < 30 || distanceToNearestOilDrum() < 30) {
                                    runningCounter = 50;
                                }
                                shootingCalculations = calculateShoot(target);
                                if (freeShootingAngle(new Bananabomb(), shootingCalculations[0], shootingCalculations[1], (int) (Bananabomb.EXPLOSIONS_RADIUS*1.5))) {
                                    ((Worms_Land) getWorld()).receiveAdaptiveAlgorithmValues(this, target);
                                    fireValues(shootingCalculations[0], shootingCalculations[1]);
                                }
                                else {
                                    target = null;
                                    wait(50, 75);
                                }
                                break;
                        }
                    }
                    if (!((Worms_Land) getWorld()).wormExistingInWorld(target) && secondShotgun && !shoot) {
                        fire(0, 0);
                        getWorld().removeObject(shotgun);
                        secondShotgun = false;
                        addWeapon = false;
                    }
                }
                else if (runningCounter > 0 && jumpingCounterAI == 0) {
                    if (jumpsAI >= 5) {
                        runningCounter = 0;
                        jumpingCounterAI = 0;
                        triedWalkingWeapon = true;
                    }
                    if (imageLeft) {
                        if (waterAtMovingPosition(getX()-25, getY()+10)) {
                            if (!jump && !waterAtMovingPosition(getX()-125, getY()+10)) {
                                jump = true;
                            }
                            else if (!jump) {
                                target = null;
                                triedWalkingWeapon = true;
                                if (runningCounter > 50) {
                                    moveRight();
                                }
                            }
                        }
                        else if (!moveLeft()) {
                            jumpingCounterAI = 1;//jump;
                            controllJumpPosition = true;
                            moveRight();
                        }
                    }
                    else {
                        if (waterAtMovingPosition(getX()+25, getY()+10)) {
                            if (!jump && !waterAtMovingPosition(getX()+125, getY()+10)) {
                                jump = true;
                            }
                            else if (!jump) {
                                target = null;
                                triedWalkingWeapon = true;
                                if (runningCounter > 50) {
                                    moveLeft();
                                }
                            }
                        }
                        else if (!moveRight()) {
                            jumpingCounterAI = 1;//jump;
                            controllJumpPosition = true;
                            moveLeft();
                        }
                    }
                    runningCounter--;
                    if (runningCounter < 0) {
                        runningCounter = 0;
                    }
                }
                else if (waitingCounter > 0) {
                    waitingCounter--;
                }
            }
            else {
                getWorld().removeObject(aimDisplay);
            }
            if (jumpingCounterAI > 0 && jumpsAI < 5) {
                if (controllJumpPosition) {
                    if (Math.abs(getX() - lastJump) < 10) {
                        //move back and choose new weapon;
                        jumpingCounterAI = -1;
                        runningCounter = 250;
                        target = null;
                    }
                    else {
                        lastJump = getX();
                    }
                    jumpsAI++;
                    controllJumpPosition = false;
                }
                if (jumpingCounterAI < 25) {
                    if (imageLeft) {
                        moveLeft();
                    }
                    else {
                        moveRight();
                    }
                }
                else if (jumpingCounterAI == 25) {
                    jump = true;
                    jumpingCounter = 0;
                    if (imageLeft) {
                        velX = 1.5;
                    }
                    else {
                        velX = -1.5;
                    }
                    velY = 7;
                }
                else if (jumpingCounterAI == 55) {
                    jumpingCounterAI = -1;
                }
                jumpingCounterAI++;
            }
            else if (jumpsAI >= 5) {
                jumpingCounterAI = 0;
            }
            if (shoot) {
                getWorld().removeObject(aimDisplay);
            }
            if (life <= 0) {
                if (dieCounter > 100) {
                    try {
                        if (executing) {
                            ((Worms_Land) getWorld()).setClaim(6, this);
                        }
                        else {
                            ((Worms_Land) getWorld()).setClaim(4, this);
                            if (((Worms_Land) getWorld()).getExecutingWorm().getParty() == this.getParty()) {
                                ((Worms_Land) getWorld()).setClaim(8, ((Worms_Land) getWorld()).getExecutingWorm());
                            }
                        }
                        if (((Worms_Land) getWorld()).getTeam(getParty()).size() == 1) {
                            ((Worms_Land) getWorld()).setClaim(3, this);
                        }
                    }
                    catch (NullPointerException npe) {
                        //npe.printStackTrace();
                    }
                    die(false);
                    return;
                }
                else {
                    dieCounter++;
                }
            }
        }
    }
    
    /**
     * Changes the location of the worm to the given coordinates if it's possible to move there.
     * 
     * @param x
     *      The X coordinate of the new location.
     * 
     * @param
     *      The Y coordinate of the new location.
     */
    public void setLocation(int x, int y) {
        if (((Worms_Land) getWorld()).getMaterialAt(x, y+15).getMaterial() != 1) {//check that the worm is not moved into earth;
            super.setLocation(x, y);
        }
    }
    
    /**
     * Make the worm jump in the current direction.
     * To make him jump more far press the key of the direction he's jumping.
     * To make him jump higher press the up key.
     */
    private void jump() {
        if (((Worms_Land) getWorld()).getMaterialAt((int) (getX()+velX), (int) (getY()-velY+25)).getMaterial() == 1 && jumpingCounter > 5) {
            velX = 0;
            velY = 0;
            jump = false;
            jumpingCounterAI = 0;
            if (artificialIntelligence) {
                if (imageLeft) {
                    moveRight();
                }
                else {
                    moveLeft();
                }
            }
        }
        else {
            velY -= Worms_Land.GRAVITY;
            if (velX < 0.1) {
                velX += 0.02;
            }
            else if (velX > -0.1) {
                velX -= 0.02;
            }
            if (velX < 0.3 && velX > -0.3) {
                velX = 0;
                velY = 0;
                flying = false;
            }
            jumpingCounter++;
            if (((Worms_Land) getWorld()).getMaterialAt((int) (getX()+velX), (int) (getY()-velY+25)).getMaterial() != 1) {
                setLocation((int) (getX() + velX), (int) (getY() - velY));
            }
        }
    }
    
    /**
     * Make the worm fly (or fall) taking into account the gravity but not the wind.
     */
    private void fly() {
        if (velY > 0) {
            velY -= Worms_Land.GRAVITY;
        }
        else {
            velY = 0;
        }
        if (velX < 0.1) {
            velX += 0.02;
        }
        else if (velX > -0.1) {
            velX -= 0.02;
        }
        if (((Worms_Land) getWorld()).getMaterialAt((int) (getX()+velX), (int) (getY()-velY+25)).getMaterial() == 1) {
            if (velX < 0.1) {
                velX += 0.07;
            }
            else if (velX > -0.1) {
                velX -= 0.07;
            }
        }
        if (velX < 0.5 && velX > -0.5) {
            velX = 0;
            velY = 0;
            flying = false;
        }
        if (((Worms_Land) getWorld()).getMaterialAt((int) (getX()+velX), (int) (getY()-velY)).getMaterial() == 1) {
            if (((Worms_Land) getWorld()).getMaterialAt((int) (getX()), (int) (getY()+25)).getMaterial() == 1) {
                setLocation(getX(), getY()-25);
            }
            velX = 0;
            velY = 0;
            flying = false;
            //count damage;
        }
        else {
            setLocation((int) (getX() + velX), (int) (getY() - velY));
        }
    }
    
    
    /**
     * Add the weapons to the world that are needet to shoot (like shotguns or baseballbats).
     */
    private void addWeapons() {
        try {
            switch (weaponUsing) {
                case 4:
                    if (addWeapon) {
                        if (getWorld().getObjects(Shotgun.class).isEmpty()) {
                            if (imageLeft) {
                                getWorld().addObject(shotgun, getX()-15, getY()+5);
                            }
                            else {
                                getWorld().addObject(shotgun, getX()+15, getY()+5);
                            }
                        }
                    }
                    else {
                        addWeapon = true;
                    }
                    break;
                case 8:
                    if (addWeapon) {
                        if (getWorld().getObjects(Baseball_Bat.class).isEmpty()) {
                            if (imageLeft) {
                                getWorld().addObject(baseballBat, getX()-15, getY()+15);
                            }
                            else {
                                getWorld().addObject(baseballBat, getX()+15, getY()+15);
                            }
                        }
                    }
                    else {
                        addWeapon = true;
                    }
                    break;
            }
        }
        catch (NullPointerException npe) {
            //npe.printStackTrace();
        }
    }
    
    /**
     * Choose which weapon the worm could use in this round.
     * Only important for AI controlled worms.
     * 
     * @param enemyWorms
     *      A list of all enemy worms which are existing in the world.
     */
    private void chooseWeapon(java.util.List<Worm> enemyWorms) {
        Weapon_Package weaponPackage = ((Worms_Land) getWorld()).getWeaponPackage();
        int random;
        int[] weaponNumber = weaponPackage.getWeaponNumber(getParty());
        int[] weaponProbability = new int[10];
        int[] throwingWeaponProbability = new int[10];
        int totalWeaponProbability = 0;
        int numberOfAllWeapons = 0;//inf = 15;
        int numberOfAllThrowingWeapons = 0;
        boolean[] weaponUsability = weaponPackage.getWeaponUsability(getParty());
        for (int i = 0; i < weaponNumber.length; i++) {
            if (!weaponTried[i]) {
                numberOfAllWeapons += (weaponNumber[i] == 11 ? 15 : weaponNumber[i]);
            }
        }
        for (int i = 0; i < 10; i++) {
            if (!weaponTried[i] && (i == 0 || i == 1 || i == 8 || i == 9)) {
                numberOfAllThrowingWeapons += (weaponNumber[i] == 11 ? 15 : weaponNumber[i]);
            }
        }
        for (int i = 0; i < 10; i++) {
            if (!weaponTried[i]) {
                weaponProbability[i] = weaponNumber[i] + totalWeaponProbability;
                totalWeaponProbability += weaponNumber[i];
            }
            else {
                weaponProbability[i] = totalWeaponProbability;
            }
        }
        totalWeaponProbability = 0;
        for (int i = 0; i < 10; i++) {
            if (!weaponTried[i]) {
                if (i == 0 || i == 1 || i == 8 || i == 9) {
                    throwingWeaponProbability[i] = weaponNumber[i] + totalWeaponProbability;
                    totalWeaponProbability += weaponNumber[i];
                }
            }
            else if (i == 0 || i == 1 || i == 8 || i == 9) {
                throwingWeaponProbability[i] = totalWeaponProbability;
            }
        }
        for (Worm w : enemyWorms) {
            if (freeShotAngle(w) && getObjectsDistance(this, w) > 150) {
                target = w;
                random = Greenfoot.getRandomNumber(numberOfAllThrowingWeapons);
                if (random < throwingWeaponProbability[0]) {
                    if (weaponUsability[0]) {
                        weaponUsing = 1;
                        weaponTried[0] = true;
                        tacticalDisplay.setTextChanged(true);
                        missileTarget = false;
                        return;
                    }
                }
                else if (random < throwingWeaponProbability[1]) {
                    if (weaponUsability[1]) {
                        weaponUsing = 2;
                        weaponTried[1] = true;
                        tacticalDisplay.setTextChanged(true);
                        missileTarget = false;
                        return;
                    }
                }
                else if (random < throwingWeaponProbability[8]) {
                    if (weaponUsability[8]) {
                        weaponUsing = 9;
                        weaponTried[8] = true;
                        tacticalDisplay.setTextChanged(true);
                        missileTarget = false;
                        return;
                    }
                }
                else {
                    if (weaponUsability[9]) {
                        weaponUsing = 10;
                        weaponTried[9] = true;
                        tacticalDisplay.setTextChanged(true);
                        missileTarget = false;
                        return;
                    }
                }
            }
        }
        for (int i = 0; i < 25; i++) {
            random = Greenfoot.getRandomNumber(numberOfAllWeapons);
            if (random < weaponProbability[0]) {
                if (weaponUsability[0]) {
                    weaponUsing = 1;
                    weaponTried[0] = true;
                    tacticalDisplay.setTextChanged(true);
                    missileTarget = false;
                    break;
                }
            }
            else if (random < weaponProbability[1]) {
                if (weaponUsability[1]) {
                    weaponUsing = 2;
                    weaponTried[1] = true;
                    tacticalDisplay.setTextChanged(true);
                    missileTarget = false;
                    break;
                }
            }
            else if (random < weaponProbability[2]) {
                if (weaponUsability[2]) {
                    weaponUsing = 3;
                    weaponTried[2] = true;
                    tacticalDisplay.setTextChanged(true);
                    missileTarget = false;
                    break;
                }
            }
            else if (random < weaponProbability[3]) {
                if (weaponUsability[3]) {
                    weaponUsing = 4;
                    weaponTried[3] = true;
                    tacticalDisplay.setTextChanged(true);
                    missileTarget = false;
                    getWorld().removeObject(aimDisplay);
                    if (getWorld().getObjects(Shotgun.class).isEmpty()) {
                        if (imageLeft) {
                            getWorld().addObject(shotgun, getX()-15, getY()+5);
                        }
                        else {
                            getWorld().addObject(shotgun, getX()+15, getY()+5);
                        }
                    }
                    break;
                }
            }
            else if (random < weaponProbability[4]) {
                if (weaponUsability[4]) {
                    weaponUsing = 5;
                    weaponTried[4] = true;
                    tacticalDisplay.setTextChanged(true);
                    missileTarget = false;
                    getWorld().removeObject(aimDisplay);
                    break;
                }
            }   
            else if (random < weaponProbability[5]) {
                if (weaponUsability[5] && !triedWalkingWeapon) {
                    weaponUsing = 6;
                    weaponTried[5] = true;
                    tacticalDisplay.setTextChanged(true);
                    missileTarget = false;
                    getWorld().removeObject(aimDisplay);
                    break;
                }
            }
            else if (random < weaponProbability[6]) {
                if (weaponUsability[6]) {
                    weaponUsing = 7;
                    weaponTried[6] = true;
                    tacticalDisplay.setTextChanged(true);
                    missileTarget = false;
                    getWorld().removeObject(aimDisplay);
                    break;
                }
            }
            else if (random < weaponProbability[7]) {
                if (weaponUsability[7] && !triedWalkingWeapon) {
                    weaponUsing = 8;
                    weaponTried[7] = true;
                    tacticalDisplay.setTextChanged(true);
                    missileTarget = false;
                    getWorld().removeObject(aimDisplay);
                    if (getWorld().getObjects(Baseball_Bat.class).isEmpty()) {
                        if (imageLeft) {
                            getWorld().addObject(baseballBat, getX()-15, getY()+15);
                        }
                        else {
                            getWorld().addObject(baseballBat, getX()+15, getY()+15);
                        }
                    }
                    break;
                }
            }
            else if (random < weaponProbability[8]) {
                if (weaponUsability[8]) {
                    weaponUsing = 9;
                    weaponTried[8] = true;
                    tacticalDisplay.setTextChanged(true);
                    missileTarget = false;
                    break;
                }
            }
            else {
                if (weaponUsability[9]) {
                    weaponUsing = 10;
                    weaponTried[9] = true;
                    tacticalDisplay.setTextChanged(true);
                    missileTarget = false;
                    break;
                }
            }
            if (i == 24) {
                for (int j = 0; i < weaponUsability.length; i++) {
                    if (weaponUsability[i]) {
                        weaponUsing = i+1;
                        tacticalDisplay.setTextChanged(true);
                        missileTarget = false;
                    }
                }
            }
        }
        tacticalDisplay.setTextChanged(true);
    }
    
    /**
     * Make the worm wait (do nothing) for a randomly got time between the two parameters.
     * Only important for AI controlled worms.
     * 
     * @param startTime
     *      The minimum time the worm has to wait.
     * 
     * @param
     *      The maximum time the worm can wait.
     */
    private void wait(int startTime, int endTime) {//only A.I.;
        waitingCounter = Greenfoot.getRandomNumber(((endTime - startTime) < 1 ? 1 : (endTime - startTime))) + endTime + 1;
    }
    
    /**
     * Make the worm play his specific sound file.
     */
    private void talk() {
        GreenfootSound sound = new GreenfootSound(Settings.getSoundByNumber(languagePack));
        sound.setVolume(Settings.effectVolume);
        sound.play();
        //Greenfoot.playSound(Settings.getSoundByNumber(languagePack));
    }
    
    //change the weapon after setExecuting() if the weapon is not usable;
    /**
     * Check if the currently used weapon is still aviable and change the weapon if not.
     */
    public void checkForWeaponsExisting() {
        try {
            Weapon_Package weaponPackage = ((Worms_Land) getWorld()).getWeaponPackage();
            if (weaponPackage.getWeaponNumber(party, weaponUsing) == 0 || weaponPackage.getWeaponDelay(party, weaponUsing) > 0) {
                for (int i = 0; i < 10; i++) {
                    if (weaponPackage.getWeaponNumber(party, i+1) > 0 && weaponPackage.getWeaponDelay(party, i+1) == 0) {
                        setWeaponUsing(i+1);
                        tacticalDisplay.setTextChanged(true);
                        setMissileTarget(false);
                    }
                }
            }
        }
        catch (NullPointerException npe) {
            //npe.printStackTrace();
            //only executed if there is no world like in the case the game is started;
        }
    }
    
    public void improveShootingAlgorithm(Worm shootingWorm, Worm enemyWorm, Weapon weaponUsed, Point impactPoint) {
        if (!GreenfootToolkit.getToolkit().playingOnline() && weaponUsed instanceof Bazooka || weaponUsed instanceof Grenade || weaponUsed instanceof Clustergrenade || 
            weaponUsed instanceof Holly_Grenade || weaponUsed instanceof Bananabomb) {
            java.util.List<String> fileText = GreenfootToolkit.getToolkit().loadFile("calculateShoot_adaptivAlgorithm.txt");
            double wind = Worms_Land.WIND;
            double deviation = Math.hypot(enemyWorm.getX() - shootingWorm.getX(), enemyWorm.getY() - shootingWorm.getY());
            double impactDevilationX = Math.abs(enemyWorm.getX() - impactPoint.getX());
            double impactDevilationY = Math.abs(enemyWorm.getY() - impactPoint.getY());
            double temp;
            int deltaX = (int) (enemyWorm.getX() - getX());
            int deltaY = (int) (enemyWorm.getY() - getY());
            if (deviation > 400) {
                return;
            }
            if (fileText == null) {
                createDefaultAlgorithmFile();
                fileText = GreenfootToolkit.getToolkit().loadFile("calculateShoot_adaptivAlgorithm.txt");
            }
            if (!(enemyWorm.getX() > impactPoint.getX() - 35 && enemyWorm.getX() < impactPoint.getX() + 35 && enemyWorm.getY() > impactPoint.getY() - 35 && enemyWorm.getY() < impactPoint.getY() + 35)) {
                double windInfluence = (1500.0 * Math.abs(wind)) / 100;
                double changeX = (((25.0/265.0) * impactDevilationX - (875.0/265.0)) / 100) * (1 - windInfluence);
                double changeY = (((25.0/265.0) * impactDevilationY - (875.0/265.0)) / 100) * (1 - windInfluence);
                boolean incrementX;
                boolean incrementY;
                //System.out.println("Algorithm adapted");
                if (impactPoint.getX() > enemyWorm.getX()) {
                    if (shootingWorm.getX() > enemyWorm.getX()) {
                        incrementX = true;
                    }
                    else {
                        incrementX = false;
                    }
                }
                else {
                    if (shootingWorm.getX() > enemyWorm.getX()) {
                        incrementX = false;
                    }
                    else {
                        incrementX = true;
                    }
                }
                if (impactPoint.getY() > enemyWorm.getY()) {
                    if (shootingWorm.getY() > enemyWorm.getY()) {
                        incrementY = true;
                    }
                    else {
                        incrementY = false;
                    }
                }
                else {
                    if (shootingWorm.getY() > enemyWorm.getY()) {
                        incrementY = false;
                    }
                    else {
                        incrementY = true;
                    }
                }
                if (changeX < 0) {
                    changeX = 0;
                }
                if (changeY < 0) {
                    changeY = 0;
                }
                if (deltaY < -Math.abs(deltaX)) {
                    temp = Double.parseDouble(fileText.get(0));
                    fileText.set(0, Double.toString(temp + (incrementX ? (changeX * temp) : -(changeX * temp))));
                    temp = Double.parseDouble(fileText.get(1));
                    fileText.set(1, Double.toString(temp + (incrementY ? (changeY * temp) : -(changeY * temp))));
                }
                else if (deltaY < -400) {
                    temp = Double.parseDouble(fileText.get(2));
                    fileText.set(2, Double.toString(temp + (incrementX ? (changeX * temp) : -(changeX * temp))));
                    temp = Double.parseDouble(fileText.get(3));
                    fileText.set(3, Double.toString(temp + (incrementY ? (changeY * temp) : -(changeY * temp))));
                }
                else if (deltaY < -250) {
                    temp = Double.parseDouble(fileText.get(4));
                    fileText.set(4, Double.toString(temp + (incrementX ? (changeX * temp) : -(changeX * temp))));
                    if (Math.abs(deltaX) > 300) {
                        temp = Double.parseDouble(fileText.get(5));
                        fileText.set(5, Double.toString(temp + (incrementY ? (changeY * temp) : -(changeY * temp))));
                    }
                    else {
                        temp = Double.parseDouble(fileText.get(6));
                        fileText.set(6, Double.toString(temp + (incrementY ? (changeY * temp) : -(changeY * temp))));
                    }
                }
                else if (deltaY > 100) {
                    if (Math.abs(deltaX) < 250) {
                        temp = Double.parseDouble(fileText.get(7));
                        fileText.set(7, Double.toString(temp + (incrementX ? (changeX * temp) : -(changeX * temp))));
                    }
                    else {
                        temp = Double.parseDouble(fileText.get(8));
                        fileText.set(8, Double.toString(temp + (incrementX ? (changeX * temp) : -(changeX * temp))));
                    }
                    temp = Double.parseDouble(fileText.get(9));
                    fileText.set(9, Double.toString(temp + (incrementY ? (changeY * temp) : -(changeY * temp))));
                }
                else if (deltaX < 300) {
                    temp = Double.parseDouble(fileText.get(10));
                    fileText.set(10, Double.toString(temp + (incrementX ? (changeX * temp) : -(changeX * temp))));
                    if (deltaY < 0) {
                        temp = Double.parseDouble(fileText.get(11));
                        fileText.set(11, Double.toString(temp + (incrementY ? (changeY * temp) : -(changeY * temp))));
                    }
                }
                else if (deltaX < 600) {
                    temp = Double.parseDouble(fileText.get(12));
                    fileText.set(12, Double.toString(temp + (incrementX ? (changeX * temp) : -(changeX * temp))));
                    if (deltaY < 0) {
                        temp = Double.parseDouble(fileText.get(13));
                        fileText.set(13, Double.toString(temp + (incrementY ? (changeY * temp) : -(changeY * temp))));
                    }
                }
                else {
                    temp = Double.parseDouble(fileText.get(14));
                    fileText.set(10, Double.toString(temp + (incrementX ? (changeX * temp) : -(changeX * temp))));
                    if (deltaY < 0) {
                        temp = Double.parseDouble(fileText.get(15));
                        fileText.set(13, Double.toString(temp + (incrementY ? (changeY * temp) : -(changeY * temp))));
                    }
                }
                if (weaponUsed instanceof Bazooka) {
                    if (Math.abs(wind) < 0.025) {
                        temp = Double.parseDouble(fileText.get(16));
                        fileText.set(16, Double.toString(temp + (incrementX ? ((windInfluence / 10) * temp) : -((windInfluence / 10) * temp))));
                    }
                    else {
                        temp = Double.parseDouble(fileText.get(17));
                        fileText.set(17, Double.toString(temp + (incrementX ? ((windInfluence / 10) * temp) : -((windInfluence / 10) * temp))));
                    }
                }
                else if (weaponUsed instanceof Grenade || weaponUsed instanceof Clustergrenade || weaponUsed instanceof Holly_Grenade || weaponUsed instanceof Bananabomb) {
                    if (Math.abs(wind) < 0.025) {
                        temp = Double.parseDouble(fileText.get(18));
                        fileText.set(18, Double.toString(temp + (incrementX ? ((windInfluence / 10) * temp) : -((windInfluence / 10) * temp))));
                    }
                    else {
                        temp = Double.parseDouble(fileText.get(19));
                        fileText.set(19, Double.toString(temp + (incrementX ? ((windInfluence / 10) * temp) : -((windInfluence / 10) * temp))));
                    }
                }
            }
            for (String text : fileText) {
                //System.out.println(text);
            }
            if (!GreenfootToolkit.getToolkit().saveFile("calculateShoot_adaptivAlgorithm.txt", false, fileText)) {
                //System.out.println("Worm: improveAdaptiveAlgorithm: Fatal error occured; File couldn't be saved.");
            }
        }
    }
    
    public void createDefaultAlgorithmFile() {
        GreenfootToolkit.getToolkit().saveFile("calculateShoot_adaptivAlgorithm.txt", false, Double.toString(20.0/1200.0), Double.toString(10.0/700.0), Double.toString(20.0/1200.0), 
            Double.toString(9.0/700.0), Double.toString(20.0/1200.0), Double.toString(9.0/700.0), Double.toString(7.5/700.0), Double.toString(13.0/1200.0), Double.toString(15.0/1200.0), 
            Double.toString(5.0/700.0), Double.toString(18.0/1200.0), Double.toString(5.0/700.0), Double.toString(14.0/1200.0), Double.toString(5.0/700.0), Double.toString(12.0/1200.0), 
            Double.toString(5.0/700.0), Double.toString(2.5), Double.toString(1.3), Double.toString(1.8), Double.toString(0.7));
    }
    
    //kill the worm and all other referenced;
    /**
     * Remove the worm and all references and make him explode if he hasn't died because of the water.
     * 
     * @param water
     *      If the worm dies because of water he'll not explode.
     */
    private void die(boolean water) {
        if (!water) {
            explode();
        }
        ((Worms_Land) getWorld()).setKillNumber(1);
        getWorld().addObject(new Grave_Stone(party, velX, velY), getX(), getY());
        try {
            getWorld().removeObject(aimDisplay);
            getWorld().removeObject(tacticalDisplay);
            getWorld().removeObject(shotgun);
            getWorld().removeObject(baseballBat);
        }
        catch (NullPointerException npe) {
            //npe.printStackTrace();
        }
        if (executing) {
            ((Worms_Land) getWorld()).setWeaponThrown(true);
        }
        getWorld().removeObject(this);
    }
    
    /**
     * Make the worm explode, kill everything near to him and blow it up.
     */
    private void explode() {
        List<Worm> worms = getObjectsInRange(EXPLOSIONS_RADIUS, Worm.class);
        List<Grave_Stone> graves = getObjectsInRange(EXPLOSIONS_RADIUS, Grave_Stone.class);
        List<Mine> mines = getObjectsInRange(EXPLOSIONS_RADIUS, Mine.class);
        List<Oil_Drum> oilDrums = getObjectsInRange(EXPLOSIONS_RADIUS, Oil_Drum.class);
        int damage;
        for (int i = 0; i < worms.size(); i++) {
            damage = (int) (-0.3125*getObjectsDistance(this, worms.get(i))+31.25);
            if (damage > 25) {
                damage = 25;
            }
            worms.get(i).setLife(-damage);
        }
        for (int i = 0; i < worms.size(); i++) {
            blowUp(Math.toRadians(directionToTurnTo(worms.get(i).getX(), worms.get(i).getY())), (((-0.5/EXPLOSIONS_RADIUS)*getObjectsDistance(worms.get(i), this))+0.5), worms.get(i));
        }
        for (int i = 0; i < graves.size(); i++) {
            blowUp(Math.toRadians(directionToTurnTo(graves.get(i).getX(), graves.get(i).getY())), (((-0.3/EXPLOSIONS_RADIUS)*getObjectsDistance(graves.get(i), this))+0.4), graves.get(i));
        }
        for (int i = 0; i < mines.size(); i++) {
            blowUp(Math.toRadians(directionToTurnTo(mines.get(i).getX(), mines.get(i).getY())), (((-0.2/EXPLOSIONS_RADIUS)*getObjectsDistance(mines.get(i), this))+0.2), mines.get(i));
        }
        for (int i = 0; i < oilDrums.size(); i++) {
            oilDrums.get(i).explode();
        }
        destroyWorld(getX(), getY(), (int) (EXPLOSIONS_RADIUS*0.4));
        getWorld().addObject(new Explosion(1.5), getX(), getY());
    }
    
    /**
     * Changes the world and the textur after an explosion.
     */
    private void destroyWorld(int x, int y, int radius) {
        GreenfootImage bg = ((Worms_Land) getWorld()).getBackground();
        bg.setColor(Color.white);
        bg.fillOval(x-radius, y-radius, 2*radius, 2*radius);
        ((Worms_Land) getWorld()).changeTextur(x, y, radius);
        ((Worms_Land) getWorld()).redrawWater();
    }
    
    /**
     * Change the movement of worms near to an explosion.
     * 
     * @param angleRadians
     *      The angle as radians of the direction the worm should move to.
     * 
     * @param forceFactor
     *      The whith wich the worm should be moved.
     * 
     * @param worm
     *      The reference to the worm that should be moved.
     */
    private void blowUp(double angleRadians, double forceFactor, Worm worm) {
        double vx = getVelX(angleRadians, forceFactor);
        double vy = getVelY(angleRadians, forceFactor);
        if (worm != null) {
            worm.setFlying(true, vx, vy);
        }
    }
    /**
     * Change the movement of the graves near to an explosion.
     * 
     * @param angleRadians
     *      The angle as radians of the direction the grave should move to.
     * 
     * @param forceFactor
     *      The whith wich the grave should be moved.
     * 
     * @param worm
     *      The reference to the grave that should be moved.
     */
    private void blowUp(double angleRadians, double forceFactor, Grave_Stone grave) {
        double vx = getVelX(angleRadians, forceFactor);
        double vy = getVelY(angleRadians, forceFactor);
        if (grave != null) {
            grave.setFlying(true, vx, vy);
        }
    }
    /**
     * Change the movement of mines near to an explosion.
     * 
     * @param angleRadians
     *      The angle as radians of the direction the mine should move to.
     * 
     * @param forceFactor
     *      The whith wich the mine should be moved.
     * 
     * @param worm
     *      The reference to the mine that should be moved.
     */
    private void blowUp(double angleRadians, double forceFactor, Mine mine) {
        double vx = getVelX(angleRadians, forceFactor);
        double vy = getVelY(angleRadians, forceFactor);
        if (mine != null) {
            mine.setFlying(true, vx, vy);
        }
    }
    
    /**
     * Reset all variables of the worm so that he has to be reinitialised.
     */
    public void resetAll() {
        life = Settings.wormLife;
        weaponUsing = 1;
        fallingCounter = 0;
        jumpingCounter = 0;
        dieCounter = 0;
        countdownTime = 5;
        selectCounter = 0;
        missileX = 0;
        missileY = 0;
        executing = false;
        weaponChange = false;
        falling = false;
        flying = false;
        tacticalDisplayAdded = false;
        shoot = false;
        jump = false;
        secondShotgun = false;
        addWeapon = false;
        missileTarget = false;
    }
    
    /**
     * Reset the value of the weaponTried variable if the conditions of the game have changed.
     */
    private void resetWeaponTried() {
        boolean[] weaponUsability = new boolean[10];
        try {
            weaponUsability = ((Worms_Land) getWorld()).getWeaponPackage().getWeaponUsability(getParty());
        }
        catch (NullPointerException npe) {
            //npe.printStackTrace();
        }
        for (int i = 0; i < weaponTried.length; i++) {
            if (!weaponUsability[i]) {
                weaponTried[i] = true;
            }
            else {
                weaponTried[i] = false;
            }
        }
    }
    /**
     * Check whether every weapon was tried.
     * 
     * @return
     *      Returns true if every weapon was tried.
     */
    private boolean everyWeaponTried() {
        for (boolean weapon : weaponTried) {
            if (!weapon) {
                return false;
            }
        }
        return true;
    }
    
    /**
     * Make the worm move left if it's possible and return true (only if it's possible).
     * 
     * @return
     *      Returns true if the movement was possible.
     */
    public boolean moveLeft() {
        if (!imageLeft) {
            getImage().mirrorHorizontally();
            imageLeft = true;
        }
        if (((Worms_Land) getWorld()).getMaterialAt(getX()-1, getY()+15).getMaterial() != 1) {
            setLocation(getX()-1, getY());
            if (artificialIntelligence) {
                resetWeaponTried();
            }
            return true;
        }
        return false;
    }
    /**
     * Make the worm move right if it's possible and return true (only if it's possible).
     * 
     * @return
     *      Returns true if the movement was possible.
     */
    public boolean moveRight() {
        if (imageLeft) {
            getImage().mirrorHorizontally();
            imageLeft = false;
        }
        if (((Worms_Land) getWorld()).getMaterialAt(getX()+1, getY()+15).getMaterial() != 1) {
            setLocation(getX()+1, getY());
            if (artificialIntelligence) {
                resetWeaponTried();
            }
            return true;
        }
        return false;
    }
    
    /**
     * Check whether the worm will walk into water at the next moving Position.
     * 
     * @param x
     *      The X coordinate of the point that is checked.
     * 
     * @param y
     *      The Y coordinate of the point that is checked.
     * 
     * @return
     *      Returns true if there is no earth at ne position so that the worm would walk into water.
     */
    public boolean waterAtMovingPosition(int x, int y) {
        for (; y < 700; y++) {
            if (((Worms_Land) getWorld()).getMaterialAt(x, y).getMaterial() == 1) {
                return false;
            }
        }
        return true;
    }
    
    /**
     * Check whether there is an enemy existing in the world.
     * 
     * @return
     *      Returns true if there is any worm existing in the world which party is diferent to the party of the calling worm.
     */
    public boolean enemyWormExisting() {
        List<Worm> worms = getWorld().getObjects(Worm.class);
        for (int i = 0; i < worms.size(); i++) {
            if (worms.get(i).getParty() != party) {
                return true;
            }
        }
        return false;
    }
    
    /**
     * Check whether there is anything in your way.
     * 
     * @param weapon
     *      An object of the weapon that is used.
     * 
     * @param velX
     *      The starting value of the shoot (change in X direction).
     * 
     * @param velY
     *      The starting value of the shoot (change in Y direction).
     * 
     * @param distance
     *      The needed distance of a free shooting angle.
     * 
     * @return
     *      Returns true if the weapon can fly without beeing interrupted for the given distance.
     */
    private boolean freeShootingAngle(Weapon weapon, double velX, double velY, int distance) {
        Calculator calculator = new Calculator(getWorld(), weapon, velX, velY, getX(), getY(), null);
        int[] impactCoordinates = calculator.getImpactCoordinates();
        return Math.hypot((int) (getX() - impactCoordinates[0]), (int) (getY() - impactCoordinates[1])) > distance;
    }
    
    /**
     * Check whether the target get's hit using the given shooting calculations.
     * 
     * @param weapon
     *      An object of the weapon that is used.
     * 
     * @param target
     *      A reference to the worm that is tried to hit.
     * 
     * @param velX
     *      The starting value of the shoot (change in X direction).
     * 
     * @param velY
     *      The starting value of the shoot (change in Y direction).
     * 
     * @return
     *      Returns true if the weapon will hit the target worm so that it'll get damage.
     */
    private boolean targetHit(Weapon weapon, Worm target, double velX, double velY) {
        Calculator calculator = new Calculator(getWorld(), weapon, velX, velY, getX(), getY(), null);
        int[] impactCoordinates = calculator.getImpactCoordinates();
        return getPointsDistance(new Point(impactCoordinates[0], impactCoordinates[1]), new Point(target.getX(), target.getY())) <= 150;
    }
    
    /**
     * Check whether the current map has got a cover.
     * 
     * @return
     *      Returns true if the map has less than the half of it's width coverd.
     */
    private boolean mapWithoutCover() {
        int positivePoints = 0;
        for (int i = 0; i < 1200; i += 25) {
            if (((Worms_Land) getWorld()).getMaterialAt(i, 10).getMaterial() == 1) {
                positivePoints++;
                if (positivePoints >= 25) {
                    return false;
                }
            }
        }
        return true;
    }
    
    /**
     * Check whether there is a free shooting angle into the direction of the parameter angle.
     * 
     * @param angle
     *      The angle you want to prove for a free shooting angle.
     * 
     * @param distance
     *      The distance of the free area.
     * 
     * @return
     *      Returns true if there is a free shooting angle.
     */
    private boolean freeShotAngle(double angle, double distance) {
        double[] newCoordinates;
        double x = getX();
        double y = getY();
        for (int i = 0; i < 100; i++) {
            newCoordinates = move(x, y, angle, (distance/100));
            x = newCoordinates[0];
            y = newCoordinates[1];
            if (((Worms_Land) getWorld()).getMaterialAt((int) x, (int) y).getMaterial() == 1) {
                return false;
            }
        }
        return true;
    }
    /**
     * Check whether there is a free shooting angle into the direction of a worm.
     * 
     * @param enemyWorm
     *      The worm which direction you want to prove for a free shooting angle.
     * 
     * @param distance
     *      The distance of the free area.
     * 
     * @return
     *      Returns true if there is a free shooting angle.
     */
    private boolean freeShotAngle(Worm enemyWorm, double distance) {
        double[] newCoordinates;
        double x = getX();
        double y = getY();
        double rotation = directionToTurnTo(enemyWorm.getX(), enemyWorm.getY());
        for (int i = 0; i < 100; i++) {
            newCoordinates = move(x, y, rotation, (distance/100));
            x = newCoordinates[0];
            y = newCoordinates[1];
            if (((Worms_Land) getWorld()).getMaterialAt((int) x, (int) y).getMaterial() == 1) {
                return false;
            }
        }
        return true;
    }
    /**
     * Check whether there is a free shooting angle for the whole way to a worm.
     * 
     * @param enemyWorm
     *      The worm which direction you want to prove for a free shooting angle.
     * 
     * @return
     *      Returns true if there is a free shooting angle for the whole way to the enemy worm.
     */
    private boolean freeShotAngle(Worm enemyWorm) {
        double[] newCoordinates;
        double x = getX();
        double y = getY();
        double rotation = directionToTurnTo(enemyWorm.getX(), enemyWorm.getY());
        double distance = getObjectsDistance(this, enemyWorm);
        for (int i = 0; i < 100; i++) {
            newCoordinates = move(x, y, rotation, (distance/100));
            x = newCoordinates[0];
            y = newCoordinates[1];
            if (((Worms_Land) getWorld()).getMaterialAt((int) x, (int) y).getMaterial() == 1) {
                return false;
            }
        }
        return true;
    }
    
    /**
     * Check whether the currenly used weapon needs an aim display.
     * 
     * @return
     *      Returns true if the weapon needs an aim display;
     */
    private boolean aimDisplayNeeded() {
        return weaponUsing == 1 || weaponUsing == 2 || weaponUsing == 3 || weaponUsing == 9 || weaponUsing == 10;
    }
    
    /**
     * Try to make the worm move out of the earth if it's location is set to low.
     * 
     * @return
     *      Returns true if the worm isn't stack in earth or if it could be moved out of earth. Otherwhile returns false.
     */
    public boolean moveOutOfEarth() {
        if (((Worms_Land) getWorld()).getMaterialAt(getX(), getY() + 25).getMaterial() == 1) {
            for (int i = 1; i < 700; i += 5) {
                if (((Worms_Land) getWorld()).getMaterialAt(getX(), getY() + 25 - i).getMaterial() != 1) {
                    setLocation(getX(), getY() + 25 - i);
                    return true;
                }
            }
            return false;
        }
        else {
            return true;
        }
    }
    
    /**
     * Check whether a walking weapon would be possible.
     * 
     * @param shootingWorm
     *      The reference to the shooting worm that should be moved.
     * 
     * @param targetWorm
     *      The reference to the target worm that should be killed.
     * 
     * @return
     *      Returns true if there is no water on the whole moving distance.
     */
    private boolean walkingWeaponUsable(Worm shootingWorm, Worm targetWorm) {
        for (int i = 0; i < Math.abs(shootingWorm.getX() - targetWorm.getX()); i += 10) {
            if (waterAtMovingPosition(((shootingWorm.getX() < targetWorm.getX()) ? shootingWorm.getX() + i : shootingWorm.getX() - i), shootingWorm.getY()+15)) {
                return false;
            }
        }
        return true;
    }
    
    /**
     * Converts a force into a force-factor.
     * 
     * @param force
     *      The force which is converted.
     * 
     * @return
     *      The value of the parameter convertet into force-factor.
     */
    public double toForceFactor(double force) {
        if (force >= Worms_Land.MAX_FORCE) {
            return 1;
        }
        else if (force <= Worms_Land.MIN_FORCE) {
            return 0;
        }
        force = ((force / (Worms_Land.MAX_FORCE - Worms_Land.MIN_FORCE))- (Worms_Land.MAX_FORCE / (Worms_Land.MAX_FORCE - Worms_Land.MIN_FORCE)) + 1 );
        return force;
    }
    
    /**
     * Get the distance to the mate worm that is the nearest one to your position.
     * 
     * @return
     *      Returns the distance to your nearest mate worm.
     */
    private double distanceToNearestMate(Worm otherWorm) {
        double minDistance = 10000;
        List<Worm> mateWorms = getMateWorms();
        for (Worm w : mateWorms) {
            if (minDistance > getObjectsDistance(otherWorm, w)) {
                minDistance = getObjectsDistance(otherWorm, w);
            }
        }
        return minDistance;
    }
    /**
     * Get the distance to the worm next to you.
     * 
     * @return
     *      Returns the distance to the next worm.
     */
    private double distanceToNearestWorm(Worm otherWorm) {
        double minDistance = 10000;
        List<Worm> worms = getWorld().getObjects(Worm.class);
        for (Worm w : worms) {
            if (minDistance > getObjectsDistance(otherWorm, w)) {
                minDistance = getObjectsDistance(otherWorm, w);
            }
        }
        return minDistance;
    }
    /**
     * Get the distance to the next oil drum.
     * 
     * @return
     *      Returns the distance to the nearest oil drum.
     */
    private double distanceToNearestOilDrum() {
        double minDistance = 10000;
        List<Oil_Drum> oilDrums = getWorld().getObjects(Oil_Drum.class);
        for (Oil_Drum oil : oilDrums) {
            if (minDistance > getObjectsDistance(oil, this)) {
                minDistance = getObjectsDistance(oil, this);
            }
        }
        return minDistance;
    }
    
    public double[] calculateAdaptiv(Worm enemyWorm) {
        if (!GreenfootToolkit.getToolkit().playingOnline()) {
            java.util.List<String> fileText = GreenfootToolkit.getToolkit().loadFile("calculateShoot_adaptivAlgorithm.txt");
            double[] shootingValues = new double[2];
            double wind = Worms_Land.WIND;
            int deltaX = (int) (enemyWorm.getX() - getX());
            int deltaY = (int) (enemyWorm.getY() - getY());
            if (fileText == null) {
                createDefaultAlgorithmFile();
                return calculateShoot(enemyWorm);
            }
            if (deltaY < -Math.abs(deltaX)) {
                shootingValues[0] = Double.parseDouble(fileText.get(0)) * deltaX;
                shootingValues[1] = 3 + Double.parseDouble(fileText.get(1)) * Math.abs(deltaY);
                //shootingValues[0] -= (shootingValues[0] * wind * 0.3);
            }
            else if (deltaY < -400) {
                shootingValues[0] = Double.parseDouble(fileText.get(2)) * deltaX;
                shootingValues[1] = 3 + Double.parseDouble(fileText.get(3)) * Math.abs(deltaY);
            }
            else if (deltaY < -250) {
                shootingValues[0] = Double.parseDouble(fileText.get(4)) * deltaX;
                if (Math.abs(deltaX) > 300) {
                    shootingValues[1] = 3 + Double.parseDouble(fileText.get(5)) * Math.abs(deltaY);
                }
                else {
                    shootingValues[1] = 3 + Double.parseDouble(fileText.get(6)) * Math.abs(deltaY);
                }
            }
            else if (deltaY > 100) {
                if (Math.abs(deltaX) < 250) {
                    shootingValues[0] = Double.parseDouble(fileText.get(7)) * deltaX;
                }
                else {
                    shootingValues[0] = Double.parseDouble(fileText.get(8)) * deltaX;
                }
                shootingValues[1] = 3 - Double.parseDouble(fileText.get(9)) * Math.abs(deltaY);
            }
            else if (deltaX < 300) {
                shootingValues[0] = Double.parseDouble(fileText.get(10)) * deltaX;
                shootingValues[1] = 3;
                if (deltaY < 0) {
                    shootingValues[1] += Double.parseDouble(fileText.get(11)) * Math.abs(deltaY);
                }
            }
            else if (deltaX < 600) {
                shootingValues[0] = Double.parseDouble(fileText.get(12)) * deltaX;
                shootingValues[1] = 3;
                if (deltaY < 0) {
                    shootingValues[1] += Double.parseDouble(fileText.get(13)) * Math.abs(deltaY);
                }
            }
            else {
                shootingValues[0] = Double.parseDouble(fileText.get(14)) * deltaX;
                shootingValues[1] = 3;
                if (deltaY < 0) {
                    shootingValues[1] += Double.parseDouble(fileText.get(15)) * Math.abs(deltaY);
                }
            }
            if (weaponUsing == 1) {
                shootingValues[0] -= (shootingValues[0] * wind * (Math.abs(wind) < 0.025 ? Double.parseDouble(fileText.get(16)) : Double.parseDouble(fileText.get(17))));
            }
            else if (weaponUsing == 2 || weaponUsing == 3 || weaponUsing == 8 || weaponUsing == 9) {
                shootingValues[0] -= (shootingValues[0] * wind * (Math.abs(wind) < 0.025 ? Double.parseDouble(fileText.get(18)) : Double.parseDouble(fileText.get(19))));
            }
            return shootingValues;
        }
        else {
            return calculateShoot(enemyWorm);
        }
    }
    
    /**
     * Calculates the shooting values for an computer-controlled worm.
     * 
     * @param enemyWorm
     *      The reference to the worm you want to hit.
     * 
     * @return
     *      Returns the shooting values as an array.
     */
    public double[] calculateShoot(Worm enemyWorm) {
        double[] shootingValues = new double[2];
        double wind = Worms_Land.WIND;
        int deltaX = (int) (enemyWorm.getX() - getX());
        int deltaY = (int) (enemyWorm.getY() - getY());
        if (deltaY < -Math.abs(deltaX)) {
            shootingValues[0] = (20.0/1200.0) * deltaX;
            shootingValues[1] = 3 + (10.0/700.0) * Math.abs(deltaY);
            //shootingValues[0] -= (shootingValues[0] * wind * 0.3);
        }
        else if (deltaY < -400) {
            shootingValues[0] = (20.0/1200.0) * deltaX;
            shootingValues[1] = 3 + (9.0/700.0) * Math.abs(deltaY);
        }
        else if (deltaY < -250) {
            shootingValues[0] = (20.0/1200.0) * deltaX;
            if (Math.abs(deltaX) > 300) {
                shootingValues[1] = 3 + (9.0/700.0) * Math.abs(deltaY);
            }
            else {
                shootingValues[1] = 3 + (7.5/700.0) * Math.abs(deltaY);
            }
        }
        else if (deltaY > 100) {
            if (Math.abs(deltaX) < 250) {
                shootingValues[0] = (13.0/1200.0) * deltaX;
            }
            else {
                shootingValues[0] = (15.0/1200.0) * deltaX;
            }
            shootingValues[1] = 3 - (5.0/700.0) * Math.abs(deltaY);
        }
        else if (deltaX < 300) {
            shootingValues[0] = (18.0/1200.0) * deltaX;
            shootingValues[1] = 3;
            if (deltaY < 0) {
                shootingValues[1] += (5.0/700.0) * Math.abs(deltaY);
            }
        }
        else if (deltaX < 600) {
            shootingValues[0] = (14.0/1200.0) * deltaX;
            shootingValues[1] = 3;
            if (deltaY < 0) {
                shootingValues[1] += (5.0/700.0) * Math.abs(deltaY);
            }
        }
        else {
            shootingValues[0] = (12.0/1200.0) * deltaX;
            shootingValues[1] = 3;
            if (deltaY < 0) {
                shootingValues[1] += (5.0/700.0) * Math.abs(deltaY);
            }
        }
        if (weaponUsing == 1) {
            shootingValues[0] -= (shootingValues[0] * wind * (Math.abs(wind) < 0.025 ? 2.5 : 1.3));
        }
        else if (weaponUsing == 2 || weaponUsing == 3 || weaponUsing == 8 || weaponUsing == 9) {
            shootingValues[0] -= (shootingValues[0] * wind * (Math.abs(wind) < 0.025 ? 1.8 : 0.7));
        }
        return shootingValues;
    }
    
    /**
     * A list of all enemy worms that are existing in the world.
     * 
     * @return 
     *      Returns a list of all enemy worms.
     */
    public java.util.List<Worm> getEnemyWorms() {
        List<Worm> worms = getWorld().getObjects(Worm.class);
        for (int i = 0; i < worms.size(); i++) {
            if (worms.get(i).getParty() == this.getParty()) {
                worms.remove(i);
                i--;
            }
        }
        return worms;
    }
    
    /**
     * A list of all mate worms that are existing in the world.
     * 
     * @return
     *      Returns a list of all mate worms.
     */
    private java.util.List<Worm> getMateWorms() {
        List<Worm> worms = getWorld().getObjects(Worm.class);
        for (int i = 0; i < worms.size(); i++) {
            if (worms.get(i).getParty() != party) {
                worms.remove(i);
                i--;
            }
        }
        return worms;
    }
    
    /**
     * Choose a worm in the right distance for the calling worm is currently using.
     * 
     * @return
     *      Returns a reference to a worm in the world which is in the possible distance for the currently used weapon.
     */
    private Worm getTargetWorm(java.util.List<Worm> enemyWorms) {
        class TargetWorm {
            private Worm target;
            
            private double targetEffectiveness = 0;
            
            public TargetWorm(Worm target) {
                this.target = target;
            }
            
            public Worm getTarget() {
                return target;
            }
            public void setTarget(Worm target) {
                this.target = target;
            }
            
            public double getTargetEffectiveness() {
                return targetEffectiveness;
            }
            public void setTargetEffectiveness(double effectiveness) {
                targetEffectiveness += effectiveness;
            }
        }
        int minDistance;
        int maxDistance;//0 = infinity;
        int explosionsRadius;
        double distance;
        double[] shootingCalculations;
        TargetWorm mostEffectiveTarget = null;
        ArrayList<TargetWorm> possibleTargets = new ArrayList<TargetWorm>();
        switch (weaponUsing) {
            case 1:
                minDistance = 150;
                maxDistance = 0;
                explosionsRadius = Bazooka.EXPLOSIONS_RADIUS;
                break;
            case 2:
                minDistance = 50;
                maxDistance = 0;
                explosionsRadius = Grenade.EXPLOSIONS_RADIUS;
                break;
            case 3:
                minDistance = 100;
                maxDistance = 0;
                explosionsRadius = 3*Clustergrenade.EXPLOSIONS_RADIUS;
                break;
            case 4:
                minDistance = 50;
                maxDistance = 500;
                explosionsRadius = Bullet.explosionsRadius;
                break;
            case 5:
                minDistance = 250;
                maxDistance = 0;
                explosionsRadius = Seeking_Missile.EXPLOSIONS_RADIUS;
                break;
            case 6:
                minDistance = 0;
                maxDistance = 100;
                explosionsRadius = Dynamite.EXPLOSIONS_RADIUS;
                break;
            case 7:
                minDistance = 200;
                maxDistance = 700;
                explosionsRadius = Sheep.EXPLOSIONS_RADIUS;
                break;
            case 8:
                minDistance = 0;
                maxDistance = 100;
                explosionsRadius = 50;
                break;
            case 9:
                minDistance = 300;
                maxDistance = 0;
                explosionsRadius = Holly_Grenade.EXPLOSIONS_RADIUS;
                break;
            case 10:
                minDistance = 300;
                maxDistance = 0;
                explosionsRadius = 3*Bananabomb.EXPLOSIONS_RADIUS;
                break;
            default:
                minDistance = 0;
                maxDistance = 0;
                explosionsRadius = 150;
                break;
        }
        /*for (Worm w : enemyWorms) {
            distance = getObjectsDistance(this, w);
            if (distance > minDistance && (maxDistance == 0 ? true : distance < maxDistance) && distanceToNearestMate(w) > explosionsRadius) {
                return w;
            }
        }*/
        for (Worm w : enemyWorms) {
            distance = getObjectsDistance(this, w);
            shootingCalculations = calculateShoot(w);
            if (distance > minDistance && (maxDistance == 0 ? true : distance < maxDistance) && distanceToNearestMate(w) > explosionsRadius) {
                switch (weaponUsing) {
                    case 1:
                        if (targetHit(new Bazooka(), w, shootingCalculations[0], shootingCalculations[1])) {
                            possibleTargets.add(new TargetWorm(w));
                        }
                        break;
                    case 2:
                        if (targetHit(new Grenade(), w, shootingCalculations[0], shootingCalculations[1])) {
                            possibleTargets.add(new TargetWorm(w));
                        }
                        break;
                    case 3:
                        if (targetHit(new Clustergrenade(), w, shootingCalculations[0], shootingCalculations[1])) {
                            possibleTargets.add(new TargetWorm(w));
                        }
                        break;
                    case 4:
                        if (freeShotAngle(directionToTurnTo(w.getX(), w.getY()), 30)) {
                            possibleTargets.add(new TargetWorm(w));
                        }
                        break;
                    case 5:
                        if (!targetHit(new Bazooka(), w, shootingCalculations[0], shootingCalculations[1]) && (freeShotAngle(255, 400) || freeShotAngle(285, 400))) {
                            possibleTargets.add(new TargetWorm(w));
                        }
                        break;
                    case 6:
                        if (!triedWalkingWeapon && walkingWeaponUsable(this, w)) {
                            possibleTargets.add(new TargetWorm(w));
                        }
                        break;
                    case 7:
                        if (walkingWeaponUsable(this, w) && Math.abs(w.getX() - getX()) > 50) {
                            possibleTargets.add(new TargetWorm(w));
                        }
                        break;
                    case 8:
                        if (!triedWalkingWeapon && walkingWeaponUsable(this, w)) {
                            possibleTargets.add(new TargetWorm(w));
                        }
                        break;
                    case 9:
                        if (targetHit(new Holly_Grenade(), w, shootingCalculations[0], shootingCalculations[1])) {
                            possibleTargets.add(new TargetWorm(w));
                        }
                        break;
                    case 10:
                        if (targetHit(new Bananabomb(), w, shootingCalculations[0], shootingCalculations[1])) {
                            possibleTargets.add(new TargetWorm(w));
                        }
                        break;
                }
            }
        }
        for (TargetWorm targetWorm : possibleTargets) {
            List<Oil_Drum> oilDrumsInRange = targetWorm.getTarget().getObjectsInRange(Oil_Drum.EXPLOSIONS_RADIUS, Oil_Drum.class);
            List<Worm> worms;
            List<Worm> enemyWormsInRange;
            List<Worm> mateWormsInRange;
            worms = targetWorm.getTarget().getObjectsInRange(250, Worm.class);
            for (int i = 0; i < worms.size(); i++) {
                if (worms.get(i).getParty() == this.getParty()) {
                    worms.remove(i);
                    i--;
                }
            }
            enemyWormsInRange = worms;
            worms = targetWorm.getTarget().getObjectsInRange(250, Worm.class);
            for (int i = 0; i < worms.size(); i++) {
                if (worms.get(i).getParty() != this.getParty()) {
                    worms.remove(i);
                    i--;
                }
            }
            mateWormsInRange = worms;
            targetWorm.setTargetEffectiveness(Math.pow((targetWorm.getTarget().getLife() - 30), 2) + 20);
            for (Worm worm : enemyWormsInRange) {
                targetWorm.setTargetEffectiveness(-0.12 * getObjectsDistance(targetWorm.getTarget(), worm) + 30);
                targetWorm.setTargetEffectiveness((-0.005 * getObjectsDistance(targetWorm.getTarget(), worm) +1.25) * (Math.pow((worm.getLife() - 30), 2) + 20));
            }
            for (Worm worm : mateWormsInRange) {
                targetWorm.setTargetEffectiveness(2.6 * getObjectsDistance(targetWorm.getTarget(), worm) - 65);
            }
            for (Oil_Drum oilDrum : oilDrumsInRange) {
                targetWorm.setTargetEffectiveness(-0.257 * getObjectsDistance(targetWorm.getTarget(), oilDrum) + 45);
            }
        }
        for (TargetWorm targetWorm : possibleTargets) {
            if (mostEffectiveTarget == null ? true : targetWorm.getTargetEffectiveness() > mostEffectiveTarget.getTargetEffectiveness()) {
                mostEffectiveTarget = targetWorm;
            }
        }
        if (mostEffectiveTarget != null && mostEffectiveTarget.getTargetEffectiveness() > 0) {
            return mostEffectiveTarget.getTarget();
        }
        return null;
    }
    
    /**
     * Returns a randomly chosen worm from a list of enemys.
     * 
     * @param enemyWorms
     *      A list of the possible enemy worms.
     * 
     * @return
     *      One randomly chosen enemy worm from the list.
     */
    private Worm getRandomEnemy(java.util.List<Worm> enemyWorms) {
        if (enemyWorms.isEmpty()) {
            return null;
        }
        return enemyWorms.get(Greenfoot.getRandomNumber(enemyWorms.size()));
    }
    
    //return true if the worm is flying because of a weapons explosion;
    public boolean getFlying() {
        return flying;
    }
    public void setFlying(boolean flying, double xSpeed, double ySpeed) {
        this.flying = flying;
        velX += xSpeed;
        velY += ySpeed;
    }
    
    //return true if the worm is falling down;
    public boolean getFalling() {
        return falling;
    }
    public void setFalling(boolean falling) {
        this.falling = falling;
    }
    
    public boolean getImageLeft() {
        return imageLeft;
    }
    public void setImageLeft(boolean imageLeft) {
        this.imageLeft = imageLeft;
    }
    
    //control the shoots of this worm;
    public boolean getShoot() {
        return shoot;
    }
    public void setShoot(boolean shoot) {
        this.shoot = shoot;
        target = null;
    }
    
    //control the life of this worm;
    public int getLife() {
        return life;
    }
    public void setLife(int number) {
        life += number;
        tacticalDisplay.setTextChanged(true);
    }
    
    //control the target of the missile;
    public boolean getMissileTarget() {
        return missileTarget;
    }
    public void setMissileTarget(boolean target) {
        missileTarget = target;
    }
    
    public int getMissileX() {
        return missileX;
    }
    public void setMissileX(int x) {
        missileX = x;
    }
    
    public int getMissileY() {
        return missileY;
    }
    public void setMissileY(int y) {
        missileY = y;
    }
    
    //control the weapon the worm is currently using;
    public int getWeaponUsing() {
        return weaponUsing;
    }
    public void setWeaponUsing(int number) {
        weaponUsing = number;
        tacticalDisplay.setTextChanged(true);
    }
    
    //control the current countdown time for weapons with countdown;
    public int getCountdownTime() {
        return countdownTime;
    }
    public void setCountdownTime(int time) {
        countdownTime = time;
        tacticalDisplay.setTextChanged(true);
    }
    
    //get the worms party;
    public int getParty() {
        return party;
    }
    public void setParty(int party) {
        this.party = party;
        tacticalDisplay.setTextChanged(true);
    }
    
    //get the executing number of this worm;
    public int getNumber() {
        return number;
    }
    public void setNumber(int number) {
        this.number = number;
        tacticalDisplay.setTextChanged(true);
    }
    
    //return true if the worm is executing at the moment;
    public boolean getExecuting() {
        return executing;
    }
    public void setExecuting(boolean executing) {
        this.executing = executing;
        shoot = !executing;
        target = null;
        lastJump = 0;
        tacticalDisplay.setTextChanged(true);
        if (executing) {
            jumpsAI = 0;
            weaponChanges = 0;
            triedWalkingWeapon = false;
            addWeapons();
            checkForWeaponsExisting();
            resetWeaponTried();
            clock.resetClock();
            clock.startClock();
        }
        else {
            clock.stopClock();
        }
        wait(25, 50);
    }
    
    public boolean getHitByBaseballBat() {
        return hitByBaseballBat;
    }
    public void setHitByBaseballBat(boolean hit) {
        hitByBaseballBat = hit;
    }
    
    public boolean getArtificialIntelligence() {
        return artificialIntelligence;
    }
    public void setArtificialIntelligence(boolean artificialIntelligence) {
        this.artificialIntelligence = artificialIntelligence;
    }
    
    public void setTeamname(String teamname) {
        this.teamname = teamname;
    }
    public String getTeamname() {
        return teamname;
    }    
    
    public void setName(String name) {
        this.name = name;
    }
    public String getName() {
        return name;
    }
    
    public void setRunningCounter(int runningCounter) {
        this.runningCounter = runningCounter;
    }
    public int getRunningCounter() {
        return runningCounter;
    }
    
    //get the objects in the class worm
    public AimDisplay getAimDisplay() {
        return aimDisplay;
    }
    public TacticalDisplay getTacticalDisplay() {
        return tacticalDisplay;
    }
    public Shotgun getShotgun() {
        return shotgun;
    }
    public Baseball_Bat getBaseballBat() {
        return baseballBat;
    }
    public Clock getClock() {
        return clock;
    }
    public Worm getTarget() {
        return target;
    }
}
