import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import greenfoot.core.WorldHandler;
import java.awt.Color;
import java.util.List;
import java.awt.Cursor;
import java.awt.Point;
import java.awt.Toolkit;
import javax.swing.*;

/**
 * Write a description of class Worms_Land here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Worms_Land extends FullScreenWorld
{
    public static final double MAX_FORCE = 10.5;
    public static final double MIN_FORCE = 1.5;
    public static final double GRAVITY = 0.1;
    
    public static final int LOWEST_ANGLE = 0;
    
    public static double WIND = 0;
    
    private int lastExecutingParty = 1;
    private int nextGameCounter = 0;
    private int executingCounter = 0;
    private int killsInThisRound = 0;
    private int suddenDeathHeight = 0;
    private int pausingCounter = 0;
    
    private int[] wormPartysExecutingNumber = new int[4];
    private int[] gameValues;//map, textur, numberOfWorms, numberOfPlayers, numberOfWormparties, numberOfWeaponPackage;
    
    private boolean weaponThrown = false;
    private boolean worldInitialised = false;
    private boolean nextGame = false;
    private boolean executeGame = true;
    private boolean winnerMessagePrinted = false;
    private boolean roundOver = false;
    private boolean suddenDeath = false;
    
    private String[][] wormNames = new String[4][5];
    
    private Worm worm_1_1 = new Worm(1, 1, false);
    private Worm worm_1_2 = new Worm(1, 2, false);
    private Worm worm_1_3 = new Worm(1, 3, false);
    private Worm worm_1_4 = new Worm(1, 4, false);
    
    private Worm worm_2_1 = new Worm(2, 1, (Settings.players > 1 ? false : true));
    private Worm worm_2_2 = new Worm(2, 2, (Settings.players > 1 ? false : true));
    private Worm worm_2_3 = new Worm(2, 3, (Settings.players > 1 ? false : true));
    private Worm worm_2_4 = new Worm(2, 4, (Settings.players > 1 ? false : true));
    
    private Worm worm_3_1 = new Worm(3, 1, (Settings.players > 2 ? false : true));
    private Worm worm_3_2 = new Worm(3, 2, (Settings.players > 2 ? false : true));
    private Worm worm_3_3 = new Worm(3, 3, (Settings.players > 2 ? false : true));
    private Worm worm_3_4 = new Worm(3, 4, (Settings.players > 2 ? false : true));
    
    private Worm worm_4_1 = new Worm(4, 1, (Settings.players > 3 ? false : true));
    private Worm worm_4_2 = new Worm(4, 2, (Settings.players > 3 ? false : true));
    private Worm worm_4_3 = new Worm(4, 3, (Settings.players > 3 ? false : true));
    private Worm worm_4_4 = new Worm(4, 4, (Settings.players > 3 ? false : true));
    
    private Worm lastExecutingWorm1 = null;
    private Worm lastExecutingWorm2 = null;
    private Worm lastExecutingWorm3 = null;
    private Worm lastExecutingWorm4 = null;
    
    private Worm shootingWorm;
    private Worm enemyWorm;
    
    private GreenfootImage cursorImage_Menu = new GreenfootImage("Cursor_Menu.png");
    
    private Weapon_Package weaponPackage;
    
    private Texturs textur = null;
    
    private WindDisplay windDisplay = new WindDisplay();
    
    private Claims claim = new Claims();
    
    private Clock clock = new Clock();
    
    private Team_Healthbar teamHealthbar = new Team_Healthbar();
    
    public static Material Earth = new Earth();
    public static Material Air = new Air();
    public static Material Water = new Water();
    
    /**
     * Standard constructor of class Worms_Land.
     * Creates new World with 1200 x 700 pixels.
     * 
     */
    public Worms_Land() {
        super(1200, 700, 1, false, true);
        GreenfootImage unkleSam = new GreenfootImage("Unkle Sam.jpg");
        unkleSam.scale(359, 450);
        getBackground().drawImage(unkleSam, (int) ((getWidth()/2)-(unkleSam.getWidth()/2)), 100);
        Greenfoot.setSpeed(50);
        setPaintOrder(Change_Menu.class, Break_Menu.class, Weapon_Menu.class, Object.class, Map_Settings_Menu.class, Profile_Menu.class, Key_Menu.class, Dropdown_List.class, SlideBar.class,
        Dialog_Menu.class, Settings_Menu.class, Main_Menu.class, Claims.class, Team_Healthbar.class, Weapon.class, AimDisplay.class, TacticalDisplay.class, Other_Weapons.class, Worm.class, 
        Grave_Stone.class, WindDisplay.class, Clock.class, Texturs.class);
        //Settings.loadSettings();
        textur = new Texturs(Greenfoot.getRandomNumber(6)+1);
    }
    
    /**
     * Initialises game by adding main menu.
     */
    public void started() {
        if (worldDisplayThread != null && worldDisplayThread.isInterrupted()) {
            worldDisplayThread.start();
        }
        if (!worldInitialised) {
            addObject(new Main_Menu(), 600, 350);
            worldInitialised = true;
        }
    }
    
    /**
     * Manages the main game relevant values.
     */
    public void run() {
        setCursor();
        if (executeGame) {
            if (pausingCounter >= 10 && !nextGame && getObjects(Main_Menu.class).isEmpty() && getObjects(Break_Menu.class).isEmpty()) {
                if (FullScreenWindow.isKeyDown(Settings.wormPause)) {
                    addObject(new Break_Menu(), 600, 350);
                    stopClock();
                    try {
                        getExecutingWorm().getClock().stopClock();
                    }
                    catch (NullPointerException npe) {
                        //npe.printStackTrace();
                    }
                    pausingCounter = 0;
                }
            }
            else {
                pausingCounter++;
            }
            if (weaponThrown && getObjects(Weapon.class).isEmpty() && claim.chaimEmpty() && nothingMoving()) {
                if (killsInThisRound >= 2) {
                    setClaim(2, getExecutingWorm());
                    killsInThisRound = 0;
                    return;
                }
                weaponThrown = false;
                shootingWorm = null;
                enemyWorm = null;
                removeObjects(getObjects(Weapon_Menu.class));
                nextRound();//resetExecutingCounter;
                changeWind();
                if (suddenDeath) {
                    redrawWater();
                }
                if (executingCounter >= 5 && noExecutingWorm() && !getObjects(Worm.class).isEmpty()) {
                    nextRound();
                }
                else if (executingCounter < 5) {
                    executingCounter++;
                }
            }
        }
        if (nextGame) {
            if (nextGameCounter > 300) {
                stopClock();
                setExecutingWorm(0, 0);//no one executing;
                executeGame = false;
                addObject(new Change_Menu(), 600, 350);
                nextGameCounter = 0;
                nextGame = false;
            }
            else {
                nextGameCounter++;
            }
        }
        if (roundOver) {
            if (getObjects(Main_Menu.class).isEmpty() && getObjects(Map_Settings_Menu.class).isEmpty() && getObjects(Change_Menu.class).isEmpty()) {
                if (getObjects(Worm.class).size() == 1) {
                    //winnermessage;
                    //findSurvivingWorm();//return Worm;
                    if (!winnerMessagePrinted) {
                        setClaim(9, (Worm) getObjects(Worm.class).get(0));
                        winnerMessagePrinted = true;
                    }
                    nextGame = true;
                }
                else if (getObjects(Worm.class).isEmpty()) {
                    //everyone died;
                    if (!winnerMessagePrinted) {
                        setClaim(10, null);
                        winnerMessagePrinted = true;
                    }
                    nextGame = true;
                }
                else if (onePartyLeft()) {
                    //party winns;
                    if (!winnerMessagePrinted) {
                        setClaim(9, (Worm) getObjects(Worm.class).get(0));
                        winnerMessagePrinted = true;
                    }
                    nextGame = true;
                }
            }
            roundOver = false;
        }
    }
    
    /**
     * Starts the game and initialises a new background.
     */
    public void startGame() {
        removeAllObjects();
        suddenDeathHeight = 0;
        drawNewWorld();
        addTextur();
        addClaims();
        addClock();
        addTeamHealthbar();
        setTeamHealthbarCounter(250);
        resetClock();
        resetWorms();
        setWormNames();
        addWorms(Settings.playerNumber*Settings.partys);
        addOilDrums(3);
        addMines(Greenfoot.getRandomNumber(Settings.maximumMines)+1);
        addObject(windDisplay, 90, 53);
        changeWind();
        setWeaponPackage(Settings.getWeaponPackageByNumber(gameValues[5]+1));
        //loadMusic();
        //setMusicVolume();
        //startMusic(Greenfoot.getRandomNumber(5)+1);
        switch (Greenfoot.getRandomNumber(Settings.partys)) {
            case 0:
                setExecutingWorm(1, 1);
                lastExecutingParty = 1;
                break;
            case 1:
                setExecutingWorm(2, 1);
                lastExecutingParty = 2;
                break;
            case 2:
                setExecutingWorm(3, 1);
                lastExecutingParty = 3;
                break;
            case 3:
                setExecutingWorm(4, 1);
                lastExecutingParty = 4;
                break;
        }
        setClaim(1, getExecutingWorm());
        executeGame = true;
        winnerMessagePrinted = false;
        suddenDeath = false;
        killsInThisRound = 0;
    }
    
    /**
     * Set the number of the round and set the executing worm.
     */
    private void nextRound() {
        int executingParty = lastExecutingParty + 1;
        int executingWorm = 0;
        executingCounter = 0;
        roundOver = true;
        if (executingParty > Settings.partys) {
            executingParty = 1;
        }
        for (int i = 0; i < 4 && !partyExisting(executingParty); i++) {
            executingParty++;
            if (executingParty > Settings.partys) {
                executingParty = 1;
            }
        }
        switch (executingParty) {
            case 1:
                executingWorm = (lastExecutingWorm1 == null ? 1 : lastExecutingWorm1.getNumber()+1);
                for (int i = 0; i < 4 && !wormExistingInWorld(getWormByNumber(1, executingWorm)); i++) {
                    executingWorm++;
                    if (executingWorm > Settings.playerNumber) {
                        executingWorm = 1;
                    }
                }
                lastExecutingWorm1 = getWormByNumber(1, executingWorm);
                setWeaponPackageDelay(executingParty);
                break;
            case 2:
                executingWorm = (lastExecutingWorm2 == null ? 1 : lastExecutingWorm2.getNumber()+1);
                for (int i = 0; i < 4 && !wormExistingInWorld(getWormByNumber(2, executingWorm)); i++) {
                    executingWorm++;
                    if (executingWorm > Settings.playerNumber) {
                        executingWorm = 1;
                    }
                }
                lastExecutingWorm2 = getWormByNumber(2, executingWorm);
                setWeaponPackageDelay(executingParty);
                break;
            case 3:
                executingWorm = (lastExecutingWorm3 == null ? 1 : lastExecutingWorm3.getNumber()+1);
                for (int i = 0; i < 4 && !wormExistingInWorld(getWormByNumber(3, executingWorm)); i++) {
                    executingWorm++;
                    if (executingWorm > Settings.playerNumber) {
                        executingWorm = 1;
                    }
                }
                lastExecutingWorm3 = getWormByNumber(3, executingWorm);
                setWeaponPackageDelay(executingParty);
                break;
            case 4:
                executingWorm = (lastExecutingWorm4 == null ? 1 : lastExecutingWorm4.getNumber()+1);
                for (int i = 0; i < 4 && !wormExistingInWorld(getWormByNumber(4, executingWorm)); i++) {
                    executingWorm++;
                    if (executingWorm > Settings.playerNumber) {
                        executingWorm = 1;
                    }
                }
                lastExecutingWorm4 = getWormByNumber(4, executingWorm);
                setWeaponPackageDelay(executingParty);
                break;
        }
        lastExecutingParty = executingParty;
        if (lastExecutingParty > Settings.partys) {
            lastExecutingParty = 1;
        }
        setExecutingWorm(executingParty, executingWorm);
        if (!onePartyLeft() && !getObjects(Worm.class).isEmpty()) {
            setClaim(1, getExecutingWorm());
        }
        if (suddenDeath) {
            suddenDeathHeight += 10 + Greenfoot.getRandomNumber(15);
        }
        setRoundDependingWeapons();
        setTeamHealthbarCounter(200);
        killsInThisRound = 0;
    }
    
    /**
     * Draws the new world onto the background (no textur).
     */
    private void drawNewWorld() {
        getBackground().clear();
        switch (gameValues[0] == 0 ? Greenfoot.getRandomNumber(16)+1 : gameValues[0]) {
            case 1:
                getBackground().drawImage(new GreenfootImage("Worms_World_1.jpg"), 0, 0);
                break;
            case 2:
                getBackground().drawImage(new GreenfootImage("Worms_World_2.jpg"), 0, 0);
                break;
            case 3:
                getBackground().drawImage(new GreenfootImage("Worms_World_3.jpg"), 0, 0);
                break;
            case 4:
                getBackground().drawImage(new GreenfootImage("Worms_World_4.jpg"), 0, 0);
                break;
            case 5:
                getBackground().drawImage(new GreenfootImage("Worms_World_5.jpg"), 0, 0);
                break;
            case 6:
                getBackground().drawImage(new GreenfootImage("Worms_World_6.jpg"), 0, 0);
                break;
            case 7:
                getBackground().drawImage(new GreenfootImage("Worms_World_7.jpg"), 0, 0);
                break;
            case 8:
                getBackground().drawImage(new GreenfootImage("Worms_World_8.jpg"), 0, 0);
                break;
            case 9:
                getBackground().drawImage(new GreenfootImage("Worms_World_9.jpg"), 0, 0);
                break;
            case 10:
                getBackground().drawImage(new GreenfootImage("Worms_World_10.jpg"), 0, 0);
                break;
            case 11:
                getBackground().drawImage(new GreenfootImage("Worms_World_11.jpg"), 0, 0);
                break;
            case 12:
                getBackground().drawImage(new GreenfootImage("Worms_World_12.jpg"), 0, 0);
                break;
            case 13:
                getBackground().drawImage(new GreenfootImage("Worms_World_13.jpg"), 0, 0);
                break;
            case 14:
                getBackground().drawImage(new GreenfootImage("Worms_World_14.jpg"), 0, 0);
                break;
            case 15:
                getBackground().drawImage(new GreenfootImage("Worms_World_15.jpg"), 0, 0);
                break;
            case 16:
                getBackground().drawImage(new GreenfootImage("Worms_World_16.jpg"), 0, 0);
                break;
        }
        redrawWater();
    }
    
    /**
     * Adds and initialises the textur.
     */
    private void addTextur() {
        textur = new Texturs(gameValues[1] == 0 ? Greenfoot.getRandomNumber(6)+1 : gameValues[1]);
        addObject(textur, 600, 350);
        textur.initialiseBasikImage();
        textur.redraw();
    }
    
    /**
     * Change the executing worm.
     * 
     * @param party
     *      The party of the next executing worm.
     *  
     * @param number
     *      The number of the next executing worm.
     */
    private void setExecutingWorm(int party, int number) {
        worm_1_1.setExecuting(false);
        worm_1_2.setExecuting(false);
        worm_1_3.setExecuting(false);
        worm_1_4.setExecuting(false);
        worm_2_1.setExecuting(false);
        worm_2_2.setExecuting(false);
        worm_2_3.setExecuting(false);
        worm_2_4.setExecuting(false);
        worm_3_1.setExecuting(false);
        worm_3_2.setExecuting(false);
        worm_3_3.setExecuting(false);
        worm_3_4.setExecuting(false);
        worm_4_1.setExecuting(false);
        worm_4_2.setExecuting(false);
        worm_4_3.setExecuting(false);
        worm_4_4.setExecuting(false);
        switch (party) {
            case 1:
                switch (number) {
                    case 1:
                        worm_1_1.setExecuting(true);
                        lastExecutingWorm1 = worm_1_1;
                        Players.setWorm(lastExecutingWorm1);
                        break;
                    case 2:
                        worm_1_2.setExecuting(true);
                        lastExecutingWorm1 = worm_1_2;
                        Players.setWorm(lastExecutingWorm1);
                        break;
                    case 3:
                        worm_1_3.setExecuting(true);
                        lastExecutingWorm1 = worm_1_3;
                        Players.setWorm(lastExecutingWorm1);
                        break;
                    case 4:
                        worm_1_4.setExecuting(true);
                        lastExecutingWorm1 = worm_1_4;
                        Players.setWorm(lastExecutingWorm1);
                        break;
                }
                break;
            case 2:
                switch (number) {
                    case 1:
                        worm_2_1.setExecuting(true);
                        lastExecutingWorm2 = worm_2_1;
                        Players.setWorm(lastExecutingWorm2);
                        break;
                    case 2:
                        worm_2_2.setExecuting(true);
                        lastExecutingWorm2 = worm_2_2;
                        Players.setWorm(lastExecutingWorm2);
                        break;
                    case 3:
                        worm_2_3.setExecuting(true);
                        lastExecutingWorm2 = worm_2_3;
                        Players.setWorm(lastExecutingWorm2);
                        break;
                    case 4:
                        worm_2_4.setExecuting(true);
                        lastExecutingWorm2 = worm_2_4;
                        Players.setWorm(lastExecutingWorm2);
                        break;
                }
                break;
            case 3:
                switch (number) {
                    case 1:
                        worm_3_1.setExecuting(true);
                        lastExecutingWorm3 = worm_3_1;
                        Players.setWorm(lastExecutingWorm3);
                        break;
                    case 2:
                        worm_3_2.setExecuting(true);
                        lastExecutingWorm3 = worm_3_2;
                        Players.setWorm(lastExecutingWorm3);
                        break;
                    case 3:
                        worm_3_3.setExecuting(true);
                        lastExecutingWorm3 = worm_3_3;
                        Players.setWorm(lastExecutingWorm3);
                        break;
                    case 4:
                        worm_3_4.setExecuting(true);
                        lastExecutingWorm3 = worm_3_4;
                        Players.setWorm(lastExecutingWorm3);
                        break;
                }
                break;
            case 4:
                switch (number) {
                    case 1:
                        worm_4_1.setExecuting(true);
                        lastExecutingWorm4 = worm_4_1;
                        Players.setWorm(lastExecutingWorm4);
                        break;
                    case 2:
                        worm_4_2.setExecuting(true);
                        lastExecutingWorm4 = worm_4_2;
                        Players.setWorm(lastExecutingWorm4);
                        break;
                    case 3:
                        worm_4_3.setExecuting(true);
                        lastExecutingWorm4 = worm_4_3;
                        Players.setWorm(lastExecutingWorm4);
                        break;
                    case 4:
                        worm_4_4.setExecuting(true);
                        lastExecutingWorm4 = worm_4_4;
                        Players.setWorm(lastExecutingWorm4);
                        break;
                }
                break;
        }
    }
    
    /**
     * Change the cursor image of the world panel.
     */
    public void setCursor() {
        JPanel panel = WorldHandler.getInstance().getWorldCanvas();
        Cursor cursor = Toolkit.getDefaultToolkit().createCustomCursor(cursorImage_Menu.getAwtImage(), new Point(3, 3), "Cursor");
        panel.setCursor(cursor);
    }
    
    /**
     * Reset all values of all worms.
     */
    private void resetWorms() {
        Worm[] worms = {worm_1_1, worm_2_1, worm_3_1, worm_4_1, worm_1_2, worm_2_2, worm_3_2, worm_4_2, worm_1_3, worm_2_3, worm_3_3, worm_4_3, worm_1_4, worm_2_4, worm_3_4, worm_4_4};
        for (Worm w : worms) {
            w.resetAll();
        }
    }
    
    /**
     * Assign the names (got by main menu) to the worms of all partys.
     */
    public void setWormNames() {
        if (wormNamesExisting()) {
             for (int i = 0; i < 4; i++) {
                 for (int j = 0; j < 4; j++) {
                    getWormByNumber(i+1, j+1).setTeamname(wormNames[i][0]);
                    getWormByNumber(i+1, j+1).setName(wormNames[i][j+1]);
                }
            }
        }
    }
    
    /**
     * Set the delay time of the used weapon package from the given party.
     * 
     * @param executingParty
     *      The party which delay time should be decremented.
     */
    private void setWeaponPackageDelay(int executingParty) {
        if (wormPartysExecutingNumber[executingParty-1] != 0) {
            getWeaponPackage().decrementWeaponDelay(executingParty);
        }
        wormPartysExecutingNumber[executingParty-1]++;
    }
    
    /**
     * Set the arctifical intelligence of the partys (values saved in settings).
     */
    private void setArtificialIntelligence() {
        for (int i = 0; i < 4; i++) {
            for (int j = 0; j < 4; j++) {
                switch (i) {
                    case 0:
                        getWormByNumber(i+1, j+1).setArtificialIntelligence(!Settings.partyOneHumanPlayer);
                        break;
                    case 1:
                        getWormByNumber(i+1, j+1).setArtificialIntelligence(!Settings.partyTwoHumanPlayer);
                        break;
                    case 2:
                        getWormByNumber(i+1, j+1).setArtificialIntelligence(!Settings.partyThreeHumanPlayer);
                        break;
                    case 3:
                        getWormByNumber(i+1, j+1).setArtificialIntelligence(!Settings.partyFourHumanPlayer);
                        break;
                }
            }
        }
    }
    
    /**
     * Add the playing worms to the world.
     * 
     * @param numberOfWorms
     *      The number of playing worms in this game (calculated by: number of players * number of partys).
     */
    private void addWorms(int numberOfWorms) {
        int x;
        int y;
        boolean positionFound = false;
        Worm[] worms;
        switch (Settings.partys) {
            case 2:
                worms = new Worm[8];
                worms[0] = worm_1_1;
                worms[1] = worm_2_1;
                worms[2] = worm_1_2;
                worms[3] = worm_2_2;
                worms[4] = worm_1_3;
                worms[5] = worm_2_3;
                worms[6] = worm_1_4;
                worms[7] = worm_2_4;
                break;
            case 3:
                worms = new Worm[12];
                worms[0] = worm_1_1;
                worms[1] = worm_2_1;
                worms[2] = worm_3_1;
                worms[3] = worm_1_2;
                worms[4] = worm_2_2;
                worms[5] = worm_3_2;
                worms[6] = worm_1_3;
                worms[7] = worm_2_3;
                worms[8] = worm_3_3;
                worms[9] = worm_1_4;
                worms[10] = worm_2_4;
                worms[11] = worm_3_4;
                break;
            case 4:
                worms = new Worm[16];
                worms[0] = worm_1_1;
                worms[1] = worm_2_1;
                worms[2] = worm_3_1;
                worms[3] = worm_4_1;
                worms[4] = worm_1_2;
                worms[5] = worm_2_2;
                worms[6] = worm_3_2;
                worms[7] = worm_4_2;
                worms[8] = worm_1_3;
                worms[9] = worm_2_3;
                worms[10] = worm_3_3;
                worms[11] = worm_4_3;
                worms[12] = worm_1_4;
                worms[13] = worm_2_4;
                worms[14] = worm_3_4;
                worms[15] = worm_4_4;
                break;
            default:
                worms = new Worm[0];
                break;
        }
        for (int i = 0; i < numberOfWorms; i++) {
            positionFound = false;
            x = Greenfoot.getRandomNumber(900)+150;
            /*for (int j = 0; j < i; j++) {
                if (Math.abs(x-worms[j].getX()) < 50) {
                    x = Greenfoot.getRandomNumber(900)+150;
                }
            }*/
            for (y = 100; y < 700; y += 50) {
                if (getMaterialAt(x, y).getMaterial() == 1 && getMaterialAt(x, y-45).getMaterial() == 2) {
                    positionFound = true;
                    break;
                }
            }
            if (!positionFound) {
                i--;
                continue;
            }
            for (int j = 0; j < 50; j++) {
                if (getMaterialAt(x, y-j).getMaterial() != 1) {
                    y -= (j+50);
                    break;
                }
            }
            addObject(worms[i], x, y);
            if (!worms[i].moveOutOfEarth()) {
                positionFound = false;
                removeObject(worms[i]);
                i--;
            }
        }
    }
    
    /**
     * Add some oil drums to the world.
     * 
     * @param numberOfDrums
     *      The number of oil drums that should be added to the world.
     *      Value saved in settings.
     */
    private void addOilDrums(int numberOfDrums) {
        int x;
        int y;
        boolean positionFound = false;
        for (int i = 0; i < numberOfDrums; i++) {
            positionFound = false;
            x = Greenfoot.getRandomNumber(900)+150;
            for (y = 100; y < 700; y += 50) {
                if (getMaterialAt(x, y).getMaterial() == 1 && getMaterialAt(x, y-45).getMaterial() == 2) {
                    positionFound = true;
                    break;
                }
            }
            if (!positionFound) {
                i--;
                continue;
            }
            for (int j = 0; j < 50; j++) {
                if (getMaterialAt(x, y-j).getMaterial() != 1) {
                    y -= (j+25);
                    break;
                }
            }
            addObject(new Oil_Drum(), x, y);
        }
    }
    
    /**
     * Add some mines to the world
     * 
     * @param numberOfMines
     *      The number of mines that should be added to the world.
     *      Value saved in settings.
     */
    private void addMines(int numberOfMines) {
        int x;
        int y;
        boolean positionFound = false;
        for (int i = 0, j = 0; i < numberOfMines && j < 50; i++, j++) {
            positionFound = false;
            x = Greenfoot.getRandomNumber(900)+150;
            for (y = 100; y < 700; y += 50) {
                if (getMaterialAt(x, y).getMaterial() == 1 && getMaterialAt(x, y-45).getMaterial() == 2 && distanceToNearestWorm(x) > 125 && distanceToNearestMine(x) > 50) {
                    positionFound = true;
                    break;
                }
            }
            if (!positionFound) {
                i--;
                continue;
            }
            for (int k = 0; k < 50; k++) {
                if (getMaterialAt(x, y-k).getMaterial() != 1) {
                    y -= (k+25);
                    break;
                }
            }
            addObject(new Mine(), x, y);
        }
    }
    
    /**
     * Adds a claim object to the world.
     */
    private void addClaims() {
        addObject(claim, 600, 40);
    }
    
    /**
     * Adds a clock object to the world.
     */
    private void addClock() {
        addObject(clock, 1122, 45);
        startClock();
    }
    
    /**
     * Adds a teamhealthbar object to the world.
     */
    private void addTeamHealthbar() {
        addObject(teamHealthbar, 600, 775);
        teamHealthbar.resetPossibleHealth();
    }
    
    /**
     * Destroys the textur to make it look like the real background.
     * Deletes a circile of the textur with the given coordinates and radius.
     * 
     * @param x
     *      The X coordinate of the point in the middle of the circile.
     * 
     * @param y
     *      The Y coordinate of the point in the middle of the circile.
     * 
     * @param radius
     *      The radius of the circile which is deleted from the textur.
     */
    public void changeTextur(int x, int y, int radius) {
        textur.destroyTextur(x, y, radius);
        textur.redraw();
    }
    
    /**
     * Changes the wind influence and the wind display.
     */
    private void changeWind() {
        WIND = (Math.random()*0.1)-0.05;
        windDisplay.redrawImage();
    }
    
    /**
     * Redrawes the backgroundwater so that it can't be destroyed and changes the height of the water in the sudden death mode.
     */
    public void redrawWater() {
        getBackground().setColor(Color.blue);
        getBackground().fillRect(-1500, 645 - suddenDeathHeight, 4200, 80 + suddenDeathHeight);
    }
    
    /**
     * Counts up the number of rounds in all rounddepending weapons that are currently existing in the world.
     */
    private void setRoundDependingWeapons() {
        List<Magnet> magnets = getObjects(Magnet.class);
        for (Magnet magnet : magnets) {
            magnet.setRound(1);
        }
    }
    
    public void calculateAdaptiveAlgorithm(Weapon weapon) {
        if (shootingWorm != null && shootingWorm.getArtificialIntelligence() && enemyWorm != null && weapon != null) {
            int[] nearestPoint = new int[2];
            if (weapon instanceof Bazooka) {
                nearestPoint = ((Bazooka) weapon).getNearestCoordinates();
            }
            else if (weapon instanceof Grenade) {
                nearestPoint = ((Grenade) weapon).getNearestCoordinates();
            }
            else if (weapon instanceof Clustergrenade) {
                nearestPoint = ((Clustergrenade) weapon).getNearestCoordinates();
            }
            else if (weapon instanceof Holly_Grenade) {
                nearestPoint = ((Holly_Grenade) weapon).getNearestCoordinates();
            }
            else if (weapon instanceof Bananabomb) {
                nearestPoint = ((Bananabomb) weapon).getNearestCoordinates();
            }
            if (nearestPoint[0] == 0 && nearestPoint[1] == 0) {
                shootingWorm.improveShootingAlgorithm(shootingWorm, enemyWorm, weapon, new Point(weapon.getX(), weapon.getY()));
            }
            else {
                shootingWorm.improveShootingAlgorithm(shootingWorm, enemyWorm, weapon, new Point(nearestPoint[0], nearestPoint[1]));
            }
        }
        shootingWorm = null;
        enemyWorm = null;
    }
    
    public void receiveAdaptiveAlgorithmValues(Worm shootingWorm, Worm enemyWorm) {
        this.shootingWorm = shootingWorm;
        this.enemyWorm = enemyWorm;
    }
    
    /**
     * Checks whether the party given as parameter is still alive.
     * 
     * @param party
     *      The number of the party that is checked.
     * 
     * @return
     *      Returns <i>true</i> if one or more worms of the party are still existing in the world.
     */
    private boolean partyExisting(int party) {
        switch (party) {
            case 1:
                Worm[] WormParty1 = {worm_1_1, worm_1_2, worm_1_3, worm_1_4};
                for (Worm w : WormParty1) {
                    if (wormExistingInWorld(w)) {
                        return true;
                    }
                }
                break;
            case 2:
                Worm[] WormParty2 = {worm_2_1, worm_2_2, worm_2_3, worm_2_4};
                for (Worm w : WormParty2) {
                    if (wormExistingInWorld(w)) {
                        return true;
                    }
                }
                break;
            case 3:
                Worm[] WormParty3 = {worm_3_1, worm_3_2, worm_3_3, worm_3_4};
                for (Worm w : WormParty3) {
                    if (wormExistingInWorld(w)) {
                        return true;
                    }
                }
                break;
            case 4:
                Worm[] WormParty4 = {worm_4_1, worm_4_2, worm_4_3, worm_4_4};
                for (Worm w : WormParty4) {
                    if (wormExistingInWorld(w)) {
                        return true;
                    }
                }
                break;
        }
        return false;
    }
    
    /**
     * Check whether there is a worms executing at the moment.
     * 
     * @return
     *      Returns <i>true</i> if there is any worm which is executing and existing in the world.
     */
    private boolean noExecutingWorm() {
        List<Worm> worms = getObjects(Worm.class);
        for (Worm w : worms) {
            if (w.getExecuting()) {
                return true;
            }
        }
        return false;
    }
    
    /**
     * Check whether there are all names of the worms known.
     * 
     * @return
     *      Returns <i>true</i> if all names of the worms are known.
     */
    private boolean wormNamesExisting() {
        for (int i = 0; i < 4; i++) {
            for (int j = 0; j < 5; j++) {
                if (wormNames[i][j] == null) {
                    return false;
                }
            }
        }
        return true;
    }
    
    /**
     * Check whether the worm given as parameter is currently existing in the world.
     * 
     * @param worm
     *      The worm that is checked.
     * 
     * @return
     *      Returns <i>true</i> if the worm given as parameter is currently existing in the world.
     */
    public boolean wormExistingInWorld(Worm worm) {
        List<Worm> wormsInWorld = getObjects(Worm.class);
        for (Worm w : wormsInWorld) {
            if (w.equals(worm) && w.getLife() > 0) {
                return true;
            }
        }
        return false;
    }
    
    /**
     * Check whether there is just one party left in the world.
     * 
     * @return
     *      Returns <i>true</i> if there is only one party left in the world.
     */
    private boolean onePartyLeft() {
        List<Worm> survivingWorms = getObjects(Worm.class);
        int survivingParty = 0;
        if (!survivingWorms.isEmpty()) {
            survivingParty = survivingWorms.get(0).getParty();
            for (Worm w : survivingWorms) {
                if (w.getParty() != survivingParty) {
                    return false;
                }
            }
        }
        return true;
    }
    
    /**
     * Check whether there is nothing moving, flying or going to explode so that the round is over.
     * 
     * @return
     *      Returns <i>true</i> if nothing is moving or going to explode.
     */
    private boolean nothingMoving() {
        List<Mine> mines = getObjects(Mine.class);
        List<Worm> worms = getObjects(Worm.class);
        for (Mine mine : mines) {
            if (mine.getFlying() || mine.getFalling() || mine.getCounting()) {
                return false;
            }
        }
        for (Worm worm : worms) {
            if (worm.getFlying() || worm.getFalling() || worm.getLife() <= 0) {
                return false;
            }
        }
        return true;
    }
    
    /**
     * Calculates the minimum distance of the <b>X coordinates</b> between the given X coordinate and the nearest worm.
     * 
     * @param xCoordinate
     *      The X coordinate of from which the minimum distance is calculated.
     * 
     * @return
     *      Returns the X distance between the given X coordinate and the nearest worms X coordinate as a double value.
     *      Maximumly returns 10000 if there is no worm nearer than this value.
     */
    private double distanceToNearestWorm(int xCoordinate) {
        double minDistance = 10000;
        List<Worm> worms = getObjects(Worm.class);
        for (Worm worm : worms) {
            if (minDistance > Math.abs(worm.getX() - xCoordinate)) {
                minDistance = Math.abs(worm.getX() - xCoordinate);
            }
        }
        return minDistance;
    }
    /**
     * Calculates the minimum distance of the <b>X coordinates</b> between the given X coordinate and the nearest mine.
     * 
     * @param xCoordinate
     *      The X coordinate of from which the minimum distance is calculated.
     * 
     * @return
     *      Returns the X distance between the given X coordinate and the nearest mines X coordinate as a double value.
     *      Maximumly returns 10000 if there is no mine nearer than this value.
     */
    private double distanceToNearestMine(int xCoordinate) {
        double minDistance = 10000;
        List<Mine> mines = getObjects(Mine.class);
        for (Mine mine : mines) {
            if (minDistance > Math.abs(mine.getX() - xCoordinate)) {
                minDistance = Math.abs(mine.getX() - xCoordinate);
            }
        }
        return minDistance;
    }
    
    /**
     * The number of the executing worms party.
     * 
     * @return
     *      Returns the number of the executing party.
     *      Returns 0 if there is no worm executing.
     */
    public int getExecutingParty() {
        List<Worm> wormsInWorld = getObjects(Worm.class);
        for (Worm worm : wormsInWorld) {
            if (worm.getExecuting()) {
                return worm.getParty();
            }
        }
        return 0;
    }
    /**
     * The reference to the currently executing worm.
     * 
     * @return
     *      Returns the reference to the executing worm.
     *      Returns null if there is on worm executing.
     */
    public Worm getExecutingWorm() {
        List<Worm> wormsInWorld = getObjects(Worm.class);
        for (Worm w : wormsInWorld) {
            if (w.getExecuting()) {
                return w;
            }
        }
        return null;
    }
    
    /**
     * Get a worm by his party- and executing-number
     * 
     * @param party
     *      The number of the party of the searched worm (possible values: 1 - 4).
     * 
     * @param number
     *      The executing-number of the searched worm (possible values: 1 - 4).
     * 
     * @return
     *      Returns the worm with the given party- and executing-number.
     *      Returns null if there is no worm declared with the ordered party- and executing-number.
     */
    public Worm getWormByNumber(int party, int number) {
        switch (party) {
            case 1:
                switch (number) {
                    case 1:
                        return worm_1_1;
                    case 2:
                        return worm_1_2;
                    case 3:
                        return worm_1_3;
                    case 4:
                        return worm_1_4;
                }
                break;
            case 2:
                switch (number) {
                    case 1:
                        return worm_2_1;
                    case 2:
                        return worm_2_2;
                    case 3:
                        return worm_2_3;
                    case 4:
                        return worm_2_4;
                }
                break;
            case 3:
                switch (number) {
                    case 1:
                        return worm_3_1;
                    case 2:
                        return worm_3_2;
                    case 3:
                        return worm_3_3;
                    case 4:
                        return worm_3_4;
                }
                break;
            case 4:
                switch (number) {
                    case 1:
                        return worm_4_1;
                    case 2:
                        return worm_4_2;
                    case 3:
                        return worm_4_3;
                    case 4:
                        return worm_4_4;
                }
                break;
        }
        return null;
    }
    
    /**
     * Get the last surviving worm.
     * 
     * @return
     *      Returns the reference to the last surviving worm.
     *      Returns null if there are no or more than one worms existing in the world.
     */
    private Worm findSurvivingWorm() {
        List<Worm> survivingWorms = getObjects(Worm.class);
        if (survivingWorms.size() == 1) {
            return survivingWorms.get(0);
        }
        return null;
    }
    
    /**
     * Get the currently target worm.
     * 
     * @retrun 
     *      Returns the reference to the currently target worm.
     */
    public Worm getEnemyWorm() {
        return enemyWorm;
    }
    
    /**
     * Get the members of the team that are still alive as a list.
     * 
     * @param number
     *      The number of the requested team.
     * 
     * @return
     *      Returns a list of the surviving worms of the requested party.
     *      Returns null if there is no worm of this team alive.
     */
    public java.util.List<Worm> getTeam(int number) {
        List<Worm> worms = getObjects(Worm.class);
        for (int i = 0; i < worms.size(); i++) {
            if (worms.get(i).getParty() != number) {
                worms.remove(i);
                i--;
            }
        }
        return worms;
    }
    
    /**
     * Get the material at the given position.
     * 
     * @param x
     *      The X coordinate of the point in the world.
     * 
     * @param y
     *      The Y coordinate of the point in the world.
     * 
     * @return
     *      Returns a static Earth object if the backgroundcolor at the given position is black.
     *      Returns a static Water object if the backgroundcolor at the given position is blue.
     *      Otherwhile returns a static Air object.
     */
    public Material getMaterialAt(int x, int y) {
        if(x < 0) {
            x = 0;
        }
        else if (x >= 1200) {
            x = 1199;
        }
        if(y < 0) {
            y = 0;
        }
        else if (y >= 700) {
            y = 699;
        }
        if(getColorAt(x, y).getBlue() >= getColorAt(x, y).getRed() + 50) {
            return Water;
        }
        if(getColorAt(x, y).getBlue() <= 25) {
            return Earth;
        }
        return Air;
    }
    
    /**
     * Receive the game values that are sent by the main menu.
     * 
     * @param valuse
     *      The game valuese for the next game as an array.
     *      1. The chosen map (0 = random).
     *      2. The chosen textur (0 = random).
     *      3. The number of worms per party.
     *      4. The number of the human players.
     *      5. The number of the different partys.
     *      6. The number of the used weapon-package.
     *      
     * 
     * @param names
     *      The names of all worms as an array.
     *      
     */
    public void receiveValues(int[] values, String[][] names) {
        gameValues = values;
        Settings.playerNumber = values[2];
        Settings.players = values[3];
        switch (values[3]) {
            case 1:
                Settings.partyOneHumanPlayer = true;
                Settings.partyTwoHumanPlayer = false;
                Settings.partyThreeHumanPlayer = false;
                Settings.partyFourHumanPlayer = false;
                break;
            case 2:
                Settings.partyOneHumanPlayer = true;
                Settings.partyTwoHumanPlayer = true;
                Settings.partyThreeHumanPlayer = false;
                Settings.partyFourHumanPlayer = false;
                break;
            case 3:
                Settings.partyOneHumanPlayer = true;
                Settings.partyTwoHumanPlayer = true;
                Settings.partyThreeHumanPlayer = true;
                Settings.partyFourHumanPlayer = false;
                break;
            case 4:
                Settings.partyOneHumanPlayer = true;
                Settings.partyTwoHumanPlayer = true;
                Settings.partyThreeHumanPlayer = true;
                Settings.partyFourHumanPlayer = true;
                break;
        }
        setArtificialIntelligence();
        Settings.partys = values[4];
        wormNames = new String[4][5];
        wormNames = names;
    }
    /**
     * The game values of this game.
     * 
     * @return
     *      Returns the game values of this game.
     */
    public int[] getGameValues() {
        return gameValues;
    }
    /**
     * The names of all worms.
     * 
     * @return
     *      Returns the names of all worms.
     */
    public String[][] getTeamNames() {
        return wormNames;
    }
    
    /**
     * Starts the clock.
     */
    public void startClock() {
        clock.startClock();
    }
    /**
     * Pauses the clock.
     */
    public void stopClock() {
        clock.stopClock();
    }
    /**
     * Resets the Clock.
     */
    public void resetClock() {
        clock.resetClock();
    }
    
    /**
     * Set the displaying counter of the team-healthbar.
     */
    public void setTeamHealthbarCounter(int counter) {
        teamHealthbar.setDisplayCounter(counter);
    }
    
    /**
     * Change the claim drawed in the top of the game window.
     * Chooses a random claim of the claimtype.
     * 
     * @param claimCase
     *      The case this claim is used for (like starting claims, killing claims, ...).
     * 
     * @param worm
     *      The calling worm.
     */
    public void setClaim(int claimCase, Worm worm) {
        if (worm != null) {
            claim.drawClaim(claimCase, worm);
        }
    }
    /**
     * Change the claim drawed in the top of the game window.
     * Chooses one specific claim.
     * 
     * @param claimCase
     *      The case this claim is used for (like starting claims, killing claims, ...).
     *      
     * @param claimNumber
     *      The number of the specific clime which is drawed.
     * 
     * @param worm
     *      The calling worm.
     */
    public void setClaim(int claimCase, int claimNumber, Worm worm) {
        claim.drawClaim(claimCase, claimNumber, worm);
    }
    
    /**
     * Getter method of the variable pausingCounter.
     * 
     * @return
     *      Returns the value of the variable pausingCounter.
     */
    public int getPausingCounter() {
        return pausingCounter;
    }
    /**
     * Setter method of the variable pausingCounter.
     * 
     * @param suddenDeath
     *      The new value of the variable pausingCounter.
     */
    public void setPausingCounter(int pausingCounter) {
        this.pausingCounter = pausingCounter;
    }
    /**
     * Resets the variable pausingCounter.
     */
    public void resetPausingCounter() {
        pausingCounter = 0;
    }
    
    /**
     * Getter method of the variable weaponThrown.
     * 
     * @return
     *      Returns the value of the variable weaponThrown.
     */
    public boolean getWeaponThrown() {
        return weaponThrown;
    }
    /**
     * Setter method of the variable weaponThrown.
     * 
     * @param thrown
     *      The new value of the variable weaponThrown.
     */
    public void setWeaponThrown(boolean thrown) {
        weaponThrown = thrown;
    }
    
    /**
     * Getter method of the variable suddenDeath.
     * 
     * @return
     *      Returns the value of the variable suddenDeath.
     */
    public boolean getSuddenDeath() {
        return suddenDeath;
    }
    /**
     * Setter method of the variable suddenDeath.
     * 
     * @param suddenDeath
     *      The new value of the variable suddenDeath.
     */
    public void setSuddenDeath(boolean suddenDeath) {
        this.suddenDeath = suddenDeath;
    }
    
    /**
     * Getter method of the variable suddenDeathHeight.
     * 
     * @return
     *      Returns the value of the variable suddenDeathHeight.
     */
    public int getSuddenDeathHeight() {
        return suddenDeathHeight;
    }
    /**
     * Setter method of the variable suddenDeathHeight.
     * 
     * @param suddenDeathHeight
     *      The new value of the variable suddenDeathHeight.
     */
    public void setSuddenDeathHeight(int suddenDeathHeight) {
        this.suddenDeathHeight = suddenDeathHeight;
    }
    
    /**
     * Getter method of the variable weaponPackage.
     * 
     * @return
     *      Returns the reference of the current used weapon-package.
     */
    public Weapon_Package getWeaponPackage() {
        return weaponPackage;
    }
    /**
     * Setter method of the variable weaponPackage.
     * 
     * @param weapons
     *      The weapon-package that is set (using the copy constructor of the class Weapon_Package).
     */
    public void setWeaponPackage(Weapon_Package weapons) {
        weaponPackage = new Weapon_Package(weapons);
    }
    
    /**
     * Increment the number of kills in this round.
     * 
     * @param number
     *      Increments this number onto the current number of kills in this round.
     */
    public void setKillNumber(int number) {
        killsInThisRound += number;
    }
    
    /**
     * Removes all aim displays that exist in the world.
     */
    public void removeAimDisplays() {
        removeObjects(getObjects(AimDisplay.class));
    }
    
    /**
     * Removes all objects that are existing in the world.
     */
    public void removeAllObjects() {
        removeObjects(getObjects(null));
    }
    
    /**
     * Removes all objects that are existing in the world but the actor given as parameter.
     * 
     * @param actor
     *      The one actor that is not removed.
     */
    public void removeAllObjectsBut(Actor actor) {
        List<Actor> actorsInWorld = getObjects(null);
        for (Actor removedActor : actorsInWorld) {
            if (!removedActor.equals(actor)) {
                removeObject(removedActor);
            }
        }
    }
}
